module check_energy

implicit none
real(8) sumtke

contains

subroutine sumenergy(flag,title)
use vars
use params, only: dodebug
integer flag
character*(*) title
real(8) sumtke1
integer k,j
if(.not.dodebug) return
if(flag.eq.1) then
  sumtke = 0.
  do k=1,nzm
   do j=1,ny
     sumtke = sumtke -sum(dudt(1:nx,j,k,na)*u(1:nx,j,k))*mu(j)*rho(k)*adz(k)
     sumtke = sumtke -sum(dvdt(1:nx,j,k,na)*v(1:nx,j,k))*muv(j)*rho(k)*adz(k)
     sumtke = sumtke -sum(dwdt(1:nx,j,k,na)*w(1:nx,j,k))*mu(j)*rhow(k)*adzw(k)
   end do
  end do
end if
if(flag.eq.-1) then
  do k=1,nzm
   do j=1,ny
     sumtke = sumtke +sum(dudt(1:nx,j,k,na)*u(1:nx,j,k))*mu(j)*rho(k)*adz(k)
     sumtke = sumtke +sum(dvdt(1:nx,j,k,na)*v(1:nx,j,k))*muv(j)*rho(k)*adz(k)
     sumtke = sumtke +sum(dwdt(1:nx,j,k,na)*w(1:nx,j,k))*mu(j)*rhow(k)*adzw(k)
   end do
  end do
  if(dompi) then
    call task_sum_real8(sumtke,sumtke1,1)    
    sumtke = sumtke1
  end if
  if(masterproc) print*,'change of KE in ',title,':',sumtke
end if
end subroutine sumenergy

end module check_energy
