
subroutine coriolis

use vars
use params, only:  dowallx,dowally
use check_energy

implicit none
	
integer i,j,k
	
if(RUN3D) then

call sumenergy(1,'coriolis')

do k=1,nzm
 do j=1,ny
  do i=1,nx
    dudt(i,j,k,na)=dudt(i,j,k,na) + 0.25* &
      (fcory(j)+u(i,j,k)*tanr(j))*(v(i,j,k)+v(i,j+1,k)+v(i-1,j,k)+v(i-1,j+1,k)-4.*vg0(k))
    dvdt(i,j,k,na)=dvdt(i,j,k,na) - 0.25*imuv(j)* &
      ((fcory(j)+u(i,j,k)*tanr(j))*mu(j)*(u(i,j,k)-ug0(k)) + &
       (fcory(j)+u(i+1,j,k)*tanr(j))*mu(j)*(u(i+1,j,k)-ug0(k)) + &
       (fcory(j-1)+u(i,j-1,k)*tanr(j-1))*mu(j-1)*(u(i,j-1,k)-ug0(k)) + &
       (fcory(j-1)+u(i+1,j-1,k)*tanr(j-1))*mu(j-1)*(u(i+1,j-1,k)-ug0(k))) 
  end do ! i
 end do ! j
end do ! k
if(dowallx.and.mod(rank,nsubdomains_x).eq.0) then
    do k=1,nzm
      dudt(1,:,k,na) = 0.
    end do
end if
if(dowally.and.RUN3D.and.rank.lt.nsubdomains_x) then
    do k=1,nzm
      dvdt(:,1,k,na) = 0.
    end do
end if

call sumenergy(-1,'coriolis')

else

do k=1,nzm
 do j=1,ny
  do i=1,nx
   dudt(i,j,k,na)=dudt(i,j,k,na)+fcory(j)*(v(i,j,k)-vg0(k))
   dvdt(i,j,k,na)=dvdt(i,j,k,na)-fcory(j)*(u(i,j,k)-ug0(k))
  end do ! i
 end do ! i
end do ! k

endif
	
!bloss: accumulate coriolis accelerations for statistics
if(dostatis) then

   utendcor(:) = 0.
   vtendcor(:) = 0.

   if(RUN3D) then

      do k=1,nzm
         do j=1,ny
            do i=1,nx
               utendcor(k)=utendcor(k)+fcory(j)*(v(i,j,k)-vg0(k))
               vtendcor(k)=vtendcor(k)-fcory(j)*mu(j)*imuv(j)*(u(i,j,k)-ug0(k))
            end do ! i
         end do ! j
      end do ! k

   else


      do k=1,nzm
         do j=1,ny
            do i=1,nx
               utendcor(k)=utendcor(k)+fcory(j)*(v(i,j,k)-vg0(k))
               vtendcor(k)=vtendcor(k)-fcory(j)*(u(i,j,k)-ug0(k))
            end do ! i
         end do ! i
      end do ! k

   endif !if(RUN3D)

end if !if(dostatis)

end subroutine coriolis

