subroutine crm_init

!  Initialize CRM

use vars
use hbuffer
use microphysics
use sgs
use tracers
use movies, only: init_movies
implicit none

call t_startf ('initialize')

call init()     ! initialize some statistics arrays
call setparm()! set all parameters and constants

!------------------------------------------------------------------
! Initialize or restart from the save-dataset:

if(nrestart.eq.0) then
   day=day0 
   call setsurface() ! set surface mask, sst, terrain, SLM, etc
   call setgrid() ! initialize vertical grid structure and terrain arrays
   call setdata() ! initialize all variables
elseif(nrestart.eq.1) then
   call read_all()
   call setsurface()
   call setgrid() 
   call diagnose()
   call sgs_init()
   call micro_init()  !initialize microphysics
elseif(nrestart.eq.2) then  ! branch run
   if(dogrestart) then
     call read_allg()
     call setsurface()
   else
     call read_all()
   end if
   call setgrid() 
   call diagnose()
   call setparm() ! overwrite the parameters
   call setperturb()
   call sgs_init()
   call micro_init()  !initialize microphysics
   nstep = 0
   day0 = day
else
   print *,'Error: confused by value of NRESTART'
   call task_abort() 
endif

call init_movies()
call stat_2Dinit()
call tracers_init() ! initialize tracers
call setforcing()
if(masterproc) call printout()
!------------------------------------------------------------------
!  Initialize statistics buffer:

call hbuf_init()

!------------------------------------------------------------------
total_water_before = total_water()
total_water_after = total_water()
nstatsteps = -1
call stepout()

nstatis = nstat/nstatfrq
nstat = nstatis * nstatfrq
nstatsteps = 0
call t_stopf ('initialize')

end 
