subroutine diagnose
	
! Diagnose some useful stuff

use vars
use params
use sgs, only: sgs_diagnose
use terrain
implicit none
	
integer i,j,k,kb,kc,k200,k500,k850
real(8) coef, coef1, buffer(nzm,8), buffer1(nzm,8)
real(8) u0d(nzm),v0d(nzm),tabs0d(nzm),q0d(nzm),qn0d(nzm),qp0d(nzm)
real omn, omp, tmp_lwp(nx,ny), coef2, coefsum

call t_startf ('diagnose')

k200 = nzm
	
tmp_lwp = 0.
coefsum = 0.
do k=1,nzm
 coefsum=coefsum + rho(k)*dz*adz(k)
end do
if(nstep.eq.0) coefsum=1. ! let first call from setdata to compute mean profile
do k=1,nzm
  u0d(k)=0.
  v0d(k)=0.
  t01(k) = tabs0(k)
  q01(k) = q0(k)
  t0(k)=0.
  tabs0d(k)=0.
  q0d(k)=0.
  qn0d(k)=0.
  qp0d(k)=0.
  p0(k)=0.
  kc=min(nzm,k+1)
  kb=max(1,k-1)
  if(pres(kc).le.200..and.pres(kb).gt.200.) k200=k
  coef1 = rho(k)*dz*adz(k)
  coef2 = coef1/coefsum
  do j=1,ny
    do i=1,nx
     tabs(i,j,k) = t(i,j,k)-gamaz(k)+ fac_cond * (qcl(i,j,k)+qpl(i,j,k)) +&
	                              fac_sub *(qci(i,j,k) + qpi(i,j,k))
     u0d(k)=u0d(k)+u(i,j,k)*wgtu(j,k)*terrau(i,j,k)
     v0d(k)=v0d(k)+v(i,j,k)*wgtv(j,k)*terrav(i,j,k)
     p0(k)=p0(k)+p(i,j,k)*wgt(j,k)*terra(i,j,k)
     t0(k)=t0(k)+t(i,j,k)*wgt(j,k)*terra(i,j,k)
     tabs0d(k)=tabs0d(k)+tabs(i,j,k)*wgt(j,k)*terra(i,j,k)
     q0d(k)=q0d(k)+(qv(i,j,k)+qcl(i,j,k)+qci(i,j,k))*wgt(j,k)*terra(i,j,k)
     qn0d(k) = qn0d(k) + (qcl(i,j,k) + qci(i,j,k))*wgt(j,k)*terra(i,j,k)
     qp0d(k) = qp0d(k) + (qpl(i,j,k) + qpi(i,j,k))*wgt(j,k)*terra(i,j,k)

     pw_xy(i,j) = pw_xy(i,j)+qv(i,j,k)*terra(i,j,k)*coef1*dtfactor
     ta_xy(i,j) = ta_xy(i,j)+tabs(i,j,k)*terra(i,j,k)*coef2*dtfactor
     cw_xy(i,j) = cw_xy(i,j)+qcl(i,j,k)*terra(i,j,k)*coef1*dtfactor
     iw_xy(i,j) = iw_xy(i,j)+qci(i,j,k)*terra(i,j,k)*coef1*dtfactor
     tmp_lwp(i,j) = tmp_lwp(i,j) + (qcl(i,j,k)+qci(i,j,k))*terra(i,j,k)*coef1

    end do
  end do

end do ! k

where(tmp_lwp(:,:).gt.0.01) cld_xy(:,:) = cld_xy(:,:) + dtfactor

k500 = nzm
do k = 1,nzm
   kc=min(nzm,k+1)
   if((pres(kc).le.500.).and.(pres(k).gt.500.)) then
      if ((500.-pres(kc)).lt.(pres(k)-500.))then
         k500=kc
      else
         k500=k
      end if
   end if
end do


do j=1,ny
 do i=1,nx
  usfc_xy(i,j) = usfc_xy(i,j) + u(i,j,k_terrau(i,j))*dtfactor
  vsfc_xy(i,j) = vsfc_xy(i,j) + v(i,j,k_terrav(i,j))*dtfactor
  tsfc_xy(i,j) = tsfc_xy(i,j) + tabs(i,j,k_terrau(i,j))*dtfactor
  qsfc_xy(i,j) = qsfc_xy(i,j) + qv(i,j,k_terrau(i,j))*dtfactor
  u200_xy(i,j) = u200_xy(i,j) + u(i,j,k200)*dtfactor *terrau(i,j,k200) 
  v200_xy(i,j) = v200_xy(i,j) + v(i,j,k200)*dtfactor *terrav(i,j,k200) 
  w500_xy(i,j) = w500_xy(i,j) + w(i,j,k500)*dtfactor *terraw(i,j,k500)
 end do
end do

if(dompi) then
  do k=1,nzm
    buffer(k,1) = u0d(k)
    buffer(k,2) = v0d(k)
    buffer(k,3) = t0(k)
    buffer(k,4) = q0d(k)
    buffer(k,5) = p0(k)
    buffer(k,6) = tabs0d(k)
    buffer(k,7) = qn0d(k)
    buffer(k,8) = qp0d(k)
  end do
  call task_sum_real8(buffer,buffer1,nzm*8)
  do k=1,nzm
    u0d(k)=buffer1(k,1)
    v0d(k)=buffer1(k,2)
    t0(k)=buffer1(k,3)
    q0d(k)=buffer1(k,4)
    p0(k)=buffer1(k,5)
    tabs0d(k)=buffer1(k,6)
    qn0d(k)=buffer1(k,7)
    qp0d(k)=buffer1(k,8)
  end do
end if

coef = 1./dble(nsubdomains*nx*ny)
do k=1,nzm
    u0(k)=u0d(k)*coef
    v0(k)=v0d(k)*coef
    t0(k)=t0(k)*coef
    q0(k)=q0d(k)*coef
    p0(k)=p0(k)*coef
    tabs0(k)=tabs0d(k)*coef
    qn0(k)=qn0d(k)*coef
    qp0(k)=qp0d(k)*coef
end do

qv0 = q0 - qn0

!=====================================================
! UW ADDITIONS

! FIND VERTICAL INDICES OF 850MB, COMPUTE SWVP
k850 = 1
do k = 1,nzm
   if(pres(k).le.850.) then
      k850 = k
      EXIT
   end if
end do

! ACCUMULATE AVERAGES OF TWO-DIMENSIONAL STATISTICS
do j=1,ny
 do i=1,nx
  psfc_xy(i,j) = psfc_xy(i,j) + (100.*pres(1) + p(i,j,1))*dtfactor*terra(i,j,1)  

  ! 850 mbar horizontal winds
  u850_xy(i,j) = u850_xy(i,j) + u(i,j,k850)*dtfactor*terrau(i,j,k850)  
  v850_xy(i,j) = v850_xy(i,j) + v(i,j,k850)*dtfactor*terrav(i,j,k850)  

 end do
end do

if(mod(nstep,nsave2D).eq.0.and.nstep.ge.nsave2Dstart.and.nstep.le.nsave2Dend) then
do k=1,nzm
  coef1 = rho(k)*dz*adz(k)*dtfactor
  do j=1,ny
    do i=1,nx

     ! Saturated water vapor path with respect to water. Can be used
     ! with water vapor path (= pw) to compute column-average
     ! relative humidity.   
     swvp_xy(i,j) = swvp_xy(i,j)+qsatw(tabs(i,j,k),pres(k))*coef1*terra(i,j,k)
    end do
  end do
end do ! k

! COMPUTE CLOUD/ECHO HEIGHTS AS WELL AS CLOUD TOP TEMPERATURE
! WHERE CLOUD TOP IS DEFINED AS THE HIGHEST MODEL LEVEL WITH A
! CONDENSATE PATH OF 0.01 kg/m2 ABOVE.  ECHO TOP IS THE HIGHEST LEVEL
! WHERE THE PRECIPITATE MIXING RATIO > 0.001 G/KG.

! initially, zero out heights and set cloudtoptemp to SST
  cloudtopheight = 0.
  cloudtoptemp = sstxy(1:nx,1:ny) + t00
  tmp_lwp = 0.
  cloudcover = 0.
  do k = nzm,1,-1
    do j = 1,ny
      do i = 1,nx
        if(k.lt.k_terra(i,j)) cycle
        ! FIND CLOUD TOP HEIGHT
        if(tmp_lwp(i,j).lt.0.01) then
             tmp_lwp(i,j) = tmp_lwp(i,j) + (qcl(i,j,k)+qci(i,j,k))*rho(k)*dz*adz(k)
              if (tmp_lwp(i,j).ge.0.01) then
              cloudtopheight(i,j) = z(k)
              cloudtoptemp(i,j) = tabs(i,j,k)*terra(i,j,k)
              tmp_lwp(i,j) = 1. ! done
              cloudcover(i,j) = 1.
              cycle
           end if
        end if
      end do
    end do
  end do
  echotopheight = 0.
  do k = nzm,1,-1
    do j = 1,ny
      do i = 1,nx
        ! FIND ECHO TOP HEIGHT
        if(k.lt.k_terra(i,j)) cycle
        if ((qpl(i,j,k)+qpi(i,j,k)).gt.1.e-6) then
             echotopheight(i,j) = z(k)
             cycle
        end if
      end do
    end do
  end do
end if

! END UW ADDITIONS
!=====================================================

!-----------------
! compute some sgs diagnostics:

call sgs_diagnose()

call t_stopf ('diagnose')

end subroutine diagnose
