
subroutine diffuse_mom3D
	
!        momentum tendency due to SGS diffusion

use vars
use sgs, only: tk, grdf_x, grdf_y, grdf_z
use params, only: docolumn, dowallx, dowally, dodebug
use terrain
use check_energy
implicit none

real rdx2,rdy2,rdz2,rdz,rdx2u,rdx2v,rdx2w,rdy2u,rdy2v,rdy2w,rdz25

integer i,j,k,ic,ib,jb,jc,kc,kcu
real tkx, tky, tkz, rhoi, iadzw, iadz
real fu(0:nx,0:ny,nz),fv(0:nx,0:ny,nz),fw(0:nx,0:ny,nz)

!-----------------------------------------

rdx2=1./(dx*dx)
rdy2=1./(dy*dy)

goto 1111

call sumenergy(1,'diff_mom3D')

do k=1,nzm
  kc=k+1
  kcu=min(kc,nzm)
  do j=1,ny
   jb=j-1
   rdx2u=rdx2*imu(j)*grdf_x(j,k)
   rdx2v=rdx2*imuv(j) * grdf_x(j,k)
   rdx2w=rdx2*imu(j) * grdf_x(j,k)
   do i=0,nx
    ic=i+1
    tkx=rdx2u*tk(i,j,k)*terra(i,j,k)
    fu(i,j,k)=-tkx*(u(ic,j,k)-u(i,j,k))*min(terrau(ic,j,k),terrau(i,j,k))
    tkx=rdx2v*(tk(i,j,k)*terra(i,j,k)+tk(i,jb,k)*terra(i,jb,k) &
               +tk(ic,j,k)*terra(ic,j,k)+tk(ic,jb,k)*terra(ic,jb,k)) &
              /(terra(i,j,k)+terra(i,jb,k)+terra(ic,j,k)+terra(ic,jb,k)+1.e-10)
    fv(i,j,k)=-tkx*((v(ic,j,k)-v(i,j,k))*min(terrav(ic,j,k),terrav(i,j,k))) 
    tkx=rdx2w*(tk(i,j,k)*terra(i,j,k)+tk(ic,j,k)*terra(ic,j,k) &
               +tk(i,j,kcu)*terra(i,j,kcu)+tk(ic,j,kcu)*terra(ic,j,kcu)) &
              /(terra(i,j,k)+terra(ic,j,k)+terra(i,j,kcu)+terra(ic,j,kcu)+1.e-10) 
    fw(i,j,k)=-tkx*((w(ic,j,kc)-w(i,j,kc))*min(terraw(ic,j,kc),terraw(i,j,kc)))
   end do 
   do i=1,nx
    ib=i-1
    dudt(i,j,k,na)=dudt(i,j,k,na)-imu(j)*(fu(i,j,k)-fu(ib,j,k))
    dvdt(i,j,k,na)=dvdt(i,j,k,na)-imuv(j)*(fv(i,j,k)-fv(ib,j,k))
    dwdt(i,j,kc,na)=dwdt(i,j,kc,na)-imu(j)*(fw(i,j,k)-fw(ib,j,k))
   end do  
  end do 
end do

if(dodebug) call debug('after diff in x')

do k=1,nzm
  kc=k+1
  kcu=min(kc,nzm)
  do j=0,ny
   jc=j+1
   rdy2u=rdy2*muv(jc)  * grdf_y(k)
   rdy2v=rdy2*mu(j) * grdf_y(k)
   rdy2w=rdy2*muv(jc) * grdf_y(k)
   do i=1,nx
    ib=i-1
    tky=rdy2u*(tk(i,j,k)*terra(i,j,k)+tk(ib,j,k)*terra(ib,j,k) &
               +tk(i,jc,k)*terra(i,jc,k)+tk(ib,jc,k)*terra(ib,jc,k)) &
             /(terra(i,j,k)+terra(ib,j,k)+terra(i,jc,k)+terra(ib,jc,k)+1.e-10)
    fu(i,j,k)=-tky*((u(i,jc,k)-u(i,j,k))*min(terrau(i,jc,k),terrau(i,j,k)))
    tky=rdy2v*tk(i,j,k)*terra(i,j,k)
    fv(i,j,k)=-tky*(v(i,jc,k)-v(i,j,k))*min(terrav(i,jc,k),terrav(i,j,k))
    tky=rdy2w*(tk(i,j,k)*terra(i,j,k)+tk(i,jc,k)*terra(i,jc,k) &
               +tk(i,j,kcu)*terra(i,j,kcu)+tk(i,jc,kcu)*terra(i,jc,kcu)) &
             /(terra(i,j,k)+terra(i,jc,k)+terra(i,j,kcu)+terra(i,jc,kcu)+1.e-10)
    fw(i,j,k)=-tky*((w(i,jc,kc)-w(i,j,kc))*min(terraw(i,jc,kc),terraw(i,j,kc)))
   end do 
  end do 
  do j=1,ny
    jb=j-1
    do i=1,nx    
     dudt(i,j,k,na)=dudt(i,j,k,na)-imu(j)*(fu(i,j,k)-fu(i,jb,k))
     dvdt(i,j,k,na)=dvdt(i,j,k,na)-imuv(j)*(fv(i,j,k)-fv(i,jb,k))
     dwdt(i,j,kc,na)=dwdt(i,j,kc,na)-imu(j)*(fw(i,j,k)-fw(i,jb,k))
   end do 
  end do 
end do 

1111 z=z

if(dodebug) call debug('after diff in y')
!-------------------------
rdz=1./dz

uwsb(:) = 0.
vwsb(:) = 0.

do k=1,nzm-1
 kc=k+1
 uwsb(kc)=0.
 vwsb(kc)=0.
 iadz = 1./adz(k)
 iadzw= 1./adzw(kc)
 rdz2 = rdz*rdz * grdf_z(k)
 rdz25 = rdz2
  do j=1,ny
   jb=j-1
   do i=1,nx
    ib=i-1
    tkz=rdz2*tk(i,j,k)*terra(i,j,k)
    fw(i,j,kc)=-tkz*(w(i,j,kc)-w(i,j,k))*min(terraw(i,j,kc),terraw(i,j,k))*rho(k)*iadz
    tkz=rdz25*(tk(i,j,k)*terra(i,j,k)+tk(ib,j,k)*terra(ib,j,k) &
              +tk(i,j,kc)*terra(i,j,kc)+tk(ib,j,kc)*terra(ib,j,kc)) &
             /(terra(i,j,k)+terra(ib,j,k)+terra(i,j,kc)+terra(ib,j,kc)+1.e-10)
    fu(i,j,kc)=-tkz*( (u(i,j,kc)-u(i,j,k))*min(terrau(i,j,kc),terrau(i,j,k))*iadzw)*rhow(kc) 
    tkz=rdz25*(tk(i,j,k)*terra(i,j,k)+tk(i,jb,k)*terra(i,jb,k) &
              +tk(i,j,kc)*terra(i,j,kc)+tk(i,jb,kc)*terra(i,jb,kc)) &
             /(terra(i,j,k)+terra(i,jb,k)+terra(i,j,kc)+terra(i,jb,kc)+1.e-10)
    fv(i,j,kc)=-tkz*( (v(i,j,kc)-v(i,j,k))*min(terrav(i,j,kc),terrav(i,j,k))*iadzw)*rhow(kc)
    uwsb(kc)=uwsb(kc)+fu(i,j,kc)
    vwsb(kc)=vwsb(kc)+fv(i,j,kc)
  end do 
 end do
end do

do j=1,ny
 do i=1,nx
   fw(i,j,k_terra(i,j)) = 0.
   fu(i,j,k_terrau(i,j))=fluxbu(i,j) * rdz * rhow(k_terrau(i,j))
   fv(i,j,k_terrav(i,j))=fluxbv(i,j) * rdz * rhow(k_terrav(i,j))
   tkz=rdz2*grdf_z(nzm)*tk(i,j,nzm)
   fw(i,j,nz)=-2.*tkz*(w(i,j,nz)-w(i,j,nzm))/adz(nzm)*rho(nzm)
   fu(i,j,nz)=fluxtu(i,j) * rdz * rhow(nz)
   fv(i,j,nz)=fluxtv(i,j) * rdz * rhow(nz)
   uwsb(k_terrau(i,j)) = uwsb(k_terrau(i,j)) + fu(i,j,k_terrau(i,j))
   vwsb(k_terrav(i,j)) = vwsb(k_terrav(i,j)) + fv(i,j,k_terrav(i,j))
  end do
 end do
 
 do k=1,nzm
  kc=k+1
  rhoi = 1./(rho(k)*adz(k))
  do j=1,ny
   do i=1,nx
    dudt(i,j,k,na)=dudt(i,j,k,na)-(fu(i,j,kc)-fu(i,j,k))*rhoi
    dvdt(i,j,k,na)=dvdt(i,j,k,na)-(fv(i,j,kc)-fv(i,j,k))*rhoi
   end do
  end do
 end do ! k

 do k=2,nzm
  rhoi = 1./(rhow(k)*adzw(k))
  do j=1,ny
   do i=1,nx 
    dwdt(i,j,k,na)=dwdt(i,j,k,na)-(fw(i,j,k+1)-fw(i,j,k))*rhoi
   end do
  end do
 end do ! k

call sumenergy(-1,'diff_mom3D')

if(dodebug) call debug('after diff in z')
end subroutine diffuse_mom3D
