subroutine nudging()
	
use vars
use params
use microphysics, only: micro_field, index_water_vapor, nmicro_fields
use sgs, only: sgs_field
implicit none

real coef, coef1, tau, xxx, yyy
integer i,j,k,it,jt
	
call t_startf ('nudging')

tnudge = 0.
qnudge = 0.
unudge = 0.
vnudge = 0.

coef = 1./tauls

if(donudging_uv) then
    do k=1,nzm
      if(z(k).ge.nudging_uv_z1.and.z(k).le.nudging_uv_z2) then
        unudge(k)=unudge(k) - (u0(k)-ug0(k))*coef
        vnudge(k)=vnudge(k) - (v0(k)-vg0(k))*coef
        do j=1,ny
          do i=1,nx
             dudt(i,j,k,na)=dudt(i,j,k,na)-(u0(k)-ug0(k))*coef
             dvdt(i,j,k,na)=dvdt(i,j,k,na)-(v0(k)-vg0(k))*coef
          end do
        end do
      end if
    end do
endif

coef = 1./tautqls

if(donudging_tq.or.donudging_t) then
    coef1 = dtn / tautqls
    do k=1,nzm
      if(z(k).ge.nudging_t_z1.and.z(k).le.nudging_t_z2) then
        tnudge(k)=tnudge(k) -(t0(k)-tg0(k)-gamaz(k))*coef
        do j=1,ny
          do i=1,nx
             t(i,j,k)=t(i,j,k)-(t0(k)-tg0(k)-gamaz(k))*coef1
          end do
        end do
      end if
    end do
endif

if(donudging_tq.or.donudging_q) then
    coef1 = dtn / tautqls
    do k=1,nzm
      if(z(k).ge.nudging_q_z1.and.z(k).le.nudging_q_z2) then
        qnudge(k)=qnudge(k) -(q0(k)-qg0(k))*coef
        do j=1,ny
          do i=1,nx
             micro_field(i,j,k,index_water_vapor)=micro_field(i,j,k,index_water_vapor)-(q0(k)-qg0(k))*coef1
          end do
        end do
      end if
    end do
endif

if(dobufferzone) then
    call task_rank_to_index(rank,it,jt)
    do k=1,nzm
       tau = 0.1*bufferzone*nx_gl*dx/(abs(u0(k))+1.)
       coef = 1./tau
       coef1 = dtn / tau
       do j=1,ny
           do i=1,nx
             xxx = dx*(i+it-1)
             if(xxx.le.bufferzone/2.*nx_gl*dx.or.xxx.ge.(1.-bufferzone/2.)*nx_gl*dx) then
               dudt(i,j,k,na)=dudt(i,j,k,na)-(u(i,j,k)-ug0(k))*coef
               dvdt(i,j,k,na)=dvdt(i,j,k,na)-(v(i,j,k)-vg0(k))*coef
               dwdt(i,j,k,na)=dwdt(i,j,k,na)-w(i,j,k)*coef
               t(i,j,k)=t(i,j,k)-(t(i,j,k)-tg0(k)-gamaz(k))*coef1
               micro_field(i,j,k,index_water_vapor)= &
                      micro_field(i,j,k,index_water_vapor)- &
                     (micro_field(i,j,k,index_water_vapor)-qg0(k))*coef1
               micro_field(i,j,k,1:index_water_vapor-1)= &
                      micro_field(i,j,k,1:index_water_vapor-1)- &
                      micro_field(i,j,k,1:index_water_vapor-1)*coef1
               micro_field(i,j,k,index_water_vapor+1:nmicro_fields)= &
                      micro_field(i,j,k,index_water_vapor+1:nmicro_fields)- &
                      micro_field(i,j,k,index_water_vapor+1:nmicro_fields)*coef1
               sgs_field(i,j,k,:)=sgs_field(i,j,k,:)- sgs_field(i,j,k,:)*coef1
             end if
           end do
       end do
    end do
    if(RUN3D) then
      do k=1,nzm
         tau = 0.1*bufferzone*ny_gl*dy/(abs(v0(k))+1.)
         coef = 1./tau
         coef1 = dtn / tau
         do j=1,ny
           yyy = dy*(j+jt-1)
           if(yyy.le.bufferzone/2.*ny_gl*dy.or.yyy.ge.(1.-bufferzone/2.)*ny_gl*dy) then
             do i=1,nx
                 dudt(i,j,k,na)=dudt(i,j,k,na)-(u(i,j,k)-ug0(k))*coef
                 dvdt(i,j,k,na)=dvdt(i,j,k,na)-(v(i,j,k)-vg0(k))*coef
                 dwdt(i,j,k,na)=dwdt(i,j,k,na)-w(i,j,k)*coef
                 t(i,j,k)=t(i,j,k)-(t(i,j,k)-tg0(k)-gamaz(k))*coef1
                 micro_field(i,j,k,index_water_vapor)= &
                      micro_field(i,j,k,index_water_vapor)- &
                     (micro_field(i,j,k,index_water_vapor)-qg0(k))*coef1
                 micro_field(i,j,k,1:index_water_vapor-1)= &
                      micro_field(i,j,k,1:index_water_vapor-1)- &
                      micro_field(i,j,k,1:index_water_vapor-1)*coef1
                 micro_field(i,j,k,index_water_vapor+1:nmicro_fields)= &
                      micro_field(i,j,k,index_water_vapor+1:nmicro_fields)- &
                      micro_field(i,j,k,index_water_vapor+1:nmicro_fields)*coef1
                 sgs_field(i,j,k,:)=sgs_field(i,j,k,:)- sgs_field(i,j,k,:)*coef1
             end do
           end if
         end do
      end do
    end if
endif


call t_stopf('nudging')

end subroutine nudging
