
subroutine press_rhs

!       right-hand-side of the Poisson equation for pressure

use vars
use terrain, only: terrau, terrav, terraw
use params, only: dowallx, dowally, doterrain

implicit none
         
	
real *8 dta,rdx,rdy,rdz,btat,ctat,rup,rdn
integer i,j,k,ic,jc,kc

if(dowallx.and.mod(rank,nsubdomains_x).eq.0) then

    do k=1,nzm
     do j=1,ny
      dudt(1,j,k,na) = 0.
     end do
    end do	

end if

if(dowally.and.RUN3D.and.rank.lt.nsubdomains_x) then

    do k=1,nzm
     do i=1,nx
      dvdt(i,1,k,na) = 0.
     end do
    end do	

end if


if(dompi) then
   call task_bound_duvdt()
else
   call bound_duvdt()	   
endif

dta=1./dt3(na)/at
btat=bt/at
ctat=ct/at

if(RUN3D) then

do k=1,nzm
 kc=k+1 
 rdz=1./(adz(k)*dz)
 rup = rhow(kc)/rho(k)*rdz
 rdn = rhow(k)/rho(k)*rdz
 do j=1,ny
  jc=j+1 
  rdx=imu(j)/dx
  rdy=imu(j)/dy
  do i=1,nx
   ic=i+1
   p(i,j,k)=(rdx*(u(ic,j,k)*terrau(ic,j,k)-u(i,j,k)*terrau(i,j,k))+ &
             rdy*(muv(jc)*v(i,jc,k)*terrav(i,jc,k)-muv(j)*v(i,j,k)*terrav(i,j,k))+ &
             (w(i,j,kc)*terraw(i,j,kc)*rup-w(i,j,k)*terraw(i,j,k)*rdn) )*dta+ &
            (rdx*(dudt(ic,j,k,na)-dudt(i,j,k,na))+ &
             rdy*(muv(jc)*dvdt(i,jc,k,na)-muv(j)*dvdt(i,j,k,na))+ &
             (dwdt(i,j,kc,na)*rup-dwdt(i,j,k,na)*rdn) ) + &
       btat*(rdx*(dudt(ic,j,k,nb)-dudt(i,j,k,nb))+ &
             rdy*(muv(jc)*dvdt(i,jc,k,nb)-muv(j)*dvdt(i,j,k,nb))+ &
             (dwdt(i,j,kc,nb)*rup-dwdt(i,j,k,nb)*rdn) ) + &
       ctat*(rdx*(dudt(ic,j,k,nc)-dudt(i,j,k,nc))+ &
             rdy*(muv(jc)*dvdt(i,jc,k,nc)-muv(j)*dvdt(i,j,k,nc))+ &
             (dwdt(i,j,kc,nc)*rup-dwdt(i,j,k,nc)*rdn) )
  end do
 end do
end do

else

j=1

rdx = 1./dx
do k=1,nzm
 kc=k+1 
 rdz=1./(adz(k)*dz)
 rup = rhow(kc)/rho(k)*rdz
 rdn = rhow(k)/rho(k)*rdz
 do i=1,nx
  ic=i+1
  p(i,j,k)=(rdx*(u(ic,j,k)*terrau(ic,j,k)-u(i,j,k)*terrau(i,j,k))+ &
                (w(i,j,kc)*terraw(i,j,kc)*rup-w(i,j,k)*terraw(i,j,k)*rdn) )*dta + &
                (rdx*(dudt(ic,j,k,na)-dudt(i,j,k,na))+ &
                (dwdt(i,j,kc,na)*rup-dwdt(i,j,k,na)*rdn) ) + &
           btat*(rdx*(dudt(ic,j,k,nb)-dudt(i,j,k,nb))+ &
                 (dwdt(i,j,kc,nb)*rup-dwdt(i,j,k,nb)*rdn) ) + &
           ctat*(rdx*(dudt(ic,j,k,nc)-dudt(i,j,k,nc))+ &
                 (dwdt(i,j,kc,nc)*rup-dwdt(i,j,k,nc)*rdn) )
 end do
end do


endif

call task_barrier()

end subroutine press_rhs
