        subroutine write_all()

        use vars
        implicit none
        character *4 rankchar
        character *256 filename
        integer irank

        call t_startf ('restart_out')

        if(masterproc) then
         print*,'Writing restart file ...'
         filename = './RESTART/'//trim(case)//'_'//trim(caseid)//'_misc_restart.bin'
         open(66,file=trim(filename), status='unknown',form='unformatted')
        end if


        if(restart_sep) then

          write(rankchar,'(i4)') rank

          filename = './RESTART/'//trim(case)//'_'//trim(caseid)//'_'//&
                rankchar(5-lenstr(rankchar):4)//'_restart.bin'


          open(65,file=trim(filename), status='unknown',form='unformatted')
          write(65) nsubdomains, nsubdomains_x, nsubdomains_y

          call write_statement(.false.)


        else
          write(rankchar,'(i4)') nsubdomains
          filename = './RESTART/'//trim(case)//'_'//trim(caseid)//'_'//&
                rankchar(5-lenstr(rankchar):4)//'_restart.bin'

          do irank=0,nsubdomains-1

             call task_barrier()

             if(irank.eq.rank) then

               if(masterproc) then
      
                open(65,file=trim(filename), status='unknown',form='unformatted')
                write(65) nsubdomains, nsubdomains_x, nsubdomains_y

               else

                open(65,file=trim(filename), status='unknown',form='unformatted',&
                   position='append')

               end if

               call write_statement(.false.)

             end if
          end do

        end if ! restart_sep

        call task_barrier()

        call t_stopf ('restart_out')

        return
        end
 
 
 
 
     
        subroutine read_all()

        use vars
        implicit none
        character *4 rankchar
        character *256 filename
        integer irank, ii

        if(masterproc) print*,'Reading restart file ...'

        if(nrestart.ne.2) then
          filename = './RESTART/'//trim(case)//'_'//trim(caseid)//'_misc_restart.bin'
        else
          filename = './RESTART/'//trim(case_restart)//'_'//trim(caseid_restart)//'_misc_restart.bin'
        end if
        open(66,file=trim(filename), status='old',form='unformatted')


        if(restart_sep) then

           write(rankchar,'(i4)') rank

           if(nrestart.ne.2) then
             filename = './RESTART/'//trim(case)//'_'//trim(caseid)//'_'//&
                  rankchar(5-lenstr(rankchar):4)//'_restart.bin'
           else
             filename = './RESTART/'//trim(case_restart)//'_'//trim(caseid_restart)//'_'//&
                  rankchar(5-lenstr(rankchar):4)//'_restart.bin'
           end if


           open(65,file=trim(filename), status='old',form='unformatted')
           read(65)

           call read_statement(.false.)


        else

          write(rankchar,'(i4)') nsubdomains

          if(nrestart.ne.2) then
            filename='./RESTART/'//trim(case)//'_'//trim(caseid)//'_'//&
                  rankchar(5-lenstr(rankchar):4)//'_restart.bin'
          else
            filename='./RESTART/'//trim(case_restart)//'_'//trim(caseid_restart)//'_'//&
                  rankchar(5-lenstr(rankchar):4)//'_restart.bin'
          end if
          open(65,file=trim(filename), status='old',form='unformatted')

          do irank=0,nsubdomains-1

             call task_barrier()

             if(irank.eq.rank) then

               read (65)
 
               do ii=0,irank-1 ! skip records
                 read(65)
               end do

               call read_statement(.false.)

             end if

          end do

        end if ! restart_sep

        call task_barrier()

        dtfactor = -1.

       ! update the boundaries 
       ! (just in case when some parameterization initializes and needs boundary points)

        call boundaries(1)
        call boundaries(4)

        return
        end
 


        subroutine write_allg()

        use vars
        implicit none
        character *10 nstepchar
        character *256 filename

        call t_startf ('restart_out')

        if(masterproc) then
         print*,'Writing general restart file ...'
         write(nstepchar,'(i10)') nstep
         filename = './RESTART/'//trim(case)//'_'//trim(caseid)//'_'//&
                nstepchar(11-lenstr(nstepchar):10)//'_grestart.bin'
         open(65,file=trim(filename), status='unknown',form='unformatted')
        end if

        call write_statement(.true.)

        call task_barrier()
        call t_stopf ('restart_out')

        return
        end


        subroutine read_allg()

        use vars
        implicit none
        character *256 filename

        if(masterproc) print*,'Reading general restart file ...'
        filename = './RESTART/'//trim(case_restart)//'_'//trim(caseid_restart)//&
                              '_grestart.bin'
        open(65,file=trim(filename), status='old',form='unformatted')
        if(masterproc) print*,'restart file:',trim(filename)

        call read_statement(.true.)

        call task_barrier()

        call boundaries(1)
        call boundaries(4)

        return
        end


        subroutine write_statement(dogenrestart)

        use vars
        use microphysics, only: micro_field, nmicro_fields
        use sgs, only: sgs_field, nsgs_fields, sgs_field_diag, nsgs_fields_diag
        use tracers
        use params
        use movies, only: irecc
        use terrain
        use rad, only: swnsxy,lwnsxy
        implicit none
        logical, intent(in) ::  dogenrestart
        integer ntape, k

        if(.not.dogenrestart) then
          write(65)  rank, &
           u, v, w, t, p, pfy, qv, qcl, qci, qpl, qpi, dudt, dvdt, dwdt, &
           tracer, micro_field, sgs_field, sgs_field_diag, sstxy, precinst
          close(65)
          if(masterproc) write(66) dt,dx,dy
          ntape = 66
        else
         if(masterproc) write(65) nx_gl, ny_gl, nzm
         call restart_write_field3D (65,u(1:nx,1:ny,1:nzm),nzm)
         call restart_write_field3D (65,v(1:nx,1:ny,1:nzm),nzm)
         call restart_write_field3D (65,w(1:nx,1:ny,1:nz),nz)
         call restart_write_field3D (65,t(1:nx,1:ny,1:nzm),nzm)
         call restart_write_field3D (65,p(1:nx,1:ny,1:nzm),nzm)
         call restart_write_field3D (65,qv(1:nx,1:ny,1:nzm),nzm)
         call restart_write_field3D (65,qcl(1:nx,1:ny,1:nzm),nzm)
         call restart_write_field3D (65,qci(1:nx,1:ny,1:nzm),nzm)
         call restart_write_field3D (65,qpl(1:nx,1:ny,1:nzm),nzm)
         call restart_write_field3D (65,qpi(1:nx,1:ny,1:nzm),nzm)
         call restart_write_field3D (65,dudt(1:nx,1:ny,1:nzm,1:3),nzm*3)
         call restart_write_field3D (65,dvdt(1:nx,1:ny,1:nzm,1:3),nzm*3)
         call restart_write_field3D (65,dwdt(1:nx,1:ny,1:nz,1:3),nzm*3)
         call restart_write_field3D (65,tracer(1:nx,1:ny,1:nzm,1:ntracers),nzm*ntracers)
         call restart_write_field3D (65,micro_field(1:nx,1:ny,1:nzm,1:nmicro_fields), &
                                     nzm*nmicro_fields)
         call restart_write_field3D (65,sgs_field(1:nx,1:ny,1:nzm,1:nsgs_fields), &
                                     nzm*nsgs_fields)
         call restart_write_field3D (65,sgs_field_diag(1:nx,1:ny,1:nzm,1:nsgs_fields_diag), &
                                     nzm*nsgs_fields_diag)
         call restart_write_field3D (65,sstxy(1:nx,1:ny),1)
         call restart_write_field3D (65,precinst(1:nx,1:ny),1)
         ntape = 65
        end if
        if(masterproc) then
           write(ntape) version, &
            z, zi, adz, adzw, pres, prespot, presi, prespoti, rho, rhow,  &
            bet, nx, ny, nz, irecc, &
            at, bt, ct, dtn, dt3, time, dz, doconstdz, &
            day, day0, nstep, na, nb, nc, caseid, case, &
            dodamping, doupperbound, docloud, doprecip, doradhomo, dosfchomo,&
            dolongwave, doshortwave, dosgs, dosubsidence, dotracers,  dosmoke, &
            docoriolis, dosurface, dolargescale,doradforcing, dossthomo, &
            dosfcforcing, doradsimple, donudging_uv, donudging_tq, &
            dowallx, dowally, doperpetual, doseasons, &
            docup, docolumn, readterr, readlandmask, soil_wetness, dodynamicocean,  &
            ocean_type, delta_sst, depth_slab_ocean, Szero, deltaS, timesimpleocean, &
            pres0, ug, vg, fcor, fcorz, tabs_s, z0, n2ox, ch4x, cfc11x, cfc12x, &
            fluxt0, fluxq0, tau0, tauls, tautqls, timelargescale, epsv, &
            nudging_uv_z1, nudging_uv_z2, donudging_t, donudging_q, doisccp, domodis, domisr,  &
            dosimfilesout, dosolarconstant, solar_constant, zenith_angle, notracegases, &
            doSAMconditionals, dosatupdnconditionals, dodynamicland, dodynamicsoil, &
            nudging_t_z1, nudging_t_z2, nudging_q_z1, nudging_q_z2, &
            cem, les, ocean, land, sfc_flx_fxd, sfc_tau_fxd, readsst, &
            nrad, nxco2, latitude0, longitude0, dofplane, earth_factor, dodamping_w, &
            docoriolisz, doradlon, doradlat, doseawater, salt_factor, SLM, &
            doterrain, dobufferzone, bufferzone, doglobal, latwalls, dohyper, &
            sst_climo, tau_ocean, sst_mean, dosstclimo, dolatlon, reado3, &
            readlandmask, landmaskfile, readsst, sstfile, readterr, terrainfile, &
            ntracers, nmicro_fields, nsgs_fields, nsgs_fields_diag
            close(ntape)
        end if
        if(rank.eq.nsubdomains-1) then
            print *,'Restart file was written at  nstep=',nstep
        endif
        return
        end


        subroutine read_statement(dogenrestart)

        use vars
        use microphysics, only: micro_field, nmicro_fields
        use sgs, only: sgs_field, nsgs_fields, sgs_field_diag, nsgs_fields_diag
        use tracers
        use params
        use movies, only: irecc
        use rad, only: swnsxy,lwnsxy
        implicit none
        logical, intent(in) ::  dogenrestart

        integer  ntape, nx1, ny1, nz1, rank1, ntr, nmic, nsgs, nsgsd, k
        character(sizeof(case)) case1
        character(sizeof(caseid)) caseid1
        character(sizeof(version)) version1
        character(sizeof(landmaskfile)) landmaskfile1
        character(sizeof(sstfile)) sstfile1
        character(sizeof(terrainfile)) terrainfile1

        if(.not.dogenrestart) then
          read(65)  rank1, &
           u, v, w, t, p, pfy, qv, qcl, qci, qpl, qpi, dudt, dvdt, dwdt, &
           tracer, micro_field, sgs_field, sgs_field_diag, sstxy, precinst
          close(65)
          read(66) dt,dx,dy
          ntape = 66
        else
         read(65) nx1, ny1, nz1
         call restart_read_field3D (65,u(1:nx,1:ny,1:nzm),nx1,ny1,nzm)
         call restart_read_field3D (65,v(1:nx,1:ny,1:nzm),nx1,ny1,nzm)
         call restart_read_field3D (65,w(1:nx,1:ny,1:nz),nx1,ny1,nz)
         call restart_read_field3D (65,t(1:nx,1:ny,1:nzm),nx1,ny1,nzm)
         call restart_read_field3D (65,p(1:nx,1:ny,1:nzm),nx1,ny1,nzm)
         call restart_read_field3D (65,qv(1:nx,1:ny,1:nzm),nx1,ny1,nzm)
         call restart_read_field3D (65,qcl(1:nx,1:ny,1:nzm),nx1,ny1,nzm)
         call restart_read_field3D (65,qci(1:nx,1:ny,1:nzm),nx1,ny1,nzm)
         call restart_read_field3D (65,qpl(1:nx,1:ny,1:nzm),nx1,ny1,nzm)
         call restart_read_field3D (65,qpi(1:nx,1:ny,1:nzm),nx1,ny1,nzm)
         call restart_read_field3D (65,dudt(1:nx,1:ny,1:nzm,1:3),nx1,ny1,nzm*3)
         call restart_read_field3D (65,dvdt(1:nx,1:ny,1:nzm,1:3),nx1,ny1,nzm*3)
         call restart_read_field3D (65,dwdt(1:nx,1:ny,1:nz,1:3),nx1,ny1,nzm*3)
         call restart_read_field3D (65,tracer(1:nx,1:ny,1:nzm,1:ntracers),nx1,ny1,nzm*ntracers)
         call restart_read_field3D (65,micro_field(1:nx,1:ny,1:nzm,1:nmicro_fields), &
                                     nx1,ny1,nzm*nmicro_fields)
         call restart_read_field3D (65,sgs_field(1:nx,1:ny,1:nzm,1:nsgs_fields), &
                                     nx1,ny1,nzm*nsgs_fields)
         call restart_read_field3D (65,sgs_field_diag(1:nx,1:ny,1:nzm,1:nsgs_fields_diag), &
                                     nx1,ny1,nzm*nsgs_fields_diag)
         call restart_read_field3D (65,sstxy(1:nx,1:ny),nx1,ny1,1)
         call restart_read_field3D (65,precinst(1:nx,1:ny),nx1,ny1,1)
         ntape = 65
        end if
        read(ntape) version1, &
            z, zi, adz, adzw, pres, prespot, presi, prespoti, rho, rhow,  &
            bet, nx1, ny1, nz1, irecc, &
            at, bt, ct, dtn, dt3, time, dz, doconstdz, &
            day, day0, nstep, na, nb, nc, caseid1, case1, &
            dodamping, doupperbound, docloud, doprecip, doradhomo, dosfchomo,&
            dolongwave, doshortwave, dosgs, dosubsidence, dotracers,  dosmoke, &
            docoriolis, dosurface, dolargescale,doradforcing, dossthomo, &
            dosfcforcing, doradsimple, donudging_uv, donudging_tq, &
            dowallx, dowally, doperpetual, doseasons, &
            docup, docolumn, readterr, readlandmask, soil_wetness, dodynamicocean, &
            ocean_type, delta_sst, depth_slab_ocean, Szero, deltaS, timesimpleocean, &
            pres0, ug, vg, fcor, fcorz, tabs_s, z0, n2ox, ch4x, cfc11x, cfc12x, &
            fluxt0, fluxq0, tau0, tauls, tautqls, timelargescale, epsv, &
            nudging_uv_z1, nudging_uv_z2, donudging_t, donudging_q, doisccp, domodis, domisr, &
            dosimfilesout, dosolarconstant, solar_constant, zenith_angle, notracegases, &
            doSAMconditionals, dosatupdnconditionals, dodynamicland, dodynamicsoil, &
            nudging_t_z1, nudging_t_z2, nudging_q_z1, nudging_q_z2, &
            cem, les, ocean, land, sfc_flx_fxd, sfc_tau_fxd, readsst, &
            nrad, nxco2, latitude0, longitude0, dofplane, earth_factor, dodamping_w, &
            docoriolisz, doradlon, doradlat, doseawater, salt_factor, SLM, &
            doterrain, dobufferzone, bufferzone, doglobal, latwalls, dohyper, &
            sst_climo, tau_ocean, sst_mean, dosstclimo, dolatlon, reado3, &
            readlandmask, landmaskfile1, readsst, sstfile1, readterr, terrainfile1, &
            ntr, nmic, nsgs, nsgsd
        close(ntape)

        if(version1.ne.version) then
          if(masterproc)print *,'Wrong restart file!'
          if(masterproc)print *,'Version of SAM that wrote the restart files:',version1
          if(masterproc)print *,'Current version of SAM',version
          call task_abort()
        end if
        if(nrestart.eq.1) then
         if(case.ne.case1) then
           if(masterproc)print*,'Case is wrong for the restart. Quitting...' 
           if(masterproc)print*,'Required case:',case 
           call task_abort()
         end if 
         if(caseid.ne.caseid1) then
           if(masterproc)print*,'Caseid is wrong for the restart. Quitting...' 
           if(masterproc)print*,'Required caseid:',caseid 
           call task_abort()
         end if 
         if(readlandmask.and.landmaskfile.ne.landmaskfile1) then
           if(masterproc)print*,'specified landmaskfile name is wrong for the restart. Quitting...' 
           if(masterproc)print*,'Required file:',sstfile1,' Quitting...' 
           call task_abort()
         end if 
         if(readterr.and.terrainfile.ne.terrainfile1) then
           if(masterproc)print*,'specified terrainfile name is wrong for the restart. ' 
           if(masterproc)print*,'Required file:',terrainfile1,' Quitting...' 
           call task_abort()
         end if 
         if(readsst.and.sstfile.ne.sstfile1) then
           if(masterproc)print*,'specified sstfile name is wrong for the restart. Quitting...' 
           if(masterproc)print*,'Required file:',sstfile1,' Quitting...' 
           call task_abort()
         end if 
        end if
        if(nrestart.ne.2) then
          if(rank.ne.rank1) then
             if(masterproc)print *,'Error: rank of restart data is not the same as rank of the process'
             if(masterproc)print *,'rank1=',rank1,'   rank=',rank
          endif
          if(nx.ne.nx1.or.ny.ne.ny1.or.nz.ne.nz1) then
             if(masterproc)print *,'Error: domain dims (nx,ny,nz) set by grid.f'
             if(masterproc)print *,' not correspond to ones in the restart file.'
             if(masterproc)print *,'in executable:   nx, ny, nz:',nx,ny,nz
             if(masterproc)print *,'in restart file: nx, ny, nz:',nx1,ny1,nz1
             if(masterproc)print *,'Exiting...'
             call task_abort()
          endif
        end if
        if(nmic.ne.nmicro_fields) then
           if(masterproc)print*,'Error: number of micro_field in restart file is not the same as nmicro_fields'
           if(masterproc)print*,'nmicro_fields=',nmicro_fields,'   in reastart file:',nmic
           if(masterproc)print*,'Exiting...'
           call task_abort()
        end if
        if(nsgs.ne.nsgs_fields.or.nsgsd.ne.nsgs_fields_diag) then
           if(masterproc)print*,'Error: number of sgs_field in restart file is not the same as nsgs_fields'
           if(masterproc)print*,'nsgs_fields=',nsgs_fields,'   in reastart file=',nsgs
           if(masterproc)print*,'nsgs_fields_diag=',nsgs_fields_diag,'   in file=',nsgsd
           if(masterproc)print*,'Exiting...'
             call task_abort()
        end if
        if(ntr.ne.ntracers) then
           if(masterproc)print*,'Error: number of tracers in restart file is not the same as ntracers.'
           if(masterproc)print*,'ntracers=',ntracers,'   ntracers(in file)=',ntr
           if(masterproc)print*,'Exiting...'
             call task_abort()
        end if
        close(65)
        if(rank.eq.nsubdomains-1) then
           print *,'Case:',caseid
           print *,'Restarting at step:',nstep
           print *,'Time(s):',nstep*dt
        endif
        if(masterproc) print*,'Done...'

        return
        end
 

subroutine restart_write_field3D (ntape,f,nlevs)

! write full global arrays into a general
! (not dependent on number of PEs) restart file

use grid, only: masterproc, nx, ny, nx_gl, ny_gl, rank, nsubdomains
implicit none
! Input:

integer ntape
real f(nx,ny,nlevs)
integer nlevs,req

! Local:

real(4) fld(nx_gl,ny_gl), buf(nx,ny)
integer irank,ranksource,tagsource,ii,jj,k

if(masterproc) write(ntape) nlevs
do k=1,nlevs
   if(masterproc) fld(1:nx,1:ny) = f(:,:,k)
   do irank = 1, nsubdomains-1
       call task_barrier()
       if(irank.eq.rank) then
         call task_bsend_float(0,f(:,:,k),nx*ny,irank)
       end if
       if(masterproc) then
         call task_receive_float(buf(:,:),nx*ny,req)
         call task_wait(req,ranksource,tagsource)
         call task_rank_to_index(ranksource,ii,jj)
         fld(ii+1:ii+nx,jj+1:jj+ny) = buf(:,:)
       end if
   end do
   if(masterproc) write(ntape) fld
end do

end


subroutine restart_read_field3D (ntape,f,nxr,nyr,nlevs)

! read arrays from a general
! (not dependent on number of PEs) restart file
! without interpolation

use grid, only: nx, ny, nx_gl, ny_gl, rank
implicit none
! Input:

integer ntape
real f(nx,ny,nlevs)
integer nxr,nyr ! size of arrays in restart file
integer nlevs


! Local:

real(4),allocatable ::  fld(:,:)
integer nlevs1,ii,jj,iii,jjj,k,i,j

allocate(fld(nxr,nyr))

call task_rank_to_index(rank,iii,jjj)
read(ntape) nlevs1
if(nlevs.ne.nlevs1) then
  print*,'Restart_read_field3D: error: nlevs.ne.nlevs1. nlevs=',nlevs,' nlevs1=',nlevs1,' quitting...'
  call task_abort
end if
ii=nx_gl/nxr
jj=ny_gl/nyr
do k=1,nlevs
  read(ntape) fld
  f(1:nx:ii,1:ny:jj,k) = fld(iii/ii+1:(iii+nx)/ii,jjj/jj+1:(jjj+ny)/jj)
  do j=1,ny
   do i=1,nx
     f(i,j,k)=f(i-mod(i-1,ii),j-mod(j-1,jj),k)
   end do
  end do
end do

deallocate(fld)
end

