	
subroutine setparm
	
!       initialize parameters:

use vars
!use micro_params
use params
use microphysics, only: micro_setparm
use sgs, only: sgs_setparm
use movies, only : irecc
use instrument_diagnostics, only: zero_instr_diag
implicit none
	
integer icondavg, ierr

NAMELIST /PARAMETERS/ dodamping, doupperbound, docloud, doprecip, &
        dolongwave, doshortwave, dosgs, dz, doconstdz, &
        docoriolis, docoriolisz, dosurface, dolargescale, doradforcing, &
	fluxt0,fluxq0,tau0,tabs_s,z0,nelapse, dt, dx, dy,  &
        fcor, ug, vg, nstop, caseid, case_restart,caseid_restart, &
	nstat, nstatfrq, nprint, nrestart, doradsimple, &
	nsave3D, nsave3Dstart, nsave3Dend, dosfcforcing, &
	donudging_uv, donudging_tq, &
        donudging_t, donudging_q, tauls,tautqls,&
        nudging_uv_z1, nudging_uv_z2, nudging_t_z1, nudging_t_z2, &
        nudging_q_z1, nudging_q_z2, dofplane, &
	timelargescale, longitude0, latitude0, day0, nrad, &
	CEM,LES,OCEAN,LAND,ISLAND,SFC_FLX_FXD,SFC_TAU_FXD, soil_wetness, &
        doensemble, nensemble, dowallx, dowally, &
        nsave2D, nsave2Dstart, nsave2Dend, qnsave3D, & 
        docolumn, save2Dbin, save2Davg, save3Dbin, &
        save2Dsep, save3Dsep, dogzip2D, dogzip3D, restart_sep, &
        doseasons, doperpetual, doradhomo, dosfchomo, doisccp, &
        domodis, domisr, dodynamicocean, ocean_type, delta_sst, &
        depth_slab_ocean, Szero, deltaS, timesimpleocean, &
	dosolarconstant, solar_constant, zenith_angle, rundatadir, &
        dotracers, output_sep, perturb_type, &
        doSAMconditionals, dosatupdnconditionals, &
        doscamiopdata, iopfile, dozero_out_day0, &
        nstatmom, nstatmomstart, nstatmomend, savemomsep, savemombin, &
        nmovie, nmoviestart, nmovieend, nrestart_skip, &
        bubble_x0,bubble_y0,bubble_z0,bubble_radius_hor, &
        bubble_radius_ver,bubble_dtemp,bubble_dq, dosmoke, dossthomo, &
        rad3Dout, nxco2, dosimfilesout, notracegases, &
        doradlat, doradlon, ncycle_max, doseawater, doterrain, dobufferzone, &
        terrain_type, dodynamicland, dodynamicsoil, &
        island_x1, island_x2, island_y1, island_y2, &
        doroundisland, island_radius, bufferzone, &
        sst_climo, tau_ocean, dosstclimo, dolatlon, &
        dogrestart, nstepgrestart, dodamping_poles, dodebug, &
        doglobal, latwalls, readinit, &
        landmaskfile, sstfile, initfile, terrainfile, dohyper, &
        readsst, readterr, readlandmask, earth_factor, dodamping_w, &
        reado3, o3file, n2ox, ch4x, cfc11x, cfc12x, &
        nsave2DZ, nsave2DZstart, nsave2DZend, save2DZsep, dogzip2DZ, save2DZbin, dogzip2DL, &
        nsave2DL, nsave2DLstart, nsave2DLend, save2DLbin, save2DLavg, save2DLsep, dogzip2DL, &
        dopointsource, pointsource_start_step, year0, nens
        
	
!----------------------------------
!  Read namelist variables from the standard input:
!------------

open(55,file='./'//trim(case)//'/prm', status='old',form='formatted') 
read (55,PARAMETERS,IOSTAT=ierr)
if (ierr.ne.0) then
     !namelist error checking
        write(*,*) '****** ERROR: bad specification in PARAMETERS namelist'
        call task_abort()
end if
close(55)

! write namelist values out to file for documentation
if(masterproc) then
      open(unit=55,file='./'//trim(case)//'/'//trim(case)//'_'//trim(caseid)//'.nml',&
            form='formatted', position='append')
      write (55,nml=PARAMETERS)
      write(55,*) 
      close(55)
end if

!------------------------------------
!  Set parameters 


! Allow only special cases for separate output:

!output_sep = output_sep.and.RUN3D
if(output_sep)  save2Dsep = .true.

if(abs(latwalls).gt.90.) then
    if(masterproc)print*,'Error: latwalls is set wrong: latwalls=',latwalls,'  exit...'
    call task_abort()
end if

if(doglobal) then
   if(.not.RUN3D) then
      if(masterproc)print*,'Error: when doglobal, domain should be 3D.  exit...'
      call task_abort()
   end if
   if(latwalls.eq.0) then
      if(masterproc)print*,'Error: when doglobal, latwalls should be also set. exit...'
      call task_abort()
   end if
   dolatlon = .true.
   dowally = .true.
   dodamping = .true.
   dodamping_poles = .true.
   dx = 2.*pi*rad_earth/earth_factor/dble(nx_gl) 
   dy =  latwalls/90.*pi*rad_earth/earth_factor/dble(ny_gl)
   latitude0 = 0.
   longitude0 = 0.
end if

if(readterr) terrain_type = 0

if(RUN2D) dy=dx

if(RUN2D.and.YES3D.eq.1) then
  if(masterproc)print*,'Error: 2D run and YES3D is set to 1. Exitting...'
  call task_abort()
endif

if(RUN3D.and.YES3D.eq.0) then
  if(masterproc)print*,'Error: 3D run and YES3D is set to 0. Exitting...'
  call task_abort()
endif


if(docoriolis.and..not.dofplane.or.doradlat.or.dolatlon) dowally=.true.
dowally = dowally.and.RUN3D ! dowally is set only for 3D runs


if(ny.eq.1) dy=dx
dtn = dt

notopened2D = .true.
notopened2DL = .true.
notopened2DZ = .true.
notopened3D = .true.
notopenedmom = .true.

call zero_instr_diag() ! initialize instruments output 
call sgs_setparm() ! read in SGS options from prm file.
call micro_setparm() ! read in microphysical options from prm file.

if(dosmoke) then
  epsv=0.
else    
  epsv=0.61
endif   

if(navgmom_x.lt.0.or.navgmom_y.lt.0) then  
   nstatmom        = 1
   nstatmomstart    = 999999999
   nstatmomend      = 999999999
end if

if(doseawater) then
  salt_factor = 0.981
else
  salt_factor = 1.
end if

SLM = LAND.or.ISLAND

if(tautqls.eq.99999999.) tautqls = tauls
          
        !===============================================================
        ! UW ADDITION

!bloss: set up conditional averages
ncondavg = 1 ! always output CLD conditional average
if(doSAMconditionals) ncondavg = ncondavg + 2
if(dosatupdnconditionals) ncondavg = ncondavg + 3
if(allocated(condavg_factor)) then ! avoid double allocation when nrestart=2
  DEALLOCATE(condavg_factor,condavg_mask,condavgname,condavglongname)
end if
ALLOCATE(condavg_factor(nzm,ncondavg), & ! replaces old cloud_factor, core_factor
     condavg_mask(nx,ny,nzm,ncondavg), & ! nx x ny x nzm indicator arrays
     condavgname(ncondavg), & ! short names (e.g. CLD, COR, SATUP)
     condavglongname(ncondavg), & ! long names (e.g. cloud, core, saturated updraft)
     STAT=ierr)
if(ierr.ne.0) then
     write(*,*) '**************************************************************************'
     write(*,*) 'ERROR: Could not allocate arrays for conditional statistics in setparm.f90'
     call task_abort()
end if
        
! indicators that can be used to tell whether a particular average
!   is present.  If >0, these give the index into the condavg arrays
!   where this particular conditional average appears.
icondavg_cld = -1
icondavg_cor = -1
icondavg_cordn = -1
icondavg_satup = -1
icondavg_satdn= -1
icondavg_env = -1

icondavg = 0
icondavg = icondavg + 1
condavgname(icondavg) = 'CLD'
condavglongname(icondavg) = 'cloud'
icondavg_cld = icondavg

if(doSAMconditionals) then
   icondavg = icondavg + 1
   condavgname(icondavg) = 'COR'
   condavglongname(icondavg) = 'core'
   icondavg_cor = icondavg

   icondavg = icondavg + 1
   condavgname(icondavg) = 'CDN'
   condavglongname(icondavg) = 'downdraft core'
   icondavg_cordn = icondavg
end if
           
if(dosatupdnconditionals) then
   icondavg = icondavg + 1
   condavgname(icondavg) = 'SUP'
   condavglongname(icondavg) = 'saturated updrafts'
   icondavg_satup = icondavg

   icondavg = icondavg + 1
   condavgname(icondavg) = 'SDN'
   condavglongname(icondavg) = 'saturated downdrafts'
   icondavg_satdn = icondavg

   icondavg = icondavg + 1
   condavgname(icondavg) = 'ENV'
   condavglongname(icondavg) = 'unsaturated environment'
   icondavg_env = icondavg
end if
           
! END UW ADDITIONS
!===============================================================

irecc = 1


end
