subroutine setsurface()

use vars
use params
use terrain, only: setterrain
use slm_vars, only: slm_init

implicit none
integer i,j,it,jt,nobs
real field(nx,ny,2)
real days(2)
real coef

call task_rank_to_index(rank,it,jt)

if(OCEAN) then
  landmask(1:nx,1:ny)=0.
else if(LAND) then
  landmask(1:nx,1:ny)=1.
else if(ISLAND) then
  if(.not.readlandmask) then
      if(doroundisland) then
        do j=1,ny
          do i=1,nx
            if((dx*(i+it)-dx*nx_gl/2)**2+YES3D*(dy*(j+jt)-dy*ny_gl/2)**2.lt.island_radius**2) then
               landmask(i,j) = 1.
            else
               landmask(i,j) = 0.
            end if
          end do
        end do
      else
        do j=1,ny
          do i=1,nx
             if((RUN2D.or.j+jt.ge.island_y1*nx_gl.and.j+jt.le.island_y2*nx_gl).and.     &
                i+it.ge.island_x1*nx_gl.and.i+it.le.island_x2*nx_gl) then
                landmask(i,j) = 1.
             else
                landmask(i,j) = 0.
             end if
         end do
        end do
       end if
  else
    call readsurface(landmaskfile,field,days)
    landmask(:,:) = field(:,:,1)
  end if
end if


if(readterr) then
    call readsurface(terrainfile,field,days)
    elevation(:,:) = field(:,:,1)
    where(elevation.lt.0.) elevation=0.
end if

if(readsst) then
    call readsurface(sstfile,sstobs,daysstobs)
    if(nrestart.eq.0) then
      if(daysstobs(2).eq.0) then
        sstxy0(:,:) = sstobs(:,:,1)
      else
        coef=(day-daysstobs(1))/(daysstobs(2)-daysstobs(1))
        sstxy0(:,:) = sstobs(:,:,1)+coef*(sstobs(:,:,2)-sstobs(:,:,1))
      end if
      sstxy(:,:) = sstxy0(:,:) - t00
    end if
endif

! initialize SLM:

call slm_init()

end
