     
subroutine write_fields2DZ
	
use vars
use rad, only: qrad
use params
use terrain, only: terrau,terrav,terraw,terra
use sgs, only: tkh
use microphysics, only: nmicro_fields, micro_field, flag_number, &
     flag_micro2DZout, mkname, mklongname, mkunits, mkoutputscale, &
     index_water_vapor, GET_reffc, Get_reffi
implicit none
character *120 filename
character *80 long_name
character *8 name
character *10 timechar
character *4 rankchar
character *7 filetype
character *10 units
character *12 c_z(nzm),c_p(nzm),c_dy, c_time
integer i,j,k,n,nfields,nfields1,nsteplast
real(4) tmp(nx,ny,nzm),tmpz(1,ny,nzm),wgtx(ny,nzm)
character*7 filestatus

if(RUN2D) return

nfields=10 ! number of 2DZ fields to save
if(.not.docloud) nfields=nfields-1
if(.not.doprecip) nfields=nfields-1
if(docloud) nfields=nfields+SUM(flag_micro2DZout)-flag_micro2DZout(index_water_vapor)
if((dolongwave.or.doshortwave).and..not.doradhomo) nfields=nfields+1
if(compute_reffc.and.(dolongwave.or.doshortwave).and.rad3Dout) nfields=nfields+1
if(compute_reffi.and.(dolongwave.or.doshortwave).and.rad3Dout) nfields=nfields+1
if(doterrain) nfields=nfields+1

nfields1=0

if(masterproc) then
 
  write(rankchar,'(i4)') nsubdomains
  write(timechar,'(i10)') nstep
  do i=1,11-lenstr(timechar)-1
    timechar(i:i)='0'
  end do

! Make sure that the new run doesn't overwrite the file from the old run

    if(notopened2DZ.and.(nrestart.eq.0.or.nrestart.eq.2)) then
      filestatus='new'
    else
      filestatus='unknown'
    end if

    if(save2DZbin) then
      filetype = '.bin2DZ'
    else
      filetype = '.com2DZ'
    end if
   
    if(save2DZsep) then
      filename='./OUT_2DZ/'//trim(case)//'_'//trim(caseid)//'_'// &
             rankchar(5-lenstr(rankchar):4)//'_'//timechar(1:10)//filetype
      open(46,file=filename,status='unknown',form='unformatted')
    else
      filename='./OUT_2DZ/'//trim(case)//'_'//trim(caseid)//'_'// &
             rankchar(5-lenstr(rankchar):4)//filetype
      open(46,file=filename,status=filestatus,form='unformatted')
      do while(.true.)
         read(46,end=222)  nsteplast
         if(nsteplast.ge.nstep) then
           backspace(46)
           backspace(46)  ! these two lines added because of
           read(46)       ! a bug in gfrotran compiler
           print*,'com2DZ file at nstep ',nsteplast
           goto 222   ! yeh, I know, it's bad ....
         end if
         read(46)
         read(46)
         do i=1,nfields
           if(masterproc) read(46)
           read(46)
           do j=1,nsubdomains-1
               read(46)
           end do
         end do
      end do
222   continue
      backspace(46)
      notopened2DZ=.false.
    end if

    write(46) nstep
    if(save2DZbin) then

      write(46) nx,ny,nzm,nsubdomains, nsubdomains_x,nsubdomains_y,nfields
      write(46) real(dy,4),real(float(nstep)*dt/(3600.*24.)+day0,4),&
              (real(z(k),4),k=1,nzm),(real(pres(k),4),k=1,nzm)

    else

      write(long_name,'(7i4)') nx,ny,nzm,nsubdomains,  &
                                     nsubdomains_x,nsubdomains_y,nfields
      do k=1,nzm
         write(c_z(k),'(f12.3)') z(k)
      end do
      do k=1,nzm
         write(c_p(k),'(f12.3)') pres(k)
      end do
      write(c_dy,'(f12.5)') dy
      write(c_time,'(f12.5)') nstep*dt/(3600.*24.)+day0
      write(46) long_name(1:28)
      write(46) c_dy,c_time,(c_z(k),k=1,nzm),(c_p(k),k=1,nzm)

    end if ! save2DZbin

end if ! masterproc

!------------------------------
  nfields1=nfields1+1
  do k=1,nzm
   do j=1,ny
    do i=1,nx
      tmp(i,j,k)=terrau(i,j,k)
    end do
   end do
  end do
  call mean_x_3D(tmp,wgtx)
  do k=1,nzm
   do j=1,ny
     wgtx(j,k)=1./(wgtx(j,k)+1.e-10)
   end do
  end do

  do k=1,nzm
   do j=1,ny
    do i=1,nx
      tmp(i,j,k)=(u(i,j,k)+ug)*wgtx(j,k)*terrau(i,j,k)
    end do
   end do
  end do
  name='U'
  call mean_x_3D(tmp,tmpz)
  long_name='X Wind Component'
  units='m/s'
  call compress3D(tmpz,1,ny,nzm,name,long_name,units, &
                                 save2DZbin,dompi,rank,nsubdomains)

  nfields1=nfields1+1
  do k=1,nzm
   do j=1,ny
    do i=1,nx
      tmp(i,j,k)=terrav(i,j,k)
    end do
   end do
  end do
  call mean_x_3D(tmp,wgtx)
  do k=1,nzm
   do j=1,ny
     wgtx(j,k)=1./(wgtx(j,k)+1.e-10)
   end do
  end do

  do k=1,nzm
   do j=1,ny
    do i=1,nx
      tmp(i,j,k)=(v(i,j,k)+vg)*wgtx(j,k)*terrav(i,j,k)
    end do
   end do
  end do
  call mean_x_3D(tmp,tmpz)
  name='V'
  long_name='Y Wind Component'
  units='m/s'
  call compress3D(tmpz,1,ny,nzm,name,long_name,units, &
                                 save2DZbin,dompi,rank,nsubdomains)

  nfields1=nfields1+1
  do k=1,nzm
   do j=1,ny
    do i=1,nx
      tmp(i,j,k)=terraw(i,j,k)
    end do
   end do
  end do
  call mean_x_3D(tmp,wgtx)
  do k=1,nzm
   do j=1,ny
     wgtx(j,k)=1./(wgtx(j,k)+1.e-10)
   end do
  end do

  do k=1,nzm
   do j=1,ny
    do i=1,nx
      tmp(i,j,k)=w(i,j,k)*wgtx(j,k)*terraw(i,j,k)
    end do
   end do
  end do
  call mean_x_3D(tmp,tmpz)
  name='W'
  long_name='Z Wind Component'
  units='m/s'
  call compress3D(tmpz,1,ny,nzm,name,long_name,units, &
                                 save2DZbin,dompi,rank,nsubdomains)

  do k=1,nzm
   do j=1,ny
    do i=1,nx
      tmp(i,j,k)=terra(i,j,k)
    end do
   end do
  end do
  call mean_x_3D(tmp,wgtx)
  do k=1,nzm
   do j=1,ny
     wgtx(j,k)=1./(wgtx(j,k)+1.e-10)
   end do
  end do

  nfields1=nfields1+1
  do k=1,nzm
   do j=1,ny
    do i=1,nx
      tmp(i,j,k)=tkh(i,j,k)*wgtx(j,k)*terra(i,j,k)
    end do
   end do
  end do
  call mean_x_3D(tmp,tmpz)
  name='KZH'
  long_name='eddy diffusivity'
  units='m2/s'
  call compress3D(tmpz,1,ny,nzm,name,long_name,units, &
                                 save2DZbin,dompi,rank,nsubdomains)

  nfields1=nfields1+1
  do k=1,nzm
   do j=1,ny
    do i=1,nx
      tmp(i,j,k)=p(i,j,k)*wgtx(j,k)*terra(i,j,k)
    end do
   end do
  end do
  call mean_x_3D(tmp,tmpz)
  name='PP'
  long_name='Pressure Perturbation'
  units='Pa'
  call compress3D(tmpz,1,ny,nzm,name,long_name,units, &
                                 save2DZbin,dompi,rank,nsubdomains)


if((dolongwave.or.doshortwave).and..not.doradhomo) then
  nfields1=nfields1+1
  do k=1,nzm
   do j=1,ny
    do i=1,nx
      tmp(i,j,k)=qrad(i,j,k)*wgtx(j,k)*terra(i,j,k)*86400.
    end do
   end do
  end do
  call mean_x_3D(tmp,tmpz)
  name='QRAD'
  long_name='Radiative heating rate'
  units='K/day'
  call compress3D(tmpz,1,ny,nzm,name,long_name,units, &
                                 save2DZbin,dompi,rank,nsubdomains)
end if
if(compute_reffc.and.(dolongwave.or.doshortwave).and.rad3Dout) then
  nfields1=nfields1+1
  tmp(1:nx,1:ny,1:nzm)=Get_reffc()
  do k=1,nzm
   do j=1,ny
    do i=1,nx
      tmp(i,j,k)=tmp(i,j,k)*wgtx(j,k)*terra(i,j,k)
    end do
   end do
  end do
  call mean_x_3D(tmp,tmpz)
  name='REL'
  long_name='Effective Radius for Cloud Liquid Water'
  units='mkm'
  call compress3D(tmpz,1,ny,nzm,name,long_name,units, &
                                 save2DZbin,dompi,rank,nsubdomains)
end if
if(compute_reffi.and.(dolongwave.or.doshortwave).and.rad3Dout) then
  nfields1=nfields1+1
  tmp(1:nx,1:ny,1:nzm)=Get_reffi()
  do k=1,nzm
   do j=1,ny
    do i=1,nx
      tmp(i,j,k)=tmp(i,j,k)*wgtx(j,k)*terra(i,j,k)
    end do
   end do
  end do
  call mean_x_3D(tmp,tmpz)
  name='REI'
  long_name='Effective Radius for Cloud Ice'
  units='mkm'
  call compress3D(tmpz,1,ny,nzm,name,long_name,units, &
                                 save2DZbin,dompi,rank,nsubdomains)
end if

if(doterrain) then
  nfields1=nfields1+1
  do k=1,nzm
   do j=1,ny
    do i=1,nx
      tmp(i,j,k)=terra(i,j,k)
    end do
   end do
  end do
  call mean_x_3D(tmp,tmpz)
  name='TERRA'
  long_name='Terrain Mask'
  units=' '
  call compress3D(tmpz,1,ny,nzm,name,long_name,units, &
                                 save2DZbin,dompi,rank,nsubdomains)
end if

  nfields1=nfields1+1
  do k=1,nzm
   do j=1,ny
    do i=1,nx
      tmp(i,j,k)=tabs(i,j,k)*terra(i,j,k)*wgtx(j,k)
    end do
   end do
  end do
  call mean_x_3D(tmp,tmpz)
  name='TABS'
  long_name='Absolute Temperature'
  units='K'
  call compress3D(tmpz,1,ny,nzm,name,long_name,units, &
                                 save2DZbin,dompi,rank,nsubdomains)


  nfields1=nfields1+1
  do k=1,nzm
   do j=1,ny
    do i=1,nx
      tmp(i,j,k)=t(i,j,k)*wgtx(j,k)*terra(i,j,k)
    end do
   end do
  end do
  call mean_x_3D(tmp,tmpz)
  name='TT'
  long_name='Liquid-Ice water static energy'
  units='K'
  call compress3D(tmpz,1,ny,nzm,name,long_name,units, &
                                 save2DZbin,dompi,rank,nsubdomains)

  nfields1=nfields1+1
  do k=1,nzm
   do j=1,ny
    do i=1,nx
      tmp(i,j,k)=qv(i,j,k)*wgtx(j,k)*terra(i,j,k)*1.e3
    end do
   end do
  end do
  call mean_x_3D(tmp,tmpz)
  name='QV'
  long_name='Water Vapor'
  units='g/kg'
  call compress3D(tmpz,1,ny,nzm,name,long_name,units, &
                                 save2DZbin,dompi,rank,nsubdomains)

if(docloud) then
  nfields1=nfields1+1
  do k=1,nzm
   do j=1,ny
    do i=1,nx
      tmp(i,j,k)=(qcl(i,j,k)+qci(i,j,k))*wgtx(j,k)*terra(i,j,k)*1.e3
    end do
   end do
  end do
  call mean_x_3D(tmp,tmpz)
  name='QN'
  long_name='Non-precipitating Condensate (Water+Ice)'
  units='g/kg'
  call compress3D(tmpz,1,ny,nzm,name,long_name,units, &
                                 save2DZbin,dompi,rank,nsubdomains)
end if


if(doprecip) then
  nfields1=nfields1+1
  do k=1,nzm
   do j=1,ny
    do i=1,nx
      tmp(i,j,k)=(qpl(i,j,k)+qpi(i,j,k))*wgtx(j,k)*terra(i,j,k)*1.e3
    end do
   end do
  end do
  call mean_x_3D(tmp,tmpz)
  name='QP'
  long_name='Precipitating Water (Rain+Snow)'
  units='g/kg'
  call compress3D(tmpz,1,ny,nzm,name,long_name,units, &
                                 save2DZbin,dompi,rank,nsubdomains)
end if


do n = 1,nmicro_fields
   if(docloud.AND.flag_micro2DZout(n).gt.0.AND.n.ne.index_water_vapor) then
      nfields1=nfields1+1
      do k=1,nzm
         do j=1,ny
            do i=1,nx
               tmp(i,j,k)=micro_field(i,j,k,n)*wgtx(j,k)*terra(i,j,k)*mkoutputscale(n)
            end do
         end do
         ! remove factor of rho from number, if this field is a number concentration
         if(flag_number(n).gt.0) tmp(:,:,k) = tmp(:,:,k)*rho(k)
      end do
      call mean_x_3D(tmp,tmpz)
      name=TRIM(mkname(n))
      long_name=TRIM(mklongname(n))
      units=TRIM(mkunits(n))
      call compress3D(tmpz,1,ny,nzm,name,long_name,units, &
           save2DZbin,dompi,rank,nsubdomains)
   end if
end do

  call task_barrier()

  if(nfields.ne.nfields1) then
    if(masterproc) print*,'write_fields2DZ error: nfields=',nfields,'  nfields1=',nfields1
    call task_abort()
  end if

if(masterproc) then
     close(46)
     if(save2DZsep.and.dogzip2DZ) call systemf('gzip -f '//filename)
     if(masterproc)print*, 'Writting 2DZ data. file:'//filename
endif

 
end
