
subroutine ocn_adamsA

!       Apply Adams-Bashforth scheme and explicit pressure gradient term

use ocn_vars
use ocn_terrain, only: terrau, terrav, terraw

implicit none

integer i,j,k,kb,jb,ib

call t_startf('ocn_adamsA')

do k=1,nzm
  do j=1,ny
   do i=1,nx
      u(i,j,k) = terrau(i,j,k)*(u(i,j,k)+dt3(na) &
               *(at*dudt(i,j,k,na)+bt*dudt(i,j,k,nb)+ct*dudt(i,j,k,nc)+dudtd(i,j,k)))
      v(i,j,k) = terrav(i,j,k)*(v(i,j,k)+dt3(na) &
               *(at*dvdt(i,j,k,na)+bt*dvdt(i,j,k,nb)+ct*dvdt(i,j,k,nc)+dvdtd(i,j,k)))
      w(i,j,k) = terraw(i,j,k)*(w(i,j,k)+dt3(na) &
               *(at*dwdt(i,j,k,na)+bt*dwdt(i,j,k,nb)+ct*dwdt(i,j,k,nc)+dwdtd(i,j,k)))
   end do
  end do
end do


call t_stopf ('ocn_adamsA')

end
