
subroutine ocn_adamsB

!       Adams-Bashorth scheme Part B
!       apply explicit pressure gradient terms after implicit step

use ocn_vars
use ocn_terrain, only: terrau, terrav, terraw
implicit none

real(8) rdx,rdy,rdz
integer i,j,k,kb,jb,ib

call t_startf('ocn_adamsB')

do k=1,nzm
 kb=max(1,k-1)
 rdz = 1./(dz*adzw(k))
 do j=1,ny
  jb=j-YES3D
  rdx=imu(j)/dx
  rdy=1./(dy*adyv(j))
  do i=1,nx
   ib=i-1
   u(i,j,k)=u(i,j,k)-dt3(na)*(bt*(p(i,j,k,nb)-p(ib,j,k,nb))+ct*(p(i,j,k,nc)-p(ib,j,k,nc)))*rdx
   v(i,j,k)=v(i,j,k)-dt3(na)*(bt*(p(i,j,k,nb)-p(i,jb,k,nb))+ct*(p(i,j,k,nc)-p(i,jb,k,nc)))*rdy
   w(i,j,k)=w(i,j,k)-dt3(na)*(bt*(p(i,j,k,nb)-p(i,j,kb,nb))+ct*(p(i,j,k,nc)-p(i,j,kb,nc)))*rdz
  end do ! i
 end do ! j
end do ! k

call t_stopf('ocn_adamsB')


end subroutine ocn_adamsB


