subroutine ocn_advect_mom

use ocn_vars
use ocn_params, only: docolumn
use ocn_check_energy

implicit none
integer i,j,k
real, allocatable ::  du(:,:,:,:)

if(docolumn) return

call t_startf ('ocn_advect_mom')

if(dostatis) then
	
  allocate (du(nx,ny,nz,3))
 
  do k=1,nzm
   do j=1,ny
    do i=1,nx
     du(i,j,k,1)=dudt(i,j,k,na) 
     du(i,j,k,2)=dvdt(i,j,k,na) 
     du(i,j,k,3)=dwdt(i,j,k,na) 
    end do
   end do
  end do

endif

call ocn_sumenergy(1,'ocn_adv_mom')

call ocn_advect2_mom_xy()
call ocn_advect2_mom_z()

call ocn_sumenergy(-1,'ocn_adv_mom')

if(dostatis) then
	
  do k=1,nzm
   do j=1,ny
    do i=1,nx
     du(i,j,k,1)=dudt(i,j,k,na)-du(i,j,k,1)
     du(i,j,k,2)=dvdt(i,j,k,na)-du(i,j,k,2)
     du(i,j,k,3)=dwdt(i,j,k,na)-du(i,j,k,3)
    end do
   end do
  end do

  call ocn_stat_tke(du,tkeleadv)
  call ocn_stat_mom(du,momleadv)
  call ocn_setvalue(twleadv,nzm,0.)
  call ocn_setvalue(swleadv,nzm,0.)
  call ocn_stat_sw1(du,twleadv,swleadv)

  deallocate(du)

endif

call t_stopf ('ocn_advect_mom')

end subroutine ocn_advect_mom

