
subroutine ocn_buoyancy()

use ocn_vars
use ocn_params
use ocn_terrain
use ocn_check_energy
implicit none
	
integer i,j,k,kb,it,jt
real betu, betd
real, allocatable :: du(:,:,:,:)

if(docolumn) return

call t_startf ('ocn_buoyancy')

if(dostatis) then

  allocate(du(nx,ny,nz,3))
  do k=1,nzm
    do j=1,ny
      do i=1,nx
         du(i,j,k,3)=dwdt(i,j,k,na)
      end do
    end do
  end do

endif

call ocn_sumenergy(1,'ocn_buoyancy')

call task_rank_to_index(rank,it,jt)

do k=2,nzm	
 kb=k-1
 betu = 0.001*ggr*adz(kb)/(adz(k)+adz(kb))
 betd = 0.001*ggr*adz(k)/(adz(k)+adz(kb))
 do j=1,ny
  do i=1,nx
    dwdt(i,j,k,na) = dwdt(i,j,k,na) - &
           terraw(i,j,k)*(betu*(rhoo(i,j,k)-rhoo0(i,j,k))+betd*(rhoo(i,j,kb)-rhoo0(i,j,kb))) 
  end do ! i
 end do ! j
end do ! k

call ocn_sumenergy(-1,'ocn_buoyancy')

if(dostatis) then

  do k=1,nzm
    do j=1,ny
      do i=1,nx
        du(i,j,k,1)=0.
        du(i,j,k,2)=0.
        du(i,j,k,3)=dwdt(i,j,k,na)-du(i,j,k,3)
      end do
    end do
  end do

  call ocn_stat_tke(du,tkelebuoy)
  call ocn_stat_mom(du,momlebuoy)
  call ocn_setvalue(twlebuoy,nzm,0.)
  call ocn_setvalue(swlebuoy,nzm,0.)
  call ocn_stat_sw1(du,twlebuoy,swlebuoy)

  deallocate (du)
endif

call t_stopf ('ocn_buoyancy')
 
end subroutine ocn_buoyancy


