module ocn_check_energy

implicit none
real(8) sumtke

contains

subroutine ocn_sumenergy(flag,title)
use ocn_vars
use ocn_params, only: dodebug
integer flag
character*(*) title
real(8) sumtke1
integer k,j
if(.not.dodebug) return
if(flag.eq.1) then
  sumtke = 0.
  do k=1,nzm
   do j=1,ny
     sumtke = sumtke -sum(dudt(1:nx,j,k,na)*u(1:nx,j,k))*mu(j)*adz(k)*ady(j)
     sumtke = sumtke -sum(dvdt(1:nx,j,k,na)*v(1:nx,j,k))*muv(j)*adz(k)*adyv(j)
     sumtke = sumtke -sum(dwdt(1:nx,j,k,na)*w(1:nx,j,k))*mu(j)*adzw(k)*ady(j)
   end do
  end do
end if
if(flag.eq.-1) then
  do k=1,nzm
   do j=1,ny
     sumtke = sumtke +sum(dudt(1:nx,j,k,na)*u(1:nx,j,k))*mu(j)*adz(k)*ady(j)
     sumtke = sumtke +sum(dvdt(1:nx,j,k,na)*v(1:nx,j,k))*muv(j)*adz(k)*adyv(j)
     sumtke = sumtke +sum(dwdt(1:nx,j,k,na)*w(1:nx,j,k))*mu(j)*adzw(k)*ady(j)
   end do
  end do
  if(dompi) then
    call task_sum_real8(sumtke,sumtke1,1)    
    sumtke = sumtke1
  end if
  if(masterproc) print*,'OCEAN: change of KE in ',title,':',sumtke
end if
end subroutine ocn_sumenergy

end module ocn_check_energy
