
subroutine ocn_coriolis

use ocn_vars
use ocn_params, only:  dowallx,dowally
use ocn_check_energy

implicit none
	
integer i,j,k
real iady
	
if(RUN3D) then

call ocn_sumenergy(1,'ocn_coriolis')

do k=1,nzm
 do j=1,ny
  iady = 1./ady(j)
  do i=1,nx
    dudt(i,j,k,na)=dudt(i,j,k,na) + 0.25*(fcory(j)+u(i,j,k)*tanr(j))*iady* &
    (adyv(j)*(v(i,j,k)+v(i-1,j,k))+adyv(j+1)*(v(i,j+1,k)+v(i-1,j+1,k))-4.*vg0(k))
    dvdt(i,j,k,na)=dvdt(i,j,k,na) - 0.25*imuv(j)* &
      ((fcory(j)+u(i,j,k)*tanr(j))*mu(j)*(u(i,j,k)-ug0(k)) + &
       (fcory(j)+u(i+1,j,k)*tanr(j))*mu(j)*(u(i+1,j,k)-ug0(k)) + &
       (fcory(j-1)+u(i,j-1,k)*tanr(j-1))*mu(j-1)*(u(i,j-1,k)-ug0(k)) + &
       (fcory(j-1)+u(i+1,j-1,k)*tanr(j-1))*mu(j-1)*(u(i+1,j-1,k)-ug0(k)))
  end do ! i
 end do ! j
end do ! k

if(dowallx.and.mod(rank,nsubdomains_x).eq.0) then
    do k=1,nzm
      dudt(1,:,k,na) = 0.
    end do
end if
if(dowally.and.RUN3D.and.rank.lt.nsubdomains_x) then
    do k=1,nzm
      dvdt(:,1,k,na) = 0.
    end do
end if

call ocn_sumenergy(-1,'ocn_coriolis')

else

do k=1,nzm
 do j=1,ny
  do i=1,nx
   dudt(i,j,k,na)=dudt(i,j,k,na)+fcory(j)*(v(i,j,k)-vg0(k))
   dvdt(i,j,k,na)=dvdt(i,j,k,na)-fcory(j)*(u(i,j,k)-ug0(k))
  end do ! i
 end do ! i
end do ! k

endif

end subroutine 

