
subroutine ocn_damping()

!  "Spange"-layer damping at the domain top region and around poles

use ocn_vars
use ocn_params, only: dolatlon, dodamping_poles, dohyper_terr, dohyper, pi, dodamping_w, &
                  damping_u_cu, damping_w_cu, ggr, dodamping_u
use ocn_terrain, only: terrau,terrav,terraw
use ocn_check_energy
implicit none

real nu, nustar, tau_max, nubu
real tauy(ny),tauz(nzm),umax(ny),wmax,tau,cu,mu_min
integer i, j, k, n_damp(nx,ny)
real tauv,taut,trce,phi

call t_startf ('ocn_damping')

call ocn_sumenergy(1,'damping')


if(dodamping_w) then

  tau_max = 1./(3.*dtn)
  do k = 1,nzm
   if(tauz(k).eq.0.) then
     wmax = damping_w_cu*dz*adzw(k)/dt
     do j=1,ny
       do i=1,nx
          dwdt(i,j,k,na)= dwdt(i,j,k,na)-  &
               (w(i,j,k)-min(wmax,max(-wmax,w(i,j,k))))*tau_max*terraw(i,j,k)
       end do! i 
     end do! j
   end if
  end do ! k

end if

!--------------------------------------------------------------------------------
if(dolatlon.and.dodamping_poles) then

  tau_max = 1./(3.*dtn)
  mu_min=minval(mu_gl)
  do j=1,ny
    tauy(j) = tau_max*(1.-abs(mu(j)-mu_min)**2)**200
    umax(j) = damping_u_cu*dx*mu(j)/dt
  end do
  nubu = 0.8
  do k = 1,nzm
   if(dodamping_u.and.pres(k).lt.70.) then
    tau = tau_max
    do j=1,ny
      do i=1,nx
           dudt(i,j,k,na)= dudt(i,j,k,na)-  &
               (u(i,j,k)-min(umax(j),max(-umax(j),u(i,j,k))))*tau*terrau(i,j,k)
           dvdt(i,j,k,na)= dvdt(i,j,k,na)-  &
               (v(i,j,k)-min(umax(j),max(-umax(j),v(i,j,k))))*tau*terrav(i,j,k)
      end do
    end do! j
   else
    do j=1,ny
      do i=1,nx
           dudt(i,j,k,na)= dudt(i,j,k,na)-  &
               (u(i,j,k)-min(umax(j),max(-umax(j),u(i,j,k))))*tauy(j)*terrau(i,j,k)
           dvdt(i,j,k,na)= dvdt(i,j,k,na)-  &
               (v(i,j,k)-min(umax(j),max(-umax(j),v(i,j,k))))*tauy(j)*terrav(i,j,k)
      end do
    end do
   end if
  end do ! k

end if 

! try to filter 2-delta noise:

if(dohyper_terr.or.dohyper) call ocn_hyperdiff()

call ocn_sumenergy(-1,'ocn_damping')

call t_stopf('ocn_damping')


end subroutine ocn_damping
