subroutine ocn_diagnose
	
! Diagnose some useful stuff

use ocn_vars
use ocn_params
use ocn_sgs, only: ocn_sgs_diagnose
use ocn_terrain
use gsw_mod_kinds, only: r8
use gsw_mod_toolbox, only: gsw_t_from_ct, gsw_rho
use slm_vars, only: seaicemask
use vars, only: sstxy,landmask
implicit none
	
integer i,j,k,kb,kc,k100,k300,k500
real(8) coef, coef1, buffer(nzm,6), buffer1(nzm,6)
real(8) t0d(nzm),s0d(nzm),rhood(nzm),tabs0d(nzm)
real coef2, coefsum

call t_startf ('ocn_diagnose')

 call ocn_fminmax_print('t:',t,dimx1_s,dimx2_s,dimy1_s,dimy2_s,nzm)
 call ocn_fminmax_print('s:',s,dimx1_s,dimx2_s,dimy1_s,dimy2_s,nzm)

do k=1,nzm
  do j=1,ny
    do i=1,nx
     rhoo(i,j,k) = gsw_rho(real(s(i,j,k),r8), real(t(i,j,k),r8), real(pres(k),r8))
     tabs(i,j,k) = gsw_t_from_ct(real(s(i,j,k),r8), real(t(i,j,k),r8), real(pres(k),r8))
    end do
  end do
end do

!rhoo(1:nx,1:ny,1:nzm) = gsw_rho(real(s(1:nx,1:ny,1:nzm),r8), &
!                        real(t(1:nx,1:ny,1:nzm),r8), real(p3D(1:nx,1:ny,1:nzm),r8))
!tabs(1:nx,1:ny,1:nzm) = gsw_t_from_ct(real(s(1:nx,1:ny,1:nzm),r8), &
!                        real(t(1:nx,1:ny,1:nzm),r8), real(p3D(1:nx,1:ny,1:nzm),r8))

! compute mean profiles 
coefsum = 0.
do k=1,nzm
 coefsum=coefsum + dz*adz(k)
end do
if(nstep.eq.0) coefsum=1. ! let first call setdata to compute mean profile
do k=1,nzm
  u0(k)=0.
  v0(k)=0.
  t0d(k)=0.
  tabs0d(k)=0.
  s0d(k)=0.
  rhood(k)=0.
  kc=min(nzm,k+1)
  kb=max(1,k-1)
  coef1 = dz*adz(k)
  coef2 = coef1/coefsum
  do j=1,ny
    do i=1,nx
     u0(k)=u0(k)+u(i,j,k)*wgtu(j,k)*terrau(i,j,k)
     v0(k)=v0(k)+v(i,j,k)*wgtv(j,k)*terrav(i,j,k)
     t0d(k)=t0d(k)+t(i,j,k)*wgt(j,k)*terra(i,j,k)
     tabs0d(k)=tabs0d(k)+tabs(i,j,k)*wgt(j,k)*terra(i,j,k)
     s0d(k)=s0d(k)+s(i,j,k)*wgt(j,k)*terra(i,j,k)
     rhood(k)=rhood(k)+rhoo(i,j,k)*wgt(j,k)*terra(i,j,k)
    end do
  end do

end do ! k

do j=1,ny
 do i=1,nx
   if(landmask(i,j).eq.0) sstxy(i,j) = tabs(i,j,nzm)
 end do
end do
k100 = nzm
k300 = nzm
k500 = nzm
do k = 1,nzm
   kc=min(nzm,k+1)
   if((pres(kc).le.100.).and.(pres(k).gt.100.)) then
      if ((100.-pres(kc)).lt.(pres(k)-100.))then
         k100=kc
      else
         k100=k
      end if
   end if
   if((pres(kc).le.300.).and.(pres(k).gt.300.)) then
      if ((300.-pres(kc)).lt.(pres(k)-300.))then
         k300=kc
      else
         k300=k
      end if
   end if
   if((pres(kc).le.500.).and.(pres(k).gt.500.)) then
      if ((500.-pres(kc)).lt.(pres(k)-500.))then
         k500=kc
      else
         k500=k
      end if
   end if
end do


do j=1,ny
 do i=1,nx
  usfc_xy(i,j) = usfc_xy(i,j) + u(i,j,nzm)*dtfactor
  vsfc_xy(i,j) = vsfc_xy(i,j) + v(i,j,nzm)*dtfactor
  tsfc_xy(i,j) = tsfc_xy(i,j) + tabs(i,j,nzm)*dtfactor
  ssfc_xy(i,j) = ssfc_xy(i,j) + s(i,j,nzm)*dtfactor
  u100_xy(i,j) = u100_xy(i,j) + u(i,j,k100)*dtfactor *terrau(i,j,k100) 
  v100_xy(i,j) = v100_xy(i,j) + v(i,j,k100)*dtfactor *terrav(i,j,k100) 
  w100_xy(i,j) = w100_xy(i,j) + w(i,j,k100)*dtfactor *terraw(i,j,k100) 
  u300_xy(i,j) = u300_xy(i,j) + u(i,j,k300)*dtfactor *terrau(i,j,k300) 
  v300_xy(i,j) = v300_xy(i,j) + v(i,j,k300)*dtfactor *terrav(i,j,k300) 
  w300_xy(i,j) = w300_xy(i,j) + w(i,j,k300)*dtfactor *terraw(i,j,k300) 
  u500_xy(i,j) = u500_xy(i,j) + u(i,j,k500)*dtfactor *terrau(i,j,k500) 
  v500_xy(i,j) = v500_xy(i,j) + v(i,j,k500)*dtfactor *terrav(i,j,k500) 
  w500_xy(i,j) = w500_xy(i,j) + w(i,j,k500)*dtfactor *terraw(i,j,k500)
 end do
end do

if(dompi) then
  do k=1,nzm
    buffer(k,1) = u0(k)
    buffer(k,2) = v0(k)
    buffer(k,3) = t0d(k)
    buffer(k,4) = s0d(k)
    buffer(k,5) = rhood(k)
    buffer(k,6) = tabs0d(k)
  end do
  call task_sum_real8(buffer,buffer1,nzm*6)
  do k=1,nzm
    u0(k)=buffer1(k,1)
    v0(k)=buffer1(k,2)
    t0d(k)=buffer1(k,3)
    s0d(k)=buffer1(k,4)
    rhood(k)=buffer1(k,5)
    tabs0d(k)=buffer1(k,6)
  end do
end if

coef = 1./dble(nsubdomains*nx*ny)
do k=1,nzm
    u0(k)=u0(k)*coef
    v0(k)=v0(k)*coef
    t0(k)=t0d(k)*coef
    s0(k)=s0d(k)*coef
    rho0(k)=rhood(k)*coef
    tabs0(k)=tabs0d(k)*coef
end do

!-----------------
! compute some sgs diagnostics:

call ocn_sgs_diagnose()

call t_stopf ('ocn_diagnose')

end subroutine ocn_diagnose
