subroutine ocn_diffuse_mom

!  Interface to the diffusion routines

use ocn_vars
use ocn_params, only: doimplicitdiff
implicit none
integer i,j,k
real, allocatable ::  du(:,:,:,:)

call t_startf ('ocn_diffuse_mom')

if(dostatis) then
	
  allocate (du(nx,ny,nz,3))
 
  do k=1,nzm
   do j=1,ny
    do i=1,nx
     du(i,j,k,1)=dudt(i,j,k,na)
     du(i,j,k,2)=dvdt(i,j,k,na)
     du(i,j,k,3)=dwdt(i,j,k,na)
    end do
   end do
  end do

endif

if(RUN3D) then
 if(doimplicitdiff) then
   call ocn_diffuse_mom_xy()
 else
   call ocn_diffuse_mom3D()
 end if
else
   call ocn_diffuse_mom2D()
endif

if(dostatis) then
	
  do k=1,nzm
   do j=1,ny
    do i=1,nx
     du(i,j,k,1)=dudt(i,j,k,na)-du(i,j,k,1)
     du(i,j,k,2)=dvdt(i,j,k,na)-du(i,j,k,2)
     du(i,j,k,3)=dwdt(i,j,k,na)-du(i,j,k,3)
    end do
   end do
  end do

  call ocn_stat_tke(du,tkelediff)
  call ocn_stat_mom(du,momlediff)
  call ocn_setvalue(twlediff,nzm,0.)
  call ocn_setvalue(swlediff,nzm,0.)
  call ocn_stat_sw1(du,twlediff,swlediff)

  deallocate(du)

endif

call t_stopf ('ocn_diffuse_mom')

end subroutine ocn_diffuse_mom

