subroutine ocn_diffuse_mom_xy
	
!        momentum tendency due to SGS diffusion

use ocn_vars
use ocn_sgs, only: tk, grdf_x, grdf_y, grdf_z, tkmin, tkmax
use ocn_params, only: docolumn, dowallx, dowally
use ocn_terrain
use ocn_check_energy
implicit none

real rdx2,rdy2,rdz2,rdz,rdx2u,rdx2v,rdx2w,rdy2u,rdy2v,rdy2w,rdz25

integer i,j,k,ic,ib,jb,jc,kc,kcu
real tkx, tky, tkz, iadzw, iadz
real fu(0:nx,0:ny,nz),fv(0:nx,0:ny,nz),fw(0:nx,0:ny,nz)

!-----------------------------------------

rdx2=1./(dx*dx)
rdy2=1./(dy*dy)

call ocn_sumenergy(1,'ocn_diff_mom_xy')

do k=1,nzm
  kc=k+1
  kcu=min(kc,nzm)
  do j=1,ny
   jb=j-1
   rdx2u=rdx2*imu(j)
   rdx2v=rdx2*imuv(j)
   rdx2w=rdx2*imu(j)
   do i=0,nx
    ic=i+1
    tkx=rdx2u*min(tkmax(j,k),max(tkmin(j,k),grdf_x(j,k)*tk(i,j,k)*terra(i,j,k)))
    fu(i,j,k)=-tkx*(u(ic,j,k)-u(i,j,k))*min(terrau(ic,j,k),terrau(i,j,k))
    tkx=rdx2v*min(tkmax(j,k),max(tkmin(j,k), &
               grdf_x(j,k)*(tk(i,j,k)*terra(i,j,k)+tk(i,jb,k)*terra(i,jb,k) &
               +tk(ic,j,k)*terra(ic,j,k)+tk(ic,jb,k)*terra(ic,jb,k)) &
              /(terra(i,j,k)+terra(i,jb,k)+terra(ic,j,k)+terra(ic,jb,k)+1.e-10)))
    fv(i,j,k)=-tkx*((v(ic,j,k)-v(i,j,k))*min(terrav(ic,j,k),terrav(i,j,k))) 
    tkx=rdx2w*min(tkmax(j,k),max(tkmin(j,k), &
               grdf_x(j,k)*(tk(i,j,k)*terra(i,j,k)+tk(ic,j,k)*terra(ic,j,k) &
               +tk(i,j,kcu)*terra(i,j,kcu)+tk(ic,j,kcu)*terra(ic,j,kcu)) &
              /(terra(i,j,k)+terra(ic,j,k)+terra(i,j,kcu)+terra(ic,j,kcu)+1.e-10)))
    fw(i,j,k)=-tkx*((w(ic,j,kc)-w(i,j,kc))*min(terraw(ic,j,kc),terraw(i,j,kc)))
   end do 
   do i=1,nx
    ib=i-1
    dudt(i,j,k,na)=dudt(i,j,k,na)-imu(j)*(fu(i,j,k)-fu(ib,j,k))
    dvdt(i,j,k,na)=dvdt(i,j,k,na)-imuv(j)*(fv(i,j,k)-fv(ib,j,k))
    dwdt(i,j,kc,na)=dwdt(i,j,kc,na)-imu(j)*(fw(i,j,k)-fw(ib,j,k))
   end do  
  end do 
end do

do k=1,nzm
  kc=k+1
  kcu=min(kc,nzm)
  do j=0,ny
   jc=j+1
   rdy2u=rdy2/adyv(jc)**2*muv(jc)
   rdy2v=rdy2/ady(j)**2*mu(j)
   rdy2w=rdy2/adyv(jc)**2*muv(jc)
   do i=1,nx
    ib=i-1
    tky=rdy2u*min(tkmax(j,k),max(tkmin(j,k), &
               grdf_y(j,k)*(tk(i,j,k)*terra(i,j,k)+tk(ib,j,k)*terra(ib,j,k) &
               +tk(i,jc,k)*terra(i,jc,k)+tk(ib,jc,k)*terra(ib,jc,k)) &
             /(terra(i,j,k)+terra(ib,j,k)+terra(i,jc,k)+terra(ib,jc,k)+1.e-10)))
    fu(i,j,k)=-tky*((u(i,jc,k)-u(i,j,k))*min(terrau(i,jc,k),terrau(i,j,k)))
    tky=rdy2v*min(tkmax(j,k),max(tkmin(j,k),grdf_y(j,k)*tk(i,j,k)*terra(i,j,k)))
    fv(i,j,k)=-tky*(v(i,jc,k)-v(i,j,k))*min(terrav(i,jc,k),terrav(i,j,k))
    tky=rdy2w*min(tkmax(j,k),max(tkmin(j,k), &
               grdf_y(j,k)*(tk(i,j,k)*terra(i,j,k)+tk(i,jc,k)*terra(i,jc,k) &
               +tk(i,j,kcu)*terra(i,j,kcu)+tk(i,jc,kcu)*terra(i,jc,kcu)) &
             /(terra(i,j,k)+terra(i,jc,k)+terra(i,j,kcu)+terra(i,jc,kcu)+1.e-10)))
    fw(i,j,k)=-tky*((w(i,jc,kc)-w(i,j,kc))*min(terraw(i,jc,kc),terraw(i,j,kc)))
   end do 
  end do 
  do j=1,ny
    jb=j-1
    do i=1,nx    
     dudt(i,j,k,na)=dudt(i,j,k,na)-imu(j)*(fu(i,j,k)-fu(i,jb,k))
     dvdt(i,j,k,na)=dvdt(i,j,k,na)-imuv(j)*(fv(i,j,k)-fv(i,jb,k))
     dwdt(i,j,kc,na)=dwdt(i,j,kc,na)-imu(j)*(fw(i,j,k)-fw(i,jb,k))
   end do 
  end do 
end do 

call ocn_sumenergy(-1,'ocn_diff_mom_xy')

end subroutine ocn_diffuse_mom_xy
