subroutine ocn_diffuse_mom_z
	
!        momentum SGS diffusion in the vertical

use ocn_vars
use ocn_sgs, only: tk
use ocn_params, only: docolumn, dowallx, dowally, dosgs, doimplicitdiff, z0
use ocn_terrain
use ocn_check_energy
implicit none

real rdx2,rdy2,rdz2,rdz,rdx2u,rdx2v,rdx2w,rdy2u,rdy2v,rdy2w,rdz25

integer i,j,k,ic,ib,jb,jc,kb,kc,kcu
real tkx, tky, tkz, iadzw, iadz, a, b, c, d, e, wnd
real alpha(nx,ny,nzm),beta(nx,ny,nzm)

!-----------------------------------------

if(.not.(dosgs.and.doimplicitdiff)) return

rdx2=1./(dx*dx)
rdy2=1./(dy*dy)

call ocn_sumenergy(1,'ocn_diff_mom_z')

! compute bottom friction assuming no heat flux (log-profile):

do j=1,ny
 do i=1,nx
  if(k_terrau(i,j).eq.nz) cycle
  k=k_terrau(i,j)
  wnd=u(i,j,k)**2+(0.25*(v(i,j,k)+v(i-1,j,k)+v(i,j+1,k)+v(i-1,j+1,k)))**2 
  fluxbu(i,j) = -min(0.25*adz(k)*dz/dtn,sqrt(wnd)*(0.4/log(min(50.,z(k)-zi(k))/z0))**2) &
                    *u(i,j,k)
 end do
end do
!print*,'>>u',rank,minval(fluxbu),maxval(fluxbu),minloc(fluxbu),maxloc(fluxbu)
do j=1,ny
 do i=1,nx
  if(k_terrav(i,j).eq.nz) cycle
  k=k_terrav(i,j)
  wnd=v(i,j,k)**2+(0.25*(u(i,j,k)+u(i+1,j,k)+u(i,j-1,k)+u(i+1,j-1,k)))**2
  fluxbv(i,j) = -min(0.25*adz(k)*dz/dtn,sqrt(wnd)*(0.4/log(min(50.,z(k)-zi(k))/z0))**2) &
                    *v(i,j,k)
 end do
end do
!print*,'>>v',rank,minval(fluxbv),maxval(fluxbv),minloc(fluxbv),maxloc(fluxbv)

!-------------------------
rdz=1./dz
rdz2 = 0.5*dtn*rdz*rdz 
!----------------------------------------------------
! Diffusion of u:

do j=1,ny
 do i=1,nx
  if(k_terrau(i,j).eq.nz) cycle
  k = k_terrau(i,j)
  if(k.ne.nzm) then
    ib=i-1
    kc =min(nzm,k+1)
     iadzw = rdz2/(adzw(kc)*adz(k))
     tkz = (tk(i,j,k)*terra(i,j,k)+tk(ib,j,k)*terra(ib,j,k) &
             +tk(i,j,kc)*terra(i,j,kc)+tk(ib,j,kc)*terra(ib,j,kc)) &
            /(terra(i,j,k)+terra(ib,j,k)+terra(i,j,kc)+terra(ib,j,kc)+1.e-10)
     c = -tkz*iadzw 
     b = 1. - c
     d = dudt(i,j,k,nc) +c*(u(i,j,k)-u(i,j,kc)) + dtn/(dz*adz(k))*fluxbu(i,j)
     alpha(i,j,k) = -c/b
     beta(i,j,k) = d/b 
  else
   dudt(i,j,nzm,nc) = dudt(i,j,nzm,nc) + dtn*(fluxbu(i,j)-fluxtu(i,j))/(dz*adz(nzm))
  end if
 end do
end do
do k=2,nzm-1
 kc=k+1
 kb=k-1
 iadz = rdz2/(adzw(k)*adz(k))
 iadzw = rdz2/(adzw(kc)*adz(k))
 do j=1,ny
   do i=1,nx
    if(k_terrau(i,j).ge.nzm) cycle
    if(k.gt.k_terrau(i,j)) then
      ib=i-1
      tkz = (tk(i,j,kb)*terra(i,j,kb)+tk(ib,j,kb)*terra(ib,j,kb) &
              +tk(i,j,k)*terra(i,j,k)+tk(ib,j,k)*terra(ib,j,k)) &
             /(terra(i,j,kb)+terra(ib,j,kb)+terra(i,j,k)+terra(ib,j,k)+1.e-10)
      a = -tkz*iadz
      tkz = (tk(i,j,k)*terra(i,j,k)+tk(ib,j,k)*terra(ib,j,k) &
              +tk(i,j,kc)*terra(i,j,kc)+tk(ib,j,kc)*terra(ib,j,kc)) &
             /(terra(i,j,k)+terra(ib,j,k)+terra(i,j,kc)+terra(ib,j,kc)+1.e-10)
      c = -tkz*iadzw
      b = 1. - a - c
      d = dudt(i,j,k,nc)+a*(u(i,j,k)-u(i,j,kb))+c*(u(i,j,k)-u(i,j,kc))
      e = b + a*alpha(i,j,k-1)
      alpha(i,j,k) = -c/e
      beta(i,j,k) = (d-a*beta(i,j,k-1))/e
    end if
   end do
 end do
end do 
k = nzm
kb = k-1
do j=1,ny
 do i=1,nx
  if(k_terrau(i,j).ge.nzm) cycle
  ib=i-1
  tkz = (tk(i,j,kb)*terra(i,j,kb)+tk(ib,j,kb)*terra(ib,j,kb) &
          +tk(i,j,k)*terra(i,j,k)+tk(ib,j,k)*terra(ib,j,k)) &
         /(terra(i,j,kb)+terra(ib,j,kb)+terra(i,j,k)+terra(ib,j,k)+1.e-10)
  iadz = rdz2/(adzw(k)*adz(k))
  a = -tkz*iadz
  b = 1. - a
  d = dudt(i,j,k,nc)+a*(u(i,j,k)-u(i,j,kb)) - dtn/(dz*adz(k))*fluxtu(i,j)
  e = b + a*alpha(i,j,k-1)
  dudt(i,j,k,nc) = (d-a*beta(i,j,k-1))/e
 end do
end do
do k=nzm-1,1,-1
 kc=k+1
 do j=1,ny
   do i=1,nx
    if(k_terrau(i,j).ge.nzm) cycle
    if(k.ge.k_terrau(i,j)) then
      dudt(i,j,k,nc) = alpha(i,j,k)*dudt(i,j,kc,nc) + beta(i,j,k)
    end if
   end do
 end do
end do 

! -----------------------------------------
! Diffusion of v:
  
do j=1,ny
 jb=j-1
 do i=1,nx
  if(k_terrav(i,j).eq.nz) cycle
  k = k_terrav(i,j)
  if(k.ne.nzm) then
    kc =min(nzm,k+1)
     iadzw = rdz2/(adzw(kc)*adz(k))
     tkz=(tk(i,j,k)*terra(i,j,k)+tk(i,jb,k)*terra(i,jb,k) &
                +tk(i,j,kc)*terra(i,j,kc)+tk(i,jb,kc)*terra(i,jb,kc)) &
               /(terra(i,j,k)+terra(i,jb,k)+terra(i,j,kc)+terra(i,jb,kc)+1.e-10)
     c = -tkz*iadzw
     b = 1. - c
     d = dvdt(i,j,k,nc)+c*(v(i,j,k)-v(i,j,kc)) + dtn/(dz*adz(k))*fluxbv(i,j)
     alpha(i,j,k) = -c/b
     beta(i,j,k) = d/b
  else
   dvdt(i,j,nzm,nc) = dvdt(i,j,nzm,nc) + dtn*(fluxbv(i,j)-fluxtv(i,j))/(dz*adz(nzm))
  end if
 end do
end do
do k=2,nzm-1
 kc=k+1
 kb=k-1
 iadz = rdz2/(adzw(k)*adz(k))
 iadzw = rdz2/(adzw(kc)*adz(k))
 do j=1,ny
   jb=j-1
   do i=1,nx
    if(k_terrav(i,j).ge.nzm) cycle
    if(k.gt.k_terrav(i,j)) then
      tkz=(tk(i,j,kb)*terra(i,j,kb)+tk(i,jb,kb)*terra(i,jb,kb) &
              +tk(i,j,k)*terra(i,j,k)+tk(i,jb,k)*terra(i,jb,k)) &
             /(terra(i,j,kb)+terra(i,jb,kb)+terra(i,j,k)+terra(i,jb,k)+1.e-10)
      a = -tkz*iadz
      tkz=(tk(i,j,k)*terra(i,j,k)+tk(i,jb,k)*terra(i,jb,k) &
              +tk(i,j,kc)*terra(i,j,kc)+tk(i,jb,kc)*terra(i,jb,kc)) &
             /(terra(i,j,k)+terra(i,jb,k)+terra(i,j,kc)+terra(i,jb,kc)+1.e-10)
      c = -tkz*iadzw
      b = 1. - a - c
      d = dvdt(i,j,k,nc)+a*(v(i,j,k)-v(i,j,kb))+c*(v(i,j,k)-v(i,j,kc))
      e = b + a*alpha(i,j,k-1)
      alpha(i,j,k) = -c/e
      beta(i,j,k) = (d-a*beta(i,j,k-1))/e
    end if
   end do
 end do
end do 
k = nzm
kb = k-1
do j=1,ny
 jb=j-1
 do i=1,nx
  if(k_terrav(i,j).ge.nzm) cycle
  tkz=(tk(i,j,kb)*terra(i,j,kb)+tk(i,jb,kb)*terra(i,jb,kb) &
              +tk(i,j,k)*terra(i,j,k)+tk(i,jb,k)*terra(i,jb,k)) &
             /(terra(i,j,kb)+terra(i,jb,kb)+terra(i,j,k)+terra(i,jb,k)+1.e-10)
  iadz = rdz2/(adzw(k)*adz(k))
  a = -tkz*iadz
  b = 1. - a
  d = dvdt(i,j,k,nc) + a*(v(i,j,k)-v(i,j,kb)) - dtn/(dz*adz(k))*fluxtv(i,j)
  e = b + a*alpha(i,j,k-1)
  dvdt(i,j,k,nc) = (d-a*beta(i,j,k-1))/e
 end do
end do
do k=nzm-1,1,-1
 kc=k+1
 do j=1,ny
   do i=1,nx
    if(k_terrav(i,j).ge.nzm) cycle
    if(k.ge.k_terrav(i,j)) then
      dvdt(i,j,k,nc) = alpha(i,j,k)*dvdt(i,j,kc,nc) + beta(i,j,k)
    end if
   end do
 end do
end do 

! -----------------------------------------
! Diffusion of w:

do j=1,ny
 do i=1,nx
  if(k_terra(i,j).ge.nzm) cycle
  k = k_terra(i,j)
  alpha(i,j,k) = 0.
  beta(i,j,k) = 0.
 end do
end do
do k=2,nzm
 kc=k+1
 kb=k-1
 iadz = rdz2/(adzw(k)*adz(kb))
 iadzw = rdz2/(adzw(k)*adz(k))
 do j=1,ny
   do i=1,nx
    if(k_terra(i,j).ge.nzm) cycle
    if(k.gt.k_terra(i,j)) then
      tkz=tk(i,j,kb)
      a = -tkz*iadz
      tkz=tk(i,j,k)
      c = -tkz*iadzw
      b = 1. - a - c
      d = dwdt(i,j,k,nc) +a*(w(i,j,k)-w(i,j,kb))+c*(w(i,j,k)-w(i,j,kc))
      e = b + a*alpha(i,j,k-1)
      alpha(i,j,k) = -c/e
      beta(i,j,k) = (d-a*beta(i,j,k-1))/e
    end if
   end do
 end do
end do 
do k=nzm,2,-1
 kc=k+1
 do j=1,ny
   do i=1,nx
     if(k_terra(i,j).ge.nzm) cycle
     if(k.ge.k_terra(i,j)) then
      dwdt(i,j,k,nc) = alpha(i,j,k)*dwdt(i,j,kc,nc) + beta(i,j,k)
    end if
   end do
 end do
end do

call ocn_sumenergy(-1,'ocn_diff_mom_z')

end subroutine ocn_diffuse_mom_z
