subroutine ocn_diffuse_scalar_z (field,fluxb,fluxt,tkh,rho,rhow,flux)

use ocn_grid
use ocn_params, only: docolumn,dowallx,dowally,dosgs
use ocn_terrain, only: k_terra, terra
implicit none
! input	
real field(dimx1_s:dimx2_s, dimy1_s:dimy2_s, nzm)	! scalar
real tkh(0:nxp1,1-YES3D:nyp1,nzm)	! eddy conductivity
real fluxb(nx,ny)		! bottom flux
real fluxt(nx,ny)		! top flux
real rho(nzm)
real rhow(nz)
real flux(nz)
! local        
real rdz2, tkz, iadz, iadzw, a, b, c, d, e
real alpha(nx,ny,nzm), beta(nx,ny,nzm)
integer i,j,k,ib,ic,jb,jc,kc,kb


if(.not.dosgs) return

rdz2 = 0.5*dtn/dz**2
do j=1,ny
 do i=1,nx
  if(k_terra(i,j).eq.nz) cycle
  k = k_terra(i,j)
  if(k.ne.nzm) then
   kc =min(nzm,k+1)
   iadzw = rdz2*rhow(kc)/(adzw(kc)*adz(k)*rho(k))
   tkz = (tkh(i,j,k)*terra(i,j,k)+tkh(i,j,kc)*terra(i,j,kc))/ &
         (terra(i,j,k)+terra(i,j,kc)+1.e-9)
   c = -tkz*iadzw
   b = 1. - c
   d = (1.+c)*field(i,j,k) - c*field(i,j,kc) + dtn*rhow(k)/(rho(k)*dz*adz(k))*fluxb(i,j)
   alpha(i,j,k) = -c/b
   beta(i,j,k) = d/b
  else
   field(i,j,nzm) = field(i,j,nzm) + dtn*(rhow(nzm)*fluxb(i,j)-rhow(nz)*fluxt(i,j))/(rho(nzm)*dz*adz(nzm))
  end if
 end do
end do
do k=2,nzm-1
 kc=k+1
 kb=k-1
 iadz = rdz2*rhow(k)/(adzw(k)*adz(k)*rho(k))
 iadzw = rdz2*rhow(kc)/(adzw(kc)*adz(k)*rho(k))
 do j=1,ny
   do i=1,nx
    if(k_terra(i,j).ge.nzm) cycle
    if(k.gt.k_terra(i,j)) then
      tkz = 0.5*(tkh(i,j,kb)+tkh(i,j,k)) 
      a = -tkz*iadz
      tkz = 0.5*(tkh(i,j,k)+tkh(i,j,kc)) 
      c = -tkz*iadzw
      b = 1. - a - c
      d = (1.+a+c)*field(i,j,k) - a*field(i,j,kb) - c*field(i,j,kc)
      e = b + a*alpha(i,j,k-1)
      alpha(i,j,k) = -c/e
      beta(i,j,k) = (d-a*beta(i,j,k-1))/e
    end if
   end do
 end do
end do
k = nzm
kb = k-1
iadz = rdz2*rhow(k)/(adzw(k)*adz(k)*rho(k))
do j=1,ny
 do i=1,nx
  if(k_terra(i,j).ge.nzm) cycle
  tkz = (tkh(i,j,k)*terra(i,j,k)+tkh(i,j,kb)*terra(i,j,kb))/ &
         (terra(i,j,k)+terra(i,j,kb)+1.e-9) 
  a = -tkz*iadz
  b = 1. - a
  d = (1.+a)*field(i,j,k) - a*field(i,j,kb) - dtn*rhow(kc)/(rho(k)*dz*adz(k))*fluxt(i,j)
  e = b + a*alpha(i,j,k-1)
  field(i,j,k) = (d-a*beta(i,j,k-1))/e
 end do
end do
do k=nzm-1,1,-1
 kc=k+1
 do j=1,ny
   do i=1,nx
    if(k_terra(i,j).ge.nzm) cycle
    if(k.ge.k_terra(i,j)) then
      field(i,j,k) = alpha(i,j,k)*field(i,j,kc) + beta(i,j,k)
    end if
   end do
 end do
end do

end subroutine ocn_diffuse_scalar_z
