
subroutine ocn_forcing
	
use ocn_vars
use ocn_params
use vars, only: sstxy, roff_ocn, shf_ocn, lhf_ocn, prec_ocn, sw_ocn, lw_ocn, taux_ocn, tauy_ocn, landmask
use slm_vars, only: seaicemask, readseaice
use params, only: dooceanonly

implicit none


integer i,j,k,n,nn,m,iz,iday0,iday,it,jt
real coef, radtend, tmp
real tt(nzm,2),ss(nzm,2),uu(nzm,2),vv(nzm,2),ww(nzm,2)
real ratio1,ratio2,ratio_t1,ratio_t2
logical zgrid
call t_startf ('ocn_forcing')

if(.not.readinit) then
! ---------------------------------------------------------------
! Large-scale sounding:

  nn=1
  do i=1,nsnd-1
   if(day.gt.daysnd(i)) then
     nn=i
   endif
  end do

  do n=1,2
  
    m = nn+n-1
    if(zsnd(2,m).gt.zsnd(1,m)) then
      zgrid=.true.
    else if(psnd(2,m).lt.psnd(1,m)) then
      zgrid=.false.
    else
      if(masterproc) print*,'error in grid in snd'
      stop
    end if
    do iz = 1,nzm
      if(zgrid) then
        do i = 2,nzsnd
          if(z(iz).le.zsnd(i,m)) then
           coef = (z(iz)-zsnd(i-1,m))/(zsnd(i,m)-zsnd(i-1,m)) 
           tt(iz,n)=tsnd(i-1,m)+(tsnd(i,m)-tsnd(i-1,m))*coef
           ss(iz,n)=ssnd(i-1,m)+(ssnd(i,m)-ssnd(i-1,m))*coef
           uu(iz,n)=usnd(i-1,m)+(usnd(i,m)-usnd(i-1,m))*coef
           vv(iz,n)=vsnd(i-1,m)+(vsnd(i,m)-vsnd(i-1,m))*coef
           goto 11
          endif
        end do
      else
        do i = 2,nzsnd
          if(pres(iz).ge.psnd(i,m)) then
           coef = (pres(iz)-psnd(i-1,m))/(psnd(i,m)-psnd(i-1,m))
           tt(iz,n)=tsnd(i-1,m)+(tsnd(i,m)-tsnd(i-1,m))*coef
           ss(iz,n)=ssnd(i-1,m)+(ssnd(i,m)-ssnd(i-1,m))*coef
           uu(iz,n)=usnd(i-1,m)+(usnd(i,m)-usnd(i-1,m))*coef
           vv(iz,n)=vsnd(i-1,m)+(vsnd(i,m)-vsnd(i-1,m))*coef
           goto 11
          endif
        end do
      end if

      tt(iz,n)=tt(iz-1,n)
      ss(iz,n) = ss(iz-1,n)
      uu(iz,n)=uu(iz-1,n)
      vv(iz,n)=vv(iz-1,n)

   11 continue

    end do ! iz 

  end do ! n

  coef=(day-daysnd(nn))/(daysnd(nn+1)-daysnd(nn))
  do k=1,nzm
    tg0(k)=tt(k,1)+(tt(k,2)-tt(k,1))*coef
    sg0(k)=ss(k,1)+(ss(k,2)-ss(k,1))*coef
! Note that ug0 and vg0 maybe reset if dolargescale is true)
    ug0(k)=uu(k,1)+(uu(k,2)-uu(k,1))*coef 
    vg0(k)=vv(k,1)+(vv(k,2)-vv(k,1))*coef
   end do

! ---------------------------------------------------------------
! Initialize tendencies:


do k=1,nzm
 ttend(k)=0.
 stend(k)=0.
end do


! Large-Scale Advection Forcing:


if(dolargescale.and.time.gt.timelargescale) then

  nn=1
  do i=1,nlsf-1
   if(day.gt.dayls(i)) then
     nn=i
   endif
  end do

  do n=1,2

    m = nn+n-1

    if(zls(2,m).gt.zls(1,m)) then
     zgrid=.true.
    else if(pls(2,m).lt.pls(1,m)) then
     zgrid=.false.
    else
     if(masterproc) print*,'error in grid in lsf'
     stop
    end if
    do iz = 1,nzm
     if(zgrid) then
      do i = 2,nzlsf
       if(z(iz).le.zls(i,m)) then
         coef = (z(iz)-zls(i-1,m))/(zls(i,m)-zls(i-1,m))
         tt(iz,n)=dtls(i-1,m)+(dtls(i,m)-dtls(i-1,m))*coef
         ss(iz,n)=dsls(i-1,m)+(dsls(i,m)-dsls(i-1,m))*coef
         uu(iz,n)=ugls(i-1,m)+(ugls(i,m)-ugls(i-1,m))*coef
         vv(iz,n)=vgls(i-1,m)+(vgls(i,m)-vgls(i-1,m))*coef
         ww(iz,n)=wgls(i-1,m)+(wgls(i,m)-wgls(i-1,m))*coef
         goto 12
       endif
      end do
     else
      do i = 2,nzlsf
       if(pres(iz).ge.pls(i,m)) then
         coef = (pres(iz)-pls(i-1,m))/(pls(i,m)-pls(i-1,m))
         tt(iz,n)=dtls(i-1,m)+(dtls(i,m)-dtls(i-1,m))*coef
         ss(iz,n)=dsls(i-1,m)+(dsls(i,m)-dsls(i-1,m))*coef
         uu(iz,n)=ugls(i-1,m)+(ugls(i,m)-ugls(i-1,m))*coef
         vv(iz,n)=vgls(i-1,m)+(vgls(i,m)-vgls(i-1,m))*coef
         ww(iz,n)=wgls(i-1,m)+(wgls(i,m)-wgls(i-1,m))*coef
         goto 12
       endif
      end do
     end if
     tt(iz,n)=0.
     ss(iz,n)=0.
     uu(iz,n)=uu(iz-1,n)
     vv(iz,n)=vv(iz-1,n)
     ww(iz,n)=0.
  12 continue

    end do

   end do ! n

   coef=(day-dayls(nn))/(dayls(nn+1)-dayls(nn))
   do k=1,nzm
    ttend(k)=tt(k,1)+(tt(k,2)-tt(k,1))*coef
    stend(k)=ss(k,1)+(ss(k,2)-ss(k,1))*coef
    ug0(k)=uu(k,1)+(uu(k,2)-uu(k,1))*coef 
    vg0(k)=vv(k,1)+(vv(k,2)-vv(k,1))*coef
   end do 

   pres0 = pres0ls(nn)+(pres0ls(nn+1)-pres0ls(nn))*coef

end if 

end if ! .not.readinit
!---------------------------------------------------------------------
! Prescribed Radiation Forcing:


if(doradforcing.and.time.gt.timelargescale) then

  nn=1
  do i=1,nrfc-1
   if(day.gt.dayrfc(i)) then
     nn=i
   endif
  end do

  do n=1,2

    m = nn+n-1 

    if(prfc(2,m).gt.prfc(1,m)) then
     zgrid=.true.
    else if(prfc(2,m).lt.prfc(1,m)) then
     zgrid=.false.
    else
     if(masterproc) print*,'error in grid in rad'
     stop
    end if
    do iz = 1,nzm
     if(zgrid) then
      do i = 2,nzrfc
       if(z(iz).le.prfc(i,m)) then
        tt(iz,n)=dtrfc(i-1,m)+(dtrfc(i,m)-dtrfc(i-1,m))/(prfc(i,m)-prfc(i-1,m)) &
                                                           *(z(iz)-prfc(i-1,m))
        goto 13
       endif
      end do
     else
      do i = 2,nzrfc
       if(pres(iz).ge.prfc(i,m)) then
        tt(iz,n)=dtrfc(i-1,m)+(dtrfc(i,m)-dtrfc(i-1,m))/(prfc(i,m)-prfc(i-1,m)) &
                                                           *(pres(iz)-prfc(i-1,m))
        goto 13
       endif
      end do
     end if
     tt(iz,n)=0.
  13 continue
    end do

  end do ! n

  coef=(day-dayrfc(nn))/(dayrfc(nn+1)-dayrfc(nn))
  do k=1,nzm
    radtend=tt(k,1)+(tt(k,2)-tt(k,1))*coef
    radqrlw(k)=radtend*float(nx*ny)
    radqrsw(k)=0.
    do j=1,ny
     do i=1,nx
       t(i,j,k)=t(i,j,k)+radtend*dtn 
     end do
    end do
  end do

endif


!----------------------------------------------------------------------------
! Surface forcing:

if(dosfcforcing.and.time.gt.timelargescale) then

  if(doglobal) then

    if(daylhfobs(2).gt.0) then
      if(day.gt.daylhfobs(2)) call ocn_readsurface(lhffile,lhfobs,daylhfobs)
      coef=(day-daylhfobs(1))/(daylhfobs(2)-daylhfobs(1))
      do j=1,ny
       do i=1,nx
         if(landmask(i,j).eq.0) then
           lhf_ocn(i,j) = lhfobs(i,j,1)+(lhfobs(i,j,2)-lhfobs(i,j,1))*coef
         else
           lhf_ocn(i,j) = 0.
         end if
       end do
      end do
    end if
    if(dayshfobs(2).gt.0) then
      if(day.gt.dayshfobs(2)) call ocn_readsurface(shffile,shfobs,dayshfobs)
      coef=(day-dayshfobs(1))/(dayshfobs(2)-dayshfobs(1))
      do j=1,ny
       do i=1,nx
         if(landmask(i,j).eq.0) then
           shf_ocn(i,j) = shfobs(i,j,1)+(shfobs(i,j,2)-shfobs(i,j,1))*coef
         else
           shf_ocn(i,j) = 0.
         end if
       end do
      end do
    end if
    if(dayprecobs(2).gt.0) then
      if(day.gt.dayprecobs(2)) call ocn_readsurface(precfile,precobs,dayprecobs)
      coef=(day-dayprecobs(1))/(dayprecobs(2)-dayprecobs(1))
      do j=1,ny
       do i=1,nx
         if(landmask(i,j).eq.0) then
           prec_ocn(i,j) = max(0.,precobs(i,j,1)+(precobs(i,j,2)-precobs(i,j,1))*coef)
         else
           prec_ocn(i,j) = 0.
         end if
       end do
      end do
    end if
    if(dayroffobs(2).gt.0) then
      if(day.gt.dayroffobs(2)) call ocn_readsurface(rofffile,roffobs,dayroffobs)
      coef=(day-dayroffobs(1))/(dayroffobs(2)-dayroffobs(1))
      do j=1,ny
       do i=1,nx
         if(landmask(i,j).eq.0) then
           roff_ocn(i,j) = roffobs(i,j,1)+(roffobs(i,j,2)-roffobs(i,j,1))*coef
         else
           roff_ocn(i,j) = 0.
         end if
       end do
      end do
    end if
    if(daylwobs(2).gt.0) then
      if(day.gt.daylwobs(2)) call ocn_readsurface(lwfile,lwobs,daylwobs)
      coef=(day-daylwobs(1))/(daylwobs(2)-daylwobs(1))
      do j=1,ny
       do i=1,nx
         if(landmask(i,j).eq.0) then
           lw_ocn(i,j) = lwobs(i,j,1)+(lwobs(i,j,2)-lwobs(i,j,1))*coef &
              - 5.67e-8*(sstxy(i,j)+273.16)**4
         else
           lw_ocn(i,j) = 0.
         end if
       end do
      end do
    end if
    if(dayswobs(2).gt.0) then
      if(day.gt.dayswobs(2)) call ocn_readsurface(swfile,swobs,dayswobs)
      coef=(day-dayswobs(1))/(dayswobs(2)-dayswobs(1))
      do j=1,ny
       do i=1,nx
         if(landmask(i,j).eq.0) then
           sw_ocn(i,j) = 0.94*(swobs(i,j,1)+(swobs(i,j,2)-swobs(i,j,1))*coef)
         else
           sw_ocn(i,j) = 0.
         end if
       end do
      end do
    end if
    if(daytauxobs(2).gt.0) then
      if(day.gt.daytauxobs(2)) call ocn_readsurface(tauxfile,tauxobs,daytauxobs)
      coef=(day-daytauxobs(1))/(daytauxobs(2)-daytauxobs(1))
      do j=1,ny
       do i=1,nx
         if(landmask(i,j).eq.0) then
           taux_ocn(i,j) = tauxobs(i,j,1)+(tauxobs(i,j,2)-tauxobs(i,j,1))*coef
         else
           taux_ocn(i,j) = 0.
         end if
       end do
      end do
    end if
    if(daytauyobs(2).gt.0) then
      if(day.gt.daytauyobs(2)) call ocn_readsurface(tauyfile,tauyobs,daytauyobs)
      coef=(day-daytauyobs(1))/(daytauyobs(2)-daytauyobs(1))
      do j=1,ny
       do i=1,nx
         if(landmask(i,j).eq.0) then
           tauy_ocn(i,j) = tauyobs(i,j,1)+(tauyobs(i,j,2)-tauyobs(i,j,1))*coef
         else
           tauy_ocn(i,j) = 0.
         end if
       end do
      end do
    end if
    if(dayqobs(2).gt.0) then
      if(day.gt.dayqobs(2)) call ocn_readsurface(qfile,qobs,dayqobs)
      coef=(day-dayqobs(1))/(dayqobs(2)-dayqobs(1))
      do j=1,ny
       do i=1,nx
         if(landmask(i,j).eq.0) then
           q_atm(i,j) = max(0.,qobs(i,j,1)+(qobs(i,j,2)-qobs(i,j,1))*coef)
         else
           q_atm(i,j) = 0.
         end if
       end do
      end do
    end if
    if(daytobs(2).gt.0) then
      if(day.gt.daytobs(2)) call ocn_readsurface(tfile,tobs,daytobs)
      coef=(day-daytobs(1))/(daytobs(2)-daytobs(1))
      do j=1,ny
       do i=1,nx
         if(landmask(i,j).eq.0) then
           t_atm(i,j) = tobs(i,j,1)+(tobs(i,j,2)-tobs(i,j,1))*coef
         else
           t_atm(i,j) = 0.
         end if
       end do
      end do
    end if
    if(dayuobs(2).gt.0) then
      if(day.gt.dayuobs(2)) call ocn_readsurface(ufile,uobs,dayuobs)
      coef=(day-dayuobs(1))/(dayuobs(2)-dayuobs(1))
      do j=1,ny
       do i=1,nx
         if(landmask(i,j).eq.0) then
           u_atm(i,j) = uobs(i,j,1)+(uobs(i,j,2)-uobs(i,j,1))*coef
         else
           u_atm(i,j) = 0.
         end if
       end do
      end do
    end if
    if(dayvobs(2).gt.0) then
      if(day.gt.dayvobs(2)) call ocn_readsurface(vfile,vobs,dayvobs)
      coef=(day-dayvobs(1))/(dayvobs(2)-dayvobs(1))
      do j=1,ny
       do i=1,nx
         if(landmask(i,j).eq.0) then
           v_atm(i,j) = vobs(i,j,1)+(vobs(i,j,2)-vobs(i,j,1))*coef
         else
           v_atm(i,j) = 0.
         end if
       end do
      end do
    end if

  else if(.not.doglobal) then

    nn=1
    do i=1,nsfc-1
      if(day.gt.daysfc(i)) then
        nn=i
      endif
    end do

    coef=(day-daysfc(nn))/(daysfc(nn+1)-daysfc(nn))
    tabs_s=sstsfc(nn)+(sstsfc(nn+1)-sstsfc(nn))*coef
    fluxt0=(shsfc(nn)+(shsfc(nn+1)-shsfc(nn))*coef)/(rhow(1)*cp)
    fluxq0=(lhsfc(nn)+(lhsfc(nn+1)-lhsfc(nn))*coef)/(rhow(1)*lcond)
    taux0=tauxsfc(nn)+(tauxsfc(nn+1)-tauxsfc(nn))*coef
    tauy0=tauysfc(nn)+(tauysfc(nn+1)-tauysfc(nn))*coef

    if(dostatis) then
      sst1obs = tabs_s  ! sst is not averaged over the sampling period
      lhobs = lhobs + fluxq0 * rhow(1)*lcond
      shobs = shobs + fluxt0 * rhow(1)*cp
    end if

  end if ! doglobal

  if(dooceanonly.and.readq.and.readt.and.readu.and.readv) then
    call ocn_surface()
  end if

endif ! dosfcforcing.and.time.gt.timelargescale



! apply surface fluxes and precipitation

if(.not.SFC_FLX_FXD) then
 where(seaicemask(1:nx,1:ny).eq.0)
  fluxtt(1:nx,1:ny) = (shf_ocn(1:nx,1:ny)+lhf_ocn(1:nx,1:ny))/(rhow(nz)*cpw)
  fluxts(1:nx,1:ny) = s(1:nx,1:ny,nzm)*(prec_ocn(1:nx,1:ny)+roff_ocn(1:nx,1:ny) &
                      -lhf_ocn(1:nx,1:ny)/lcond)/rhow(nz)
 elsewhere
  fluxtt(1:nx,1:ny) = 0.
  fluxts(1:nx,1:ny) = 0.
 end where
else
  fluxtt(1:nx,1:ny) = fluxt0
  fluxts(1:nx,1:ny) = 0.
end if
if(.not.SFC_TAU_FXD) then
 where(seaicemask(1:nx,1:ny).eq.0)
  fluxtu(1:nx,1:ny) = taux_ocn(1:nx,1:ny)/rhow(nz)
  fluxtv(1:nx,1:ny) = tauy_ocn(1:nx,1:ny)/rhow(nz)
 elsewhere
  fluxtu(1:nx,1:ny) = 0.
  fluxtu(1:nx,1:ny) = 0
 end where
else
  fluxtu(1:nx,1:ny) = taux0/rhow(nz)
  fluxtv(1:nx,1:ny) = tauy0/rhow(nz)
end if

shf_xy(:,:) = shf_xy(:,:) + shf_ocn(:,:)*dtfactor
lhf_xy(:,:) = lhf_xy(:,:) + lhf_ocn(:,:)*dtfactor
prec_xy(:,:) = prec_xy(:,:) + prec_ocn(:,:)*dtfactor
roff_xy(:,:) = roff_xy(:,:) + roff_ocn(:,:)*dtfactor
taux_xy(:,:) = taux_xy(:,:) + taux_ocn(:,:)*dtfactor
tauy_xy(:,:) = tauy_xy(:,:) + tauy_ocn(:,:)*dtfactor
uatm_xy(:,:) = uatm_xy(:,:) + u_atm(:,:)*dtfactor
vatm_xy(:,:) = vatm_xy(:,:) + v_atm(:,:)*dtfactor
tatm_xy(:,:) = tatm_xy(:,:) + t_atm(:,:)*dtfactor
qatm_xy(:,:) = qatm_xy(:,:) + q_atm(:,:)*dtfactor
seaicefrac_xy(:,:) = seaicefrac_xy(:,:) + seaicemask(:,:)*dtfactor
seaicethic_xy(:,:) = seaicethic_xy(:,:) + h_seaice(:,:)*dtfactor
!-------------------------------------------------------------------------------
call t_stopf ('ocn_forcing')

end subroutine ocn_forcing
