subroutine ocn_initialize()

!  Initialize ocean model

use ocn_vars
use ocn_hbuffer
use ocn_sgs
use ocn_tracers
implicit none

call t_startf ('ocn_initialize')

call ocn_init()     ! allocate major arrays, initialize some statistics arrays
call ocn_setparm()! set all parameters and constants

!------------------------------------------------------------------
! Initialize or restart from the save-dataset:

if(nrestart.eq.0) then
   day=day0 
   call ocn_setsurface() ! set surface mask, sst, terrain, SLM, etc
   call ocn_setgrid() ! initialize vertical grid structure and terrain arrays
   call ocn_setdata() ! initialize all variables
elseif(nrestart.eq.1) then
   call ocn_read_all()
   call ocn_setsurface()
   call ocn_setgrid() 
   call ocn_diagnose()
   call ocn_sgs_init()
elseif(nrestart.eq.2) then  ! branch run
   call ocn_read_all()
   call ocn_setgrid() 
   call ocn_diagnose()
   call ocn_setparm() ! overwrite the parameters
   call ocn_setperturb()
   call ocn_sgs_init()
   nstep = 0
   day0 = day
else
   print *,'Error: confused by value of NRESTART'
   call task_abort() 
endif

call ocn_stat_2Dinit()
call ocn_tracers_init() ! initialize tracers
call ocn_setforcing()
if(masterproc) call ocn_printout()
!------------------------------------------------------------------
!  Initialize statistics buffer:

call ocn_hbuf_init()

!------------------------------------------------------------------
nstatsteps = -1

nstatis = nstat/nstatfrq
nstat = nstatis * nstatfrq
nstatsteps = 0

if(doterrain) call ocn_terrain_fill()

call t_stopf ('ocn_initialize')

end 
