subroutine ocn_press_grad

!       pressure term of the momentum equations

use ocn_vars
implicit none

real(8) rdx,rdy,rdz
integer i,j,k,kb,jb,ib

do k=1,nzm
 kb=max(1,k-1)
 rdz = 1./(dz*adzw(k))
 do j=1,ny
  jb=j-YES3D
  rdx=imu(j)/dx
  rdy=1./(dy*adyv(j))
  do i=1,nx
   ib=i-1
   u(i,j,k)=u(i,j,k)-dt3(na)*at*(p(i,j,k,na)-p(ib,j,k,na))*rdx
   v(i,j,k)=v(i,j,k)-dt3(na)*at*(p(i,j,k,na)-p(i,jb,k,na))*rdy
   w(i,j,k)=w(i,j,k)-dt3(na)*at*(p(i,j,k,na)-p(i,j,kb,na))*rdz
  end do ! i
 end do ! j
end do ! k

call task_barrier()

end subroutine ocn_press_grad



