
subroutine ocn_press_grad_sfc

! pressure gradiaent force due to surface difference in height

use ocn_vars
use ocn_params, only:  ggr
use ocn_check_energy
use ocn_toplayer, only: h

implicit none
	
integer i,j,jb,ib
real rdx, rdy
	
call ocn_sumenergy(1,'ocn_pres_grad_sfc')

do j=1,ny
 jb=j-YES3D
 rdx=ggr*imu(j)/dx
 rdy=ggr/(dy*adyv(j))
 do i=1,nx
   ib=i-1
   dudt(i,j,:,na)=dudt(i,j,:,na)-(h(i,j)-h(ib,j))*rdx       
   dvdt(i,j,:,na)=dvdt(i,j,:,na)-(h(i,j)-h(i,jb))*rdy       
 end do ! i
end do ! j     

call ocn_sumenergy(-1,'con_pres_grad_sfc')
	
end subroutine 

