
subroutine ocn_press_rhs(ppp)

!       right-hand-side of the Poisson equation for pressure

use ocn_vars
use ocn_terrain, only: terrau, terrav, terraw
use ocn_params, only: dowallx, dowally, doterrain

implicit none
	
real, intent(out) :: ppp(nx,ny,nzm)

real(8) dta,rdx,rdy,rdz
integer i,j,k,ic,jc,kc

if(dowallx.and.mod(rank,nsubdomains_x).eq.0) then

    do k=1,nzm
     do j=1,ny
      u(1,j,k) = 0.
     end do
    end do	

end if

if(dowally.and.RUN3D.and.rank.lt.nsubdomains_x) then

    do k=1,nzm
     do i=1,nx
      v(i,1,k) = 0.
     end do
    end do	

end if


if(dompi) then
   call ocn_task_bound_duvdt()
else
   call ocn_bound_duvdt()	   
endif

dta=1./dt3(na)

! compute r.h.s. of Poisson equation for pressure:

if(RUN3D) then

do k=1,nzm
 kc=k+1 
 rdz=1./(adz(k)*dz)
 do j=1,ny
  jc=j+1 
  rdx=imu(j)/dx
  rdy=imu(j)/(dy*ady(j))
  do i=1,nx
   ic=i+1
   ppp(i,j,k)=(rdx*(u(ic,j,k)-u(i,j,k))+ &
             rdy*(muv(jc)*v(i,jc,k)-muv(j)*v(i,j,k))+ &
             rdz*(w(i,j,kc)-w(i,j,k)))*dta
  end do
 end do
end do

else

j=1

rdx = 1./dx
do k=1,nzm
 kc=k+1 
 rdz=1./(adz(k)*dz)
 do i=1,nx
  ic=i+1
   ppp(i,j,k)=(rdx*(u(ic,j,k)-u(i,j,k))+ &
             rdz*(w(i,j,kc)-w(i,j,k)))*dta
 end do
end do

endif

call task_barrier()

end subroutine ocn_press_rhs
