subroutine ocn_pressure

! call ocn_a pressure solver

use ocn_vars
use ocn_grid
use ocn_params, only: dolatlon,doflat,dowallx,dowally
use ocn_check_energy
implicit none
integer i,j,k

call t_startf ('ocn_pressure')

call ocn_sumenergy(1,'pressure:')

if(RUN3D) then
  if(dolatlon.or.doyvar) then
     if(doflat) then
       call ocn_pressure_big(.false.)
     else
       call ocn_pressure_gmg(.false.)
     end if
  else
     call ocn_pressure_big(.false.)
  end if
else
    if(masterproc) print*, 'there is no 2D version of ocean'
    stop
!    call ocn_pressure_orig()
end if

if(dowallx.and.mod(rank,nsubdomains_x).eq.0) then

    do k=1,nzm
     do j=1,ny
      dudt(1,j,k,na) = 0.
      u(1,j,k) = 0.
     end do
    end do

end if

if(dowally.and.RUN3D.and.rank.lt.nsubdomains_x) then

    do k=1,nzm
     do i=1,nx
      dvdt(i,1,k,na) = 0.
      v(i,1,k) = 0.
     end do
    end do

end if

call ocn_sumenergy(-1,'pressure:')

call t_stopf ('ocn_pressure')

end
