	subroutine ocn_printout()

	use ocn_vars
        use ocn_tracers
	use ocn_params
        use ocn_sgs, only: dosmagor
	implicit none
        integer k
	
	print*,'=================================================='
	print*,'Ocean Model parameter'
        print*
	print*,'Case: ',trim(case)
	print*,'Caseid: ',trim(caseid)
        select case (nrestart) 
	case(0) 
	  print*,'New Run.'
	case(1)
	  print*,'Restart. nrestart=',nrestart
	case(2) 
          print*,'Branch run Restart Case:',trim(case_restart)
          print*,'Case-ID:',trim(caseid_restart)
        end select

        print*,'doterrain=',doterrain
        if(doterrain) print*,'terrain_type=',terrain_type

	print*, 'Statistics file ouput frequency: ',nstat,' steps'
	print*, 'Statistics file sampling: every ',nstatfrq,' steps'
	
	if(nadams.eq.2.or.nadams.eq.3) then
	   print*, 'Adams-Bashforth scheme order:',nadams
	else
	   print*, 'Error: nadams =',nadams
	   call task_abort()
	endif 
	  	
	if(dx.gt.0.and.dy.gt.0.and.dz.gt.0. ) then
	   print*, 'Global Grid:',nx_gl,ny_gl,nz_gl
	   print*, 'Local Grid:',nx,ny,nzm
           print*,'dx, dy, dz:',dx,dy,dz
           print*,'Leyer centers: (z, pres):'
           do k=nzm,1,-1
            print*,k,zi(nz)-z(k),pres(k)
           end do
           print*
           print*,'Layer interfaces: (zi, presi):'
           do k=nz,1,-1
            print*,k,zi(nz)-zi(k),presi(k)
           end do
	else
	   print*, 'Error: grid spacings dx, dy, dz:',dx, dy, dz
	   call task_abort()
	endif
        print*
        print*,'dowallx=',dowallx
        print*,'dowally=',dowally
        print*	
	print*, 'do column model', docolumn

	print*, 'do spange damping at the domain top: ', dodamping
	print*, 'do spange damping near pole walls: ', dodamping_poles
	print*, 'maintain grad. of scalars at the top:',doupperbound
	print*, 'SGS scheme is on:',dosgs
	print*, 'dosmagor:',dosmagor
	print*, 'larger-scale tendency is on:',dolargescale
        if(doradforcing.and.(dolongwave.or.doshortwave)) then
          print*, 'prescribed rad. forcing and radiation '// &
          'calculations cannot be done at the same time.'
          call task_abort()
        endif
        if(dolongwave) print*, 'longwave radiation:',dolongwave  
        if(doshortwave) then
            print*, 'shortwave radiation:',doshortwave
	endif
        print*,'doimplicitdiff = ',doimplicitdiff
        print*,'doradsimple = ',doradsimple
        print*,'doradhomo =',doradhomo
        print*,'rundatadir = ',trim(rundatadir)
        if(doradforcing) print*, 'radiation forcing is prescribed'
	print*,'surface flux parameterization is on:',dosurface
        if(dosurface) then
            print*, ' sensible heat flux prescribed:',SFC_FLX_FXD
            if(SFC_FLX_FXD.and..not.dosfcforcing) print*, 'fluxt0 (W/m2)=',fluxt0*rhow(1)*cp
            print*, ' latent heat flux prescribed:',SFC_FLX_FXD
            if(SFC_FLX_FXD.and..not.dosfcforcing) print*, 'fluxq0 (W/m2)=',fluxq0*rhow(1)*lcond
            print*, ' surface stress prescribed:',SFC_TAU_FXD
            if(SFC_TAU_FXD.and..not.dosfcforcing) print*, 'taux0 (m2/s2)=',taux0
            if(SFC_TAU_FXD.and..not.dosfcforcing) print*, 'tauy0 (m2/s2)=',tauy0
            print*,'dosfchomo = ',dosfchomo
        endif
        if(dosurface.and.dosfcforcing) then
          print*,'surface temperature prescribed: T'
!          if(.not.doglobal) then
!            if(day.lt.daysfc(1).or.day+(nstop-nstep)*dt/86400..gt.daysfc(nsfc)) then
!             print*,'Error: simulation time (from start to stop)'// &
!              'can be beyond the sfc forcing intervals'
!             print*,'current day=',day
!             print*,'stop day=',day+(nstop-nstep)*dt/86400.
!             print*,'sfc forcing:start =',daysfc(1)
!             print*,'sfc forcing:  end =',daysfc(nsfc)
!             call task_abort()
!            end if
!          endif
        endif
!        if(doradforcing) then
!          if ( day.lt.dayrfc(1) &
!            .or.day+(nstop-nstep)/86400.*dt.gt.dayrfc(nrfc))then
!             print*,'Error: simulation time (from start to stop)'// &
!              'can be beyond the rad. forcing intervals'
!             print*,'current day=',day
!             print*,'stop day=',day+(nstop-nstep-1)*dt/86400.
!             print*,'rad forcing:start =',dayrfc(1)
!             print*,'rad forcing:  end =',dayrfc(nrfc)
!             call task_abort()
!          endif
!       endif

	if(donudging_uv) print*, 'Nudging of U and V:', donudging_uv
	if(donudging_uv) print*,'tauls = ',tauls
	if(donudging_ts) print*, 'Nudging of T and S:', donudging_ts

        print*,'docoriolis=',docoriolis

        print*,'dotracers =',dotracers
        if(dotracers) then
           if(ntracers.eq.0) then
             print*,'dotracers is set to .true., yet ntracers = 0. Aborting ...'
             call task_abort()
           end if
           print*,ntracers, ' tracers are included'
           print*,'Tracer names:',tracername(1:ntracers)
        end if
        print*,'perturb_type = ',perturb_type
        print*,'nsave2D = ',nsave2D
        print*,'nsave2Dstart = ',nsave2Dstart
        print*,'nsave2Dend = ',nsave2Dend
        print*,'save2Dbin = ',save2Dbin
        print*,'nsave3D = ',nsave3D
        print*,'nsave3Dstart = ',nsave3Dstart
        print*,'nsave3Dend = ',nsave3Dend
        print*,'save3Dbin = ',save3Dbin
        print*,'docolumn = ',docolumn
        print*,'doensemble = ',doensemble
        print*,'nensemble = ',nensemble
	print*,'==== End of OCEAN Parameters ================================'
        
	return
	end

