subroutine ocn_refprof()

! compute reference pfofiles for each of the nasins.
use ocn_vars
use ocn_terrain
implicit none

real(8) rhob(nzm),sumb(nzm),tmp,ccc(nx,ny)
real(8) buffer(2*nzm), buffer1(2*nzm)
integer nbasins
integer i,j,k,m,kk

call t_startf ('ocn_refprof')

nbasins = maxval(basins)
if(dompi) then
  call task_max_integer(nbasins,i,1)
  nbasins = i
end if
if(masterproc) print*,'nbasins=',nbasins

rhoo0(:,:,:) = rhoo(:,:,:)

do m=1,nbasins
 rhob(:) = 0.
 sumb(:) = 0.
 where(basins.eq.m) 
   ccc = 1.
 elsewhere
   ccc = 0.
 end where
 do k=1,nzm
  do j=1,ny
   do i=1,nx
    tmp = mu(j)*terra(i,j,k)*ccc(i,j)
    rhob(k)=rhob(k)+rhoo(i,j,k)*tmp
    sumb(k)=sumb(k)+tmp 
   end do
  end do
 end do
 if(dompi) then
    buffer(1:nzm) = rhob(1:nzm)
    buffer(nzm+1:2*nzm) = sumb(1:nzm)
    call task_sum_real8(buffer,buffer1,nzm*2)
    rhob(1:nzm) = buffer1(1:nzm)
    sumb(1:nzm) = buffer1(nzm+1:2*nzm)
 end if
 rhob(:)=rhob(:)/(sumb(:)+1.e-9)
 do k=1,nzm
  kk=k
  if(sumb(k).gt.0) exit 
 end do
! if(masterproc) print*,'basin=',m,rhob(kk:)
 do j=1,ny
   do i=1,nx
    rhoo0(i,j,kk:)=rhoo0(i,j,kk:)*(1.-ccc(i,j))+rhob(kk:)*ccc(i,j)
   end do
 end do
end do

call ocn_fminmax_print('rhoo0:',rhoo0(1:nx,1:ny,1:nzm),1,nx,1,ny,nzm)

call t_stopf ('ocn_refprof')
end

