        subroutine ocn_write_all()

        use ocn_vars
        implicit none
        character *4 rankchar
        character *256 filename
        integer irank

        call t_startf ('restart_out')

        if(masterproc) then
         print*,'Writing restart file ...'
         filename = './RESTART/'//trim(case)//'_'//trim(caseid)//'_misc_restart.ocn.bin'
         open(66,file=trim(filename), status='unknown',form='unformatted')
        end if


        if(restart_sep) then

          write(rankchar,'(i4)') rank

          filename = './RESTART/'//trim(case)//'_'//trim(caseid)//'_'//&
                rankchar(5-lenstr(rankchar):4)//'_restart.ocn.bin'


          open(65,file=trim(filename), status='unknown',form='unformatted')
          write(65) nsubdomains, nsubdomains_x, nsubdomains_y

          call ocn_write_statement(.false.)


        else
          write(rankchar,'(i4)') nsubdomains
          filename = './RESTART/'//trim(case)//'_'//trim(caseid)//'_'//&
                rankchar(5-lenstr(rankchar):4)//'_restart.ocn.bin'

          do irank=0,nsubdomains-1

             call task_barrier()

             if(irank.eq.rank) then

               if(masterproc) then
      
                open(65,file=trim(filename), status='unknown',form='unformatted')
                write(65) nsubdomains, nsubdomains_x, nsubdomains_y

               else

                open(65,file=trim(filename), status='unknown',form='unformatted',&
                   position='append')

               end if

               call ocn_write_statement(.false.)

             end if
          end do

        end if ! restart_sep

        call task_barrier()

        call t_stopf ('restart_out')

        return
        end
 
 
 
 
     
        subroutine ocn_read_all()

        use ocn_vars
        implicit none
        character *4 rankchar
        character *256 filename
        integer irank, ii

        if(masterproc) print*,'Reading restart file ...'

        if(nrestart.ne.2) then
          filename = './RESTART/'//trim(case)//'_'//trim(caseid)//'_misc_restart.ocn.bin'
        else
          filename = './RESTART/'//trim(case_restart)//'_'//trim(caseid_restart)//'_misc_restart.ocn.bin'
        end if
        open(66,file=trim(filename), status='old',form='unformatted')


        if(restart_sep) then

           write(rankchar,'(i4)') rank

           if(nrestart.ne.2) then
             filename = './RESTART/'//trim(case)//'_'//trim(caseid)//'_'//&
                  rankchar(5-lenstr(rankchar):4)//'_restart.ocn.bin'
           else
             filename = './RESTART/'//trim(case_restart)//'_'//trim(caseid_restart)//'_'//&
                  rankchar(5-lenstr(rankchar):4)//'_restart.ocn.bin'
           end if


           open(65,file=trim(filename), status='old',form='unformatted')
           read(65)

           call ocn_read_statement(.false.)


        else

          write(rankchar,'(i4)') nsubdomains

          if(nrestart.ne.2) then
            filename='./RESTART/'//trim(case)//'_'//trim(caseid)//'_'//&
                  rankchar(5-lenstr(rankchar):4)//'_restart.ocn.bin'
          else
            filename='./RESTART/'//trim(case_restart)//'_'//trim(caseid_restart)//'_'//&
                  rankchar(5-lenstr(rankchar):4)//'_restart.ocn.bin'
          end if
          open(65,file=trim(filename), status='old',form='unformatted')

          do irank=0,nsubdomains-1

             call task_barrier()

             if(irank.eq.rank) then

               read (65)
 
               do ii=0,irank-1 ! skip records
                 read(65)
               end do

               call ocn_read_statement(.false.)

             end if

          end do

        end if ! restart_sep

        call task_barrier()

        dtfactor = -1.

       ! update the boundaries 
       ! (just in case when some parameterization initializes and needs boundary points)

        call ocn_boundaries(1)
        call ocn_boundaries(4)

        return
        end
 



        subroutine ocn_write_statement(dogenrestart)

        use ocn_vars
        use ocn_sgs, only: sgs_field, nsgs_fields, sgs_field_diag, nsgs_fields_diag
        use ocn_tracers
        use ocn_params
        use ocn_terrain
        use ocn_toplayer
        implicit none
        logical, intent(in) ::  dogenrestart
        integer ntape, k

        write(65)  rank, &
           u, v, w, t, p, pfy, s, dudt, dvdt, dwdt, rhoo0, tracer, sgs_field, sgs_field_diag, &
           h, h0, hu, hv, terraul, terraur, terravl, terravr
          close(65)
        if(masterproc) write(66) dt
        ntape = 66
        if(masterproc) then
           write(ntape) version, &
            z, zi, adz, adzw, pres, presi, rho, rhow,  &
            bet, nx, ny, nz, at, bt, ct, dtn, dt3, ncycle3, time, dz, doconstdz, &
            nstep, na, nb, nc, caseid, case, &
            dodamping, doupperbound, doradhomo, dosfchomo,&
            dolongwave, doshortwave, dosgs, dotracers, &
            docoriolis, dosurface, dolargescale,doradforcing, dossthomo, &
            dosfcforcing, doradsimple, donudging_uv, donudging_ts, &
            docup, docolumn, readterr, &
            pres0, tabs_s, z0, gmg_precision, &
            fluxt0, fluxq0, taux0, tauy0, tauls, tautsls, timelargescale, &
            nudging_uv_z1, nudging_uv_z2, donudging_t, donudging_s, &
            nudging_t_z1, nudging_t_z2, nudging_s_z1, nudging_s_z2, &
            sfc_flx_fxd, sfc_tau_fxd, doimplicitdiff, &
            dodamping_w, dodamping_u, damping_u_cu, damping_w_cu, &
            doterrain, dobufferzone, bufferzonex, bufferzoney, dohyper, dohyper_terr, &
            readq, readt, readlhf, readshf, readprec, readroff, &
            readlw, readsw, readu, readv, readtaux, readtauy, readbasins, &
            qfile, tfile, lhffile, shffile, precfile, rofffile, &
            lwfile, swfile, ufile, vfile, tauxfile, tauyfile, basinsfile, &
            hyper_coef, readterr, terrainfile, &
            ntracers, nsgs_fields, nsgs_fields_diag
            close(ntape)
        end if
        if(rank.eq.nsubdomains-1) then
            print *,'Restart file was written at  nstep=',nstep
        endif
        return
        end


        subroutine ocn_read_statement(dogenrestart)

        use ocn_vars
        use ocn_sgs, only: sgs_field, nsgs_fields, sgs_field_diag, nsgs_fields_diag
        use ocn_tracers
        use ocn_params
        use ocn_toplayer
        implicit none
        logical, intent(in) ::  dogenrestart

        integer  ntape, nx1, ny1, nz1, rank1, ntr, nmic, nsgs, nsgsd, k
        character(sizeof(case)) case1
        character(sizeof(caseid)) caseid1
        character(sizeof(version)) version1
        character(sizeof(terrainfile)) terrainfile1

        read(65)  rank1, &
           u, v, w, t, p, pfy, s, dudt, dvdt, dwdt, rhoo0, tracer, sgs_field, sgs_field_diag, &
           h, h0, hu, hv, terraul, terraur, terravl, terravr
          close(65)
        read(66) dt
        ntape = 66
        read(ntape) version1, &
            z, zi, adz, adzw, pres, presi, rho, rhow,  &
            bet, nx1, ny1, nz1, at, bt, ct, dtn, dt3, ncycle3, time, dz, doconstdz, &
            nstep, na, nb, nc, caseid1, case1, &
            dodamping, doupperbound, doradhomo, dosfchomo,&
            dolongwave, doshortwave, dosgs, dotracers, &
            dosurface, dolargescale,doradforcing, dossthomo, &
            dosfcforcing, doradsimple, donudging_uv, donudging_ts, &
            docup, docolumn, readterr, &
            pres0, tabs_s, z0, gmg_precision, &
            fluxt0, fluxq0, taux0, tauy0, tauls, tautsls, timelargescale, &
            nudging_uv_z1, nudging_uv_z2, donudging_t, donudging_s, &
            nudging_t_z1, nudging_t_z2, nudging_s_z1, nudging_s_z2, &
            sfc_flx_fxd, sfc_tau_fxd, doimplicitdiff, &
            dodamping_w, dodamping_u, damping_u_cu, damping_w_cu, &
            doterrain, dobufferzone, bufferzonex, bufferzoney, dohyper, dohyper_terr, &
            readq, readt, readlhf, readshf, readprec, readroff, &
            readlw, readsw, readu, readv, readtaux, readtauy, readbasins, &
            qfile, tfile, lhffile, shffile, precfile, rofffile, &
            lwfile, swfile, ufile, vfile, tauxfile, tauyfile, basinsfile, &
            hyper_coef, readterr, terrainfile1, &
            ntr, nmic, nsgs, nsgsd
        close(ntape)

        if(version1.ne.version) then
          if(masterproc)print *,'Wrong restart file!'
          if(masterproc)print *,'Version of SAM that wrote the restart files:',version1
          if(masterproc)print *,'Current version of SAM',version
          call task_abort()
        end if
        if(nrestart.eq.1) then
         if(case.ne.case1) then
           if(masterproc)print*,'Case is wrong for the restart. Quitting...' 
           if(masterproc)print*,'Required case:',case 
           call task_abort()
         end if 
         if(caseid.ne.caseid1) then
           if(masterproc)print*,'Caseid is wrong for the restart. Quitting...' 
           if(masterproc)print*,'Required caseid:',caseid 
           call task_abort()
         end if 
         if(readterr.and.terrainfile.ne.terrainfile1) then
           if(masterproc)print*,'specified terrainfile name is wrong for the restart. ' 
           if(masterproc)print*,'Required file:',terrainfile1,' Quitting...' 
           call task_abort()
         end if 
        end if
        if(nrestart.ne.2) then
          if(rank.ne.rank1) then
             if(masterproc)print *,'Error: rank of restart data is not the same as rank of the process'
             if(masterproc)print *,'rank1=',rank1,'   rank=',rank
          endif
          if(nx.ne.nx1.or.ny.ne.ny1.or.nz.ne.nz1) then
             if(masterproc)print *,'Error: domain dims (nx,ny,nz) set by grid.f'
             if(masterproc)print *,' not correspond to ones in the restart file.'
             if(masterproc)print *,'in executable:   nx, ny, nz:',nx,ny,nz
             if(masterproc)print *,'in restart file: nx, ny, nz:',nx1,ny1,nz1
             if(masterproc)print *,'Exiting...'
             call task_abort()
          endif
        end if
        if(nsgs.ne.nsgs_fields.or.nsgsd.ne.nsgs_fields_diag) then
           if(masterproc)print*,'Error: number of sgs_field in restart file is not the same as nsgs_fields'
           if(masterproc)print*,'nsgs_fields=',nsgs_fields,'   in reastart file=',nsgs
           if(masterproc)print*,'nsgs_fields_diag=',nsgs_fields_diag,'   in file=',nsgsd
           if(masterproc)print*,'Exiting...'
             call task_abort()
        end if
        if(ntr.ne.ntracers) then
           if(masterproc)print*,'Error: number of tracers in restart file is not the same as ntracers.'
           if(masterproc)print*,'ntracers=',ntracers,'   ntracers(in file)=',ntr
           if(masterproc)print*,'Exiting...'
             call task_abort()
        end if
        close(65)
        if(rank.eq.nsubdomains-1) then
           print *,'Case:',caseid
           print *,'Restarting at step:',nstep
           print *,'Time(s):',nstep*dt
        endif
        if(masterproc) print*,'Done...'

        return
        end
 

subroutine ocn_restart_write_field3D (ntape,f,nlevs)

! write full global arrays into a general
! (not dependent on number of PEs) restart file

use ocn_grid, only: masterproc, nx, ny, nx_gl, ny_gl, rank, nsubdomains
implicit none
! Input:

integer ntape
real f(nx,ny,nlevs)
integer nlevs,req

! Local:

real(4),allocatable ::  fld(:,:)
real(4) ::  buf(nx,ny)
integer irank,ranksource,tagsource,ii,jj,k

if(masterproc) write(ntape) nlevs
do k=1,nlevs
   if(masterproc) then
     allocate(fld(1:nx_gl,1:ny_gl))
     fld(1:nx,1:ny) = f(:,:,k)
   end if
   do irank = 1, nsubdomains-1
       call task_barrier()
       if(irank.eq.rank) then
         call ocn_task_bsend_float(0,f(:,:,k),nx*ny,irank)
       end if
       if(masterproc) then
         call ocn_task_receive_float(buf(:,:),nx*ny,req)
         call task_wait(req,ranksource,tagsource)
         call task_rank_to_index(ranksource,ii,jj)
         fld(ii+1:ii+nx,jj+1:jj+ny) = buf(:,:)
       end if
   end do
   if(masterproc) then
     write(ntape) fld
     deallocate(fld)
   end if
end do

end


subroutine ocn_restart_read_field3D (ntape,f,nxr,nyr,nlevs)

! read arrays from a general
! (not dependent on number of PEs) restart file
! without interpolation

use ocn_grid, only: nx, ny, nx_gl, ny_gl, rank
implicit none
! Input:

integer ntape
real f(nx,ny,nlevs)
integer nxr,nyr ! size of arrays in restart file
integer nlevs


! Local:

real(4),allocatable ::  fld(:,:)
integer nlevs1,ii,jj,iii,jjj,k,i,j

allocate(fld(nxr,nyr))

call task_rank_to_index(rank,iii,jjj)
read(ntape) nlevs1
if(nlevs.ne.nlevs1) then
  print*,'Restart_read_field3D: error: nlevs.ne.nlevs1. nlevs=',nlevs,' nlevs1=',nlevs1,' quitting...'
  call task_abort
end if
ii=nx_gl/nxr
jj=ny_gl/nyr
do k=1,nlevs
  read(ntape) fld
  f(1:nx:ii,1:ny:jj,k) = fld(iii/ii+1:(iii+nx)/ii,jjj/jj+1:(jjj+ny)/jj)
  do j=1,ny
   do i=1,nx
     f(i,j,k)=f(i-mod(i-1,ii),j-mod(j-1,jj),k)
   end do
  end do
end do

deallocate(fld)
end

