subroutine ocn_setdata()
	
use gsw_mod_kinds, only: r8
use ocn_vars
use ocn_params
use ocn_terrain
use gsw_mod_toolbox, only: gsw_sa_from_sp, gsw_ct_from_pt, &
                           gsw_t_from_ct, gsw_ct_from_t, gsw_rho
use ocn_sgs, only: ocn_sgs_init, ocn_sgs_proc
use vars, only: sstxy
use vars, only: roff_ocn, lhf_ocn, shf_ocn, prec_ocn,  &
                sw_ocn, lw_ocn, taux_ocn, tauy_ocn

implicit none
	
integer ndmax,n,i,j,k,kb,iz,it,jt
real presr(nz)	
parameter (ndmax = 1000)
real zz(ndmax),tt(ndmax),ss(ndmax),uu(ndmax),vv(ndmax) 
real zz1(ndmax),tt1(ndmax),ss1(ndmax),uu1(ndmax),vv1(ndmax) 
real rrr1,rrr2, pres1, ta(ndmax)
real ratio_t1,ratio_t2,ratio_p1,ratio_p2,rdx,rdy
real tmp(nx,ny,nzm),tmpz(ny,nzm)
integer nx1,ny1,nz1
real  coef
real(4) tmp4(nzm)

p = 0.
w = 0.
u = 0.
v = 0.
fluxbu = 0.
fluxbv = 0.
fluxbt = 0.
fluxbs = 0.
fluxtu = 0.
fluxtv = 0.
fluxtt = 0.
fluxts = 0.
dudt = 0.
dvdt = 0.
dwdt = 0.	   
	

if(.not.readinit) then

!**************************************************************
!	Read Initial Sounding

 open(77,file='./CASES/'//trim(case)//'/snd_ocn',status='old',form='formatted')
 read(77,*)

 do while(.true.)

   read(77,err=55,end=55,fmt=*) rrr1, n, pres0
   do i=1,n
       read(77,*) zz(i),tt(i),ss(i),uu(i),vv(i)
       zz(i) = zi(nz) - zz(i)
   end do	      
   read(77,err=55,end=55,fmt=*) rrr2, n, pres1
   do i=1,n
       read(77,*) zz1(i),tt1(i),ss1(i),uu1(i),vv1(i)
       zz1(i) = zi(nz) - zz1(i)
   end do	      
 
   if(day.ge.rrr1.and.day.le.rrr2) then
       do i=1,n
         tt(i)=tt(i)+(tt1(i)-tt(i))/(rrr2-rrr1+1.e-5)*(day-rrr1)
         ss(i)=ss(i)+(ss1(i)-ss(i))/(rrr2-rrr1+1.e-5)*(day-rrr1)
         uu(i)=uu(i)+(uu1(i)-uu(i))/(rrr2-rrr1+1.e-5)*(day-rrr1)
         vv(i)=vv(i)+(vv1(i)-vv(i))/(rrr2-rrr1+1.e-5)*(day-rrr1)
       end do
     goto 56
   endif
   do i=1,n+1
     backspace(77)
 !    backspace(77) ! these two lines were addedf because ocn_of 
 !    read(77)      ! a bug in gfortran compiler
   end do	      
 
 end do
 
 55 continue
 if(masterproc) then
   print*,'Error: day is beyond the sounding time range'
   print*,day,rrr1,rrr2
 end if
 call task_abort()
 56 continue	
 
 close (77)
 
 !-----------------------------------------------------------
 !       Interpolate sounding into vertical grid:
 
 do k= nzm,1,-1
  do iz = 2,n
   if(z(k).ge.zz(iz)) then
     tabs0(k)=tt(iz-1)+(tt(iz)-tt(iz-1))/(zz(iz)-zz(iz-1))*(z(k)-zz(iz-1))	
     sp0(k)=ss(iz-1)+(ss(iz)-ss(iz-1))/(zz(iz)-zz(iz-1))*(z(k)-zz(iz-1))
     u0(k)=uu(iz-1)+(uu(iz)-uu(iz-1))/(zz(iz)-zz(iz-1))*(z(k)-zz(iz-1))  
     v0(k)=vv(iz-1)+(vv(iz)-vv(iz-1))/(zz(iz)-zz(iz-1))*(z(k)-zz(iz-1)) 
     goto 12
   endif
  end do
  tabs0(k)=tabs0(k+1)
  sp0(k)=sp0(k+1)
  u0(k)=u0(k+1)
  v0(k)=v0(k+1)
 12 continue
  ug0(k)=u0(k)
  vg0(k)=v0(k)
  s0(k) =  gsw_sa_from_sp(real(sp0(k),r8), real(pres(k),r8), real(0.,r8), real(0.,r8))
  t0(k) =  gsw_ct_from_t(real(s0(k),r8), real(tabs0(k),r8), real(pres(k),r8))
 end do
 
  do k=1,nzm
   do j=1,ny
    do i=1,nx
     u(i,j,k)= u0(k)
     v(i,j,k)= v0(k)
     t(i,j,k)= t0(k)
     s(i,j,k)= s0(k)
    end do
   end do
  end do

else
 
  open(11,file=initfile,form='unformatted')
  read(11) nx1,ny1,nz1
  if(masterproc) print*,'reading initfile=',trim(initfile)
  if(masterproc) print*,'data size:',nx1,ny1,nz1
  read(11) tmp4(1)
  pres0 = tmp4(1)
  if(masterproc) print*,'pres0=',pres0
  read(11) tmp4
  pres = tmp4
  if(masterproc) print*,'pres=',pres
  if(masterproc) print*,'reading u:'
  call ocn_read_field3D (11,u(1:nx,1:ny,1:nzm),nx1,ny1,z,nzm)
  u = u*terrau 
  call ocn_fminmax_print('u:',u(1:nx,1:ny,1:nzm),1,nx,1,ny,nzm)
  if(masterproc) print*,'reading v:'
  call ocn_read_field3D (11,v(1:nx,1:ny,1:nzm),nx1,ny1,z,nzm)
  call ocn_fminmax_print('v:',v(1:nx,1:ny,1:nzm),1,nx,1,ny,nzm)
  v = v*terrav 
  if(masterproc) print*,'reading s:'
  call ocn_read_field3D (11,s(1:nx,1:ny,1:nzm),nx1,ny1,z,nzm)
  call ocn_fminmax_print('s(data):',s(1:nx,1:ny,1:nzm),1,nx,1,ny,nzm)
  if(masterproc) print*,'reading tabs:'
  call ocn_read_field3D (11,t(1:nx,1:ny,1:nzm),nx1,ny1,z,nzm)
  call ocn_fminmax_print('t(data):',t(1:nx,1:ny,1:nzm),1,nx,1,ny,nzm)
  close(11)
  do k=1,nzm
   do j=1,ny
     do i=1,nx
         s(i,j,k) =  gsw_sa_from_sp(real(s(i,j,k),r8), real(pres(k),r8), &
                                    real(0.,r8), real(0.,r8))
                         !           real(longitude(i,j),r8), real(latitude(i,j),r8))
         t(i,j,k) =  gsw_ct_from_pt(real(s(i,j,k),r8), real(t(i,j,k),r8))
     end do
   end do
  end do

! fillin terrain with zonally average:

!  if(doterrain) then
!    do k=1,nzm
!     do j=1,ny
!      do i=1,nx
!        tmp(i,j,k) = s(i,j,k)*wgtx(j,k)*terra(i,j,k)
!      end do
!     end do
!    end do
!    call ocn_mean_x_3D(tmp,tmpz) 
!    do k=1,nzm
!     do j=1,ny
!      do i=1,nx
!        if(terra(i,j,k).lt.1.) s(i,j,k) = tmpz(j,k)
!      end do
!     end do
!    end do
!    do k=1,nzm
!     do j=1,ny
!      do i=1,nx
!        tmp(i,j,k) = t(i,j,k)*wgtx(j,k)*terra(i,j,k)
!      end do
!     end do
!    end do
!    call ocn_mean_x_3D(tmp,tmpz)
!    do k=1,nzm
!     do j=1,ny
!      do i=1,nx
!        if(terra(i,j,k).lt.1) t(i,j,k) = tmpz(j,k)
!      end do
!     end do
!    end do
!  end if

end if 
!-------------------------------------------------------------

call ocn_diagnose()
call ocn_refprof()


call ocn_fminmax_print('rhoo:',rhoo(1:nx,1:ny,1:nzm),1,nx,1,ny,nzm)
call ocn_fminmax_print('tabs:',tabs(1:nx,1:ny,1:nzm),1,nx,1,ny,nzm)

if(masterproc) then
 print *,'  k      zi     presi ' 
 print *,'--------------------------------------------------------------------'
 print *,'Initial Sounding:'
 print *, '  k       z(m)      dz(m)   pres(dbar)  Tc(C)  T(C)   sa(g/kg)' 
 do k = nzm,1,-1
  write(6,'(i4,1x,6f10.2,2f10.4)')   k, zi(nz)-z(k), zi(k+1)-zi(k),pres(k), &
     t0(k), tabs0(k), s0(k)
 end do
 print *, '  k       z(m)      dz(m)   pres(dbar)  Tc(C)  T(C)  sa(g/kg)' 
endif

if(dosgs) call ocn_sgs_init()


!initialize surface:

call ocn_setperturb()

! exchange boundaries:
call ocn_boundaries(1)
call ocn_boundaries(4)


if(masterproc) print*,'u0=',u0
if(masterproc) print*,'v0=',v0

call ocn_fminmax_print('u:',u(1:nx,1:ny,1:nzm),1,nx,1,ny,nzm)
call ocn_fminmax_print('v:',v(1:nx,1:ny,1:nzm),1,nx,1,ny,nzm)
call ocn_fminmax_print('w:',w(1:nx,1:ny,1:nzm),1,nx,1,ny,nzm)
call ocn_fminmax_print('s:',s(1:nx,1:ny,1:nzm),1,nx,1,ny,nzm)
call ocn_fminmax_print('t:',t(1:nx,1:ny,1:nzm),1,nx,1,ny,nzm)

if(nstep.eq.0) call ocn_write_fields3D()

end


