	
subroutine ocn_setparm
	
!       initialize parameters:

use ocn_grid
use ocn_params
use ocn_sgs, only: ocn_sgs_setparm
implicit none
	
integer icondavg, ierr

NAMELIST /OCN_PARAMETERS/ dodamping, doupperbound,  &
        dolongwave, doshortwave, dosgs, dz, doconstdz, &
        dosurface, dolargescale, doradforcing, &
	fluxt0,fluxq0,taux0,tauy0,tabs_s,z0, nstat, nstatfrq, doradsimple, &
	nsave3D, nsave3Dstart, nsave3Dend, dosfcforcing, &
	donudging_uv, donudging_ts, &
        donudging_t, donudging_s, tauls,tautsls,&
        nudging_uv_z1, nudging_uv_z2, nudging_t_z1, nudging_t_z2, &
        nudging_s_z1, nudging_s_z2, timelargescale, &
	SFC_FLX_FXD,SFC_TAU_FXD, &
        doensemble, nensemble, &
        nsave2D, nsave2Dstart, nsave2Dend, qnsave3D, & 
        docolumn, save2Dbin, save2Davg, save3Dbin, &
        save2Dsep, save3Dsep, dogzip2D, dogzip3D, &
        doradhomo, dosfchomo, &
        dotracers, perturb_type, &
        bubble_x0,bubble_y0,bubble_z0,bubble_radius_hor, &
        bubble_radius_ver,bubble_dtemp,bubble_ds, dossthomo, &
        rad3Dout, ncycle_max, doterrain, dobufferzone, &
        terrain_type, bufferzonex, bufferzoney, tk_factor, &
        dodamping_poles, dodebug, readinit, dohyper_terr, &
        initfile, terrainfile, dohyper, hyper_coef, &
        readterr, dodamping_w, dodamping_u, damping_u_cu, damping_w_cu,  &
        nsave2DZ, nsave2DZstart, nsave2DZend, save2DZsep, dogzip2DZ, save2DZbin, &
        dopointsource, pointsource_start_step, nens, doimplicitdiff,gmg_precision, &
        readq, readt, readlhf, readshf, readprec, readroff, &
        readlw, readsw, readu, readv, readtaux, readtauy, readbasins, &
        qfile, tfile, precfile, lhffile, shffile, rofffile, &
        lwfile, swfile, ufile, vfile, tauxfile, tauyfile, basinsfile
	
!----------------------------------
!  Read namelist variables from the standard input:
!------------

open(55,file='./CASES/'//trim(case)//'/prm_ocn', status='old',form='formatted') 
read (55,OCN_PARAMETERS,IOSTAT=ierr)
if (ierr.ne.0) then
     !namelist error checking
        write(*,*) '****** ERROR: bad specification in OCN_PARAMETERS namelist'
        rewind(55)
        read (55,OCN_PARAMETERS)
        call task_abort()
end if
close(55)

! write namelist values out to file for documentation
if(masterproc) then
      open(unit=55,file='./OUT_STAT/'//trim(case)//'_'//trim(caseid)//'.ocn.nml',&
            form='formatted', position='append')
      write (55,nml=OCN_PARAMETERS)
      write(55,*) 
      close(55)
end if

!------------------------------------
!  Set parameters 

nstat = nstat/ncallocean 
nsave2D  = nsave2D/ncallocean
nsave2Dstart = nsave2Dstart/ncallocean
nsave2Dend = nsave2Dend/ncallocean
nsave3D  = nsave3D/ncallocean
nsave3Dstart = nsave3Dstart/ncallocean
nsave3Dend = nsave3Dend/ncallocean


if(readterr) terrain_type = 0

notopened2D = .true.
notopened2DZ = .true.
notopened3D = .true.

call ocn_sgs_setparm() ! read in SGS options from prm file.

if(tautsls.eq.99999999.) tautsls = tauls
          
dt3 = 0.

end
