
subroutine ocn_setperturb

!  Random noise

use ocn_vars
use ocn_params
use ocn_sgs, only: ocn_setperturb_sgs
use ocn_terrain, only: k_terra, terra

implicit none

integer i,j,k,ptype,it,jt
real(4) rrr,ranf_
real xxx,yyy,zzz
real nu, nuv, phi, lamda

call ranset_(3*rank+nens)

ptype = perturb_type

call ocn_setperturb_sgs(ptype)  ! set sgs fields

select case (ptype)

  case(-1)

! do nothing

  case(0)

     do k=1,nzm
      do j=1,ny
       do i=1,nx
         if(k.le.nzm.and.k.ge.nzm-10) then
       !     t(i,j,k)=t(i,j,k)+0.1*rrr
            rrr=1.-2.*ranf_()
            u(i,j,k)=u(i,j,k)+0.1*rrr
            rrr=1.-2.*ranf_()
            v(i,j,k)=v(i,j,k)+0.1*rrr
         endif
       end do
      end do
     end do

  case(2) ! warm bubble

     if(masterproc) then
       print*, 'initialize with warm bubble:'
       print*, 'bubble_x0=',bubble_x0
       print*, 'bubble_y0=',bubble_y0
       print*, 'bubble_z0=',bubble_z0
       print*, 'bubble_radius_hor=',bubble_radius_hor
       print*, 'bubble_radius_ver=',bubble_radius_ver
       print*, 'bubble_dtemp=',bubble_dtemp
       print*, 'bubble_ds=',bubble_ds
     end if

     call task_rank_to_index(rank,it,jt)
     do k=1,nzm
       zzz = z(k)
       do j=1,ny
         yyy = dy*(j+jt-1)
         do i=1,nx
          xxx = dx*(i+it-1)
           if((xxx-bubble_x0)**2+YES3D*(yyy-bubble_y0)**2.lt.bubble_radius_hor**2 &
            .and.(zzz-bubble_z0)**2.lt.bubble_radius_ver**2) then
              rrr = cos(pi/2.*(xxx-bubble_x0)/bubble_radius_hor)**2 &
               *cos(pi/2.*(yyy-bubble_y0)/bubble_radius_hor)**2 &
               *cos(pi/2.*(zzz-bubble_z0)/bubble_radius_ver)**2
              t(i,j,k) = t(i,j,k) + bubble_dtemp*rrr
              s(i,j,k) = s(i,j,k) + bubble_ds*rrr
           end if
         end do
       end do
     end do

  case default

       if(masterproc) print*,'perturb_type is not defined in setperturb(). Exitting...'
       call task_abort()

end select


end

