subroutine ocn_setsurface()

use ocn_vars
use ocn_params
use ocn_terrain, only: ocn_setterrain
use vars, only: roff_ocn, lhf_ocn, shf_ocn, prec_ocn,  &
                sw_ocn, lw_ocn, taux_ocn, tauy_ocn, landmask
use params, only: dooceanonly,readlandmask, landmaskfile

implicit none
integer i,j,it,jt,nobs
real field(nx,ny,2)
real days(2)
real coef

call task_rank_to_index(rank,it,jt)

if(dooceanonly.and.readlandmask) then
    call ocn_readsurface(landmaskfile,field,days)
    landmask(:,:) = nint(field(:,:,1))
end if

if(readbasins) then
    call ocn_readsurface(basinsfile,field,days)
    basins(:,:) = nint(field(:,:,1))
end if

if(readterr) then
    call ocn_readsurface(terrainfile,field,days)
    elevation(:,:) = field(:,:,1)
!    do j=1,ny
!     if(j+jt.ge.ny_gl-1) elevation(:,j) = 0.
!    end do
    where(basins.eq.0) elevation = 0.
    where(elevation.ge.-5..and.elevation.lt.0.) elevation = -5.
end if

if(dosfcforcing) then

  if(readq) then
    call ocn_readsurface(qfile,qobs,dayqobs)
    if(nrestart.eq.0) then
      if(dayqobs(2).eq.0) then
        q_atm(:,:) = qobs(:,:,1)
      else
        coef=(day-dayqobs(1))/(dayqobs(2)-dayqobs(1))
        q_atm(:,:) = qobs(:,:,1)+coef*(qobs(:,:,2)-qobs(:,:,1))
      end if
    end if
  endif

  if(readt) then
    call ocn_readsurface(tfile,tobs,daytobs)
    if(nrestart.eq.0) then
      if(daytobs(2).eq.0) then
        t_atm(:,:) = tobs(:,:,1)
      else
        coef=(day-daytobs(1))/(daytobs(2)-daytobs(1))
        t_atm(:,:) = tobs(:,:,1)+coef*(tobs(:,:,2)-tobs(:,:,1))
      end if
    end if
  endif

  if(readroff) then
    call ocn_readsurface(rofffile,roffobs,dayroffobs)
    if(nrestart.eq.0) then
      if(dayroffobs(2).eq.0) then
        roff_ocn(:,:) = roffobs(:,:,1)
      else
        coef=(day-dayroffobs(1))/(dayroffobs(2)-dayroffobs(1))
        roff_ocn(:,:) = roffobs(:,:,1)+coef*(roffobs(:,:,2)-roffobs(:,:,1))
      end if
    end if
  endif

  if(readlhf) then
    call ocn_readsurface(lhffile,lhfobs,daylhfobs)
    if(nrestart.eq.0) then
      if(daylhfobs(2).eq.0) then
        lhf_ocn(:,:) = lhfobs(:,:,1)
      else
        coef=(day-daylhfobs(1))/(daylhfobs(2)-daylhfobs(1))
        lhf_ocn(:,:) = lhfobs(:,:,1)+coef*(lhfobs(:,:,2)-lhfobs(:,:,1))
      end if
    end if
  endif

  if(readshf) then
    call ocn_readsurface(shffile,shfobs,dayshfobs)
    if(nrestart.eq.0) then
      if(dayshfobs(2).eq.0) then
        shf_ocn(:,:) = shfobs(:,:,1)
      else
        coef=(day-dayshfobs(1))/(dayshfobs(2)-dayshfobs(1))
        shf_ocn(:,:) = shfobs(:,:,1)+coef*(shfobs(:,:,2)-shfobs(:,:,1))
      end if
    end if
  endif 

  if(readprec) then
    call ocn_readsurface(precfile,precobs,dayprecobs)
    if(nrestart.eq.0) then
      if(dayprecobs(2).eq.0) then
        prec_ocn(:,:) = precobs(:,:,1)
      else
        coef=(day-dayprecobs(1))/(dayprecobs(2)-dayprecobs(1))
        prec_ocn(:,:) = precobs(:,:,1)+coef*(precobs(:,:,2)-precobs(:,:,1))
      end if
    end if
  endif

  if(readlw) then
    call ocn_readsurface(lwfile,lwobs,daylwobs)
    if(nrestart.eq.0) then
      if(daylwobs(2).eq.0) then
        lw_ocn(:,:) = lwobs(:,:,1)
      else
        coef=(day-daylwobs(1))/(daylwobs(2)-daylwobs(1))
        lw_ocn(:,:) = lwobs(:,:,1)+coef*(lwobs(:,:,2)-lwobs(:,:,1))
      end if
    end if
  endif

  if(readsw) then
    call ocn_readsurface(swfile,swobs,dayswobs)
    if(nrestart.eq.0) then
      if(dayswobs(2).eq.0) then
        sw_ocn(:,:) = swobs(:,:,1)
      else
        coef=(day-dayswobs(1))/(dayswobs(2)-dayswobs(1))
        sw_ocn(:,:) = swobs(:,:,1)+coef*(swobs(:,:,2)-swobs(:,:,1))
      end if
    end if
  endif

  if(readu) then
    call ocn_readsurface(ufile,uobs,dayuobs)
    if(nrestart.eq.0) then
      if(dayuobs(2).eq.0) then
        u_atm(:,:) = uobs(:,:,1)
      else
        coef=(day-dayuobs(1))/(dayuobs(2)-dayuobs(1))
        u_atm(:,:) = uobs(:,:,1)+coef*(uobs(:,:,2)-uobs(:,:,1))
      end if
    end if
  endif

  if(readv) then
    call ocn_readsurface(vfile,vobs,dayvobs)
    if(nrestart.eq.0) then
      if(dayvobs(2).eq.0) then
        v_atm(:,:) = vobs(:,:,1)
      else
        coef=(day-dayvobs(1))/(dayvobs(2)-dayvobs(1))
        v_atm(:,:) = vobs(:,:,1)+coef*(vobs(:,:,2)-vobs(:,:,1))
      end if
    end if
  endif

  if(readtaux) then
    call ocn_readsurface(tauxfile,tauxobs,daytauxobs)
    if(nrestart.eq.0) then
      if(daytauxobs(2).eq.0) then
        taux_ocn(:,:) = tauxobs(:,:,1)
      else
        coef=(day-daytauxobs(1))/(daytauxobs(2)-daytauxobs(1))
        taux_ocn(:,:) = tauxobs(:,:,1)+coef*(tauxobs(:,:,2)-tauxobs(:,:,1))
      end if
    end if
  endif

  if(readtauy) then
    call ocn_readsurface(tauyfile,tauyobs,daytauyobs)
    if(nrestart.eq.0) then
      if(daytauyobs(2).eq.0) then
        tauy_ocn(:,:) = tauyobs(:,:,1)
      else
        coef=(day-daytauyobs(1))/(daytauyobs(2)-daytauyobs(1))
        tauy_ocn(:,:) = tauyobs(:,:,1)+coef*(tauyobs(:,:,2)-tauyobs(:,:,1))
      end if
    end if
  endif

endif ! dosfcforcing

end
