
subroutine ocn_statistics()

use ocn_vars
use ocn_tracers
use ocn_params
use ocn_hbuffer
implicit none	
	
	real u2z(nzm)
	real v2z(nzm)
	real w2z(nzm)
	real w22(nzm)
	real w3z(nzm)
	real skw(nzm)
	real t2z(nzm)
	real tsz(nzm)
	real s2z(nzm)
	real aup(nzm)
	real tkez(nzm)
	real fadv(nz)
	real shear(nz)
	real shearx(nzm)
	real sheary(nzm)
	real presx(nzm)
	real presy(nzm)
	real twgrad(nzm)
	real swgrad(nzm)
	real tvwle(nzm)

	real tvirt(nx,ny,nzm)
	
	integer i,j,k,n,ntr
	real coef,coef1
	real factor_xy, factor_n, tmp(4), tmp1(4)
	real zero(nzm)

        call t_startf('statistics')

	factor_xy = 1./float(nx*ny)
	factor_n = 1./float(nsubdomains)
	
!-----------------------------------------------
!	Mean thermodynamics profiles:
!-----------------------------------------------	
	call ocn_hbuf_put('TC',t0,1.)
        call ocn_hbuf_put('TABS',tabs0,1.)
	call ocn_hbuf_put('U',u0,1.)
	call ocn_hbuf_put('V',v0,1.)
	call ocn_hbuf_put('SA',s0,1.e3)
	call ocn_hbuf_put('TABSOBS',tg0,1.)
	call ocn_hbuf_put('SOBS',sg0,1.)
	call ocn_hbuf_put('UOBS',ug0,1.)
	call ocn_hbuf_put('VOBS',vg0,1.)
	call ocn_hbuf_put('TTEND',ttend,86400.)
	call ocn_hbuf_put('STEND',stend,86400.)
	call ocn_hbuf_put('PRES',pres,1.)
	call ocn_hbuf_put('RHO',rho,1.)

!-------------------------------------------------------------
!	Fluxes:
!-------------------------------------------------------------

	do k=1,nzm
	  tmp(1) = dz/rhow(k)
	  tmp(2) = tmp(1) / dtn
	  uwsb(k) = uwsb(k) * tmp(1)
	  vwsb(k) = vwsb(k) * tmp(1)
	  twsb(k) = twsb(k) * tmp(1) * rhow(k) * cpw
	  swsb(k) = swsb(k) * tmp(1) * rhow(k)
	  uwle(k) = uwle(k)*tmp(1) + uwsb(k)
	  vwle(k) = vwle(k)*tmp(1) + vwsb(k)
	  twle(k) = twle(k)*tmp(2)*rhow(k)*cpw + twsb(k)
	  swle(k) = swle(k)*tmp(2)*rhow(k) + swsb(k)
	  if(dotracers) then
           do ntr=1,ntracers
	    trwsb(k,ntr) = trwsb(k,ntr) * tmp(1)*rhow(k)
     	    trwle(k,ntr) = trwle(k,ntr) * tmp(2)*rhow(k) + trwsb(k,ntr)
           end do
          end if
	end do
	uwle(nz) = 0.
	vwle(nz) = 0.
	uwsb(nz) = 0.
	vwsb(nz) = 0.

	call ocn_hbuf_put('UW',uwle,factor_xy)
	call ocn_hbuf_put('VW',vwle,factor_xy)
	call ocn_hbuf_put('UWSB',uwsb,factor_xy)
	call ocn_hbuf_put('VWSB',vwsb,factor_xy)
	call ocn_hbuf_put('TCFLUX',twle,factor_xy)
	call ocn_hbuf_put('TCFLUXS',twsb,factor_xy)
	call ocn_hbuf_put('SAFLUX',swle,factor_xy)
	call ocn_hbuf_put('SAFLUXS',swsb,factor_xy)
	
!---------------------------------------------------------
!	Mean turbulence related profiles:
!-----------------------------------------------------------


	do k=1,nzm

	 u2z(k) = 0.
	 v2z(k) = 0.
	 w2z(k) = 0.
	 w22(k) = 0.
	 w3z(k) = 0.
	 t2z(k) = 0.
	 tsz(k) = 0.
	 s2z(k) = 0.
         aup(k) = 0.
	 do j=1,ny
	  do i=1,nx
	    u2z(k) = u2z(k)+(u(i,j,k)-u0(k))**2	  
	    v2z(k) = v2z(k)+(v(i,j,k)-v0(k))**2
	    w2z(k) = w2z(k)+0.5*(w(i,j,k+1)**2+w(i,j,k)**2)
	    w22(k) = w22(k)+w(i,j,k)**2
	    w3z(k) = w3z(k)+0.5*(w(i,j,k+1)**3+w(i,j,k)**3)	  
	    t2z(k) = t2z(k)+(t(i,j,k)-t0(k))**2	  
	    tsz(k) = tsz(k)+(t(i,j,k)-t0(k))*(s(i,j,k)-s0(k))	  
	    s2z(k) = s2z(k)+(s(i,j,k)-s0(k))**2
	    if(w(i,j,k)+w(i,j,k+1).gt.0) aup(k) = aup(k) + 1
	  end do
	 end do
	 skw(k) = w3z(k)/(w2z(k)*factor_xy+1.e-5)**1.5
	 tkez(k)= 0.5*(u2z(k)+v2z(k)*YES3D+w2z(k))
	 
	end do

	call ocn_hbuf_put('U2',u2z,factor_xy)
	call ocn_hbuf_put('V2',v2z,factor_xy)
	call ocn_hbuf_put('W2',w2z,factor_xy)
	call ocn_hbuf_put('W3',w3z,factor_xy)
	call ocn_hbuf_put('WSKEW',skw,factor_xy)
	call ocn_hbuf_put('AUP',aup,factor_xy)
	call ocn_hbuf_put('TC2',t2z,factor_xy)
	call ocn_hbuf_put('TCSA',tsz,factor_xy)
	call ocn_hbuf_put('SA2',s2z,1.e6*factor_xy)
	call ocn_hbuf_put('TKE',tkez,factor_xy)
!-----------------------------------------------------------------
!  TKE balance:

        shear(1)=0.
        shear(nz)=0.
        do k=2,nzm
          shear(k)=-( (uwle(k)-uwsb(k))*(u0(k)-u0(k-1)) &
            +(vwle(k)-vwsb(k))*(v0(k)-v0(k-1))*YES3D )*factor_xy /(dz*adzw(k))
        end do
        do k=1,nzm
          shear(k)=0.5*(shear(k)+shear(k+1))
          tkeleadv(k)=tkeleadv(k)-shear(k)
          tkelediff(k)=tkelediff(k)-tkelediss(k)
        end do

        call ocn_hbuf_put('ADVTR',tkeleadv,1.)
        call ocn_hbuf_put('PRESSTR',tkelepress,1.)
        call ocn_hbuf_put('BUOYA',tkelebuoy,1.)
        call ocn_hbuf_put('SHEAR',shear,1.)
        call ocn_hbuf_put('DISSIP',tkelediss,1.)
        call ocn_hbuf_put('DIFTR',tkelediff,1.)
	
	fadv(1)=0.
	fadv(nz)=0.
!-----------------------------------------------------------------
!  Momentum flux balance:

!  UW advection d(w'w'u')/dz:

	do k=2,nzm
	 fadv(k)=0.
	 do j=1,ny
	  do i=1,nx
	    fadv(k)=fadv(k)+w(i,j,k)**2*rhow(k)*0.5* &
                         ( u(i,j,k-1)-u0(k-1)+u(i,j,k)-u0(k))
	  end do
	 end do
	 fadv(k)=fadv(k)*factor_xy
	end do
	do k=1,nzm
	 coef=-(fadv(k+1)-fadv(k))/(adz(k)*dz*rho(k))
	 shearx(k)=momleadv(k,1)-coef
	 momleadv(k,1)=coef
	end do	


!  VW advection d(w'w'v')/dz:

	do k=2,nzm
	 fadv(k)=0.
	 do j=1,ny
	  do i=1,nx
	    fadv(k)=fadv(k)+w(i,j,k)**2*rhow(k)*0.5* &	
                         ( v(i,j,k-1)-v0(k-1)+v(i,j,k)-v0(k))
	  end do
	 end do
	 fadv(k)=fadv(k)*factor_xy
	end do
	do k=1,nzm
	 coef=-(fadv(k+1)-fadv(k))/(adz(k)*dz*rho(k))
	 sheary(k)=momleadv(k,2)-coef
	 momleadv(k,2)=coef
	end do	


!  UW advection d(p'u')/dz:

	do k=1,nz
	 fadv(k)=0.
	 if(k.eq.1) then
	   do j=1,ny
	    do i=1,nx
	      fadv(k)=fadv(k)+(1.5*(u(i,j,k)-u0(k))*p(i,j,k,na)*rho(k)- &
                     0.5*(u(i,j,k+1)-u0(k+1))*p(i,j,k+1,na)*rho(k+1))
	    end do
	   end do
	 else if(k.eq.nz) then
	   do j=1,ny
	    do i=1,nx
	     fadv(k)=fadv(k)+(1.5*(u(i,j,k-1)-u0(k-1))*p(i,j,k-1,na)*rho(k-1)- &
                  0.5*(u(i,j,k-2)-u0(k-2))*p(i,j,k-2,na)*rho(k-2))
	    end do
	   end do
	 else
	   do j=1,ny
	    do i=1,nx
	      fadv(k)=fadv(k)+0.5*((u(i,j,k)-u0(k))*p(i,j,k,na)*rho(k)+ &
                       (u(i,j,k-1)-u0(k-1))*p(i,j,k-1,na)*rho(k-1))
	    end do
	   end do
	 end if
	 fadv(k)=fadv(k)*factor_xy
	end do
	do k=1,nzm
	 presx(k)=-(fadv(k+1)-fadv(k))/(adz(k)*dz*rho(k))
	end do	


!  VW advection d(p'v')/dz:

	do k=1,nz
	 fadv(k)=0.
	 if(k.eq.1) then
	   do j=1,ny
	    do i=1,nx
	      fadv(k)=fadv(k)+(1.5*(v(i,j,k)-v0(k))*p(i,j,k,na)*rho(k)- & 
                    0.5*(v(i,j,k+1)-v0(k+1))*p(i,j,k+1,na)*rho(k+1))
	    end do
	   end do
	 else if(k.eq.nz) then
	   do j=1,ny
	    do i=1,nx
             fadv(k)=fadv(k)+(1.5*(v(i,j,k-1)-v0(k-1))*p(i,j,k-1,na)*rho(k-1)- &
                     0.5*(v(i,j,k-2)-v0(k-2))*p(i,j,k-2,na)*rho(k-2))
	    end do
	   end do
	 else
	   do j=1,ny
	    do i=1,nx
	      fadv(k)=fadv(k)+0.5*((v(i,j,k)-v0(k))*p(i,j,k,na)*rho(k)+ &
                       (v(i,j,k-1)-v0(k-1))*p(i,j,k-1,na)*rho(k-1))
	    end do
	   end do
	 end if
	 fadv(k)=fadv(k)*factor_xy
	end do
	do k=1,nzm
	 presy(k)=-(fadv(k+1)-fadv(k))/(adz(k)*dz*rho(k))
	end do	

	do k=1,nzm
	  momlepress(k,1)=momlepress(k,1)-presx(k)
	  momlepress(k,2)=momlepress(k,2)-presy(k)
	  momlepress(k,3)=momlepress(k,3)-tkelepress(k)
	end do

	call ocn_hbuf_put('WUADV',momleadv(1,1),1.)
	call ocn_hbuf_put('WUANIZ',momlepress(1,1),1.)
	call ocn_hbuf_put('WUBUOY',momlebuoy(1,1),1.)
	call ocn_hbuf_put('WUSHEAR',shearx,1.)
	call ocn_hbuf_put('WUPRES',presx,1.)
	call ocn_hbuf_put('WUDIFF',momlediff(1,1),1.)

	call ocn_hbuf_put('WVADV',momleadv(1,2),1.)
	call ocn_hbuf_put('WVANIZ',momlepress(1,2),1.)
	call ocn_hbuf_put('WVBUOY',momlebuoy(1,2),1.)
	call ocn_hbuf_put('WVSHEAR',sheary,1.)
	call ocn_hbuf_put('WVPRES',presy,1.)
	call ocn_hbuf_put('WVDIFF',momlediff(1,2),1.)

	call ocn_hbuf_put('W2BUOY',momlebuoy(1,3),2.)
	call ocn_hbuf_put('W2ADV',momleadv(1,3),2.)
	call ocn_hbuf_put('W2REDIS',momlepress(1,3),2.)
	call ocn_hbuf_put('W2PRES',tkelepress,2.)
	call ocn_hbuf_put('W2DIFF',momlediff(1,3),2.)

!-----------------------------------------------------------
! T2 and Q2 variance budget:


	do k=1,nzm
	  s2lediff(k)=s2lediff(k)-s2lediss(k)
	  t2lediff(k)=t2lediff(k)-t2lediss(k)
	end do	
	

	call ocn_hbuf_put('T2ADVTR',t2leadv,1.)
	call ocn_hbuf_put('T2GRAD',t2legrad,1.)
	call ocn_hbuf_put('T2DISSIP',t2lediss,1.)
	call ocn_hbuf_put('T2DIFTR',t2lediff,1.)
	call ocn_hbuf_put('T2PREC',t2leprec,1.)

	call ocn_hbuf_put('S2ADVTR',s2leadv,1.)
	call ocn_hbuf_put('S2GRAD',s2legrad,1.)
	call ocn_hbuf_put('S2DISSIP',s2lediss,1.)
	call ocn_hbuf_put('S2DIFTR',s2lediff,1.)

!------------------------------------------------------------------
! HW and QW budgets:


	fadv(1)=0.
	fadv(nz)=0.


!  HW advection d(w'w'h')/dz:

	do k=2,nzm
	 fadv(k)=0.
	 do j=1,ny
	  do i=1,nx
	    fadv(k)=fadv(k)+w(i,j,k)**2*rhow(k)*0.5* &
                 	      ( t(i,j,k-1)-t0(k-1)+t(i,j,k)-t0(k))
	  end do
	 end do
	end do
	do k=1,nzm
	 coef=-(fadv(k+1)-fadv(k))/(adz(k)*dz*rho(k))
	 twgrad(k)=twleadv(k)-coef
	 twleadv(k)=coef
	end do	


!  QW advection d(w'w'q')/dz:

	do k=2,nzm
	 fadv(k)=0.
	 do j=1,ny
	  do i=1,nx
	    fadv(k)=fadv(k)+w(i,j,k)**2*rhow(k)*0.5* &
       	     ( s(i,j,k-1)-s0(k-1)+s(i,j,k)-s0(k))
	  end do
	 end do
	end do
	do k=1,nzm
	 coef=-(fadv(k+1)-fadv(k))/(adz(k)*dz*rho(k))
	 swgrad(k)=swleadv(k)-coef
	 swleadv(k)=coef
	end do	



	call ocn_hbuf_put('TWADV',twleadv,factor_xy)
	call ocn_hbuf_put('TWDIFF',twlediff,factor_xy)
	call ocn_hbuf_put('TWGRAD',twgrad,factor_xy)
	call ocn_hbuf_put('TWBUOY',twlebuoy,factor_xy)
	call ocn_hbuf_put('TWPRES',twlepres,factor_xy)

	call ocn_hbuf_put('SWADV',swleadv,factor_xy)
	call ocn_hbuf_put('SWDIFF',swlediff,factor_xy)
	call ocn_hbuf_put('SWGRAD',swgrad,factor_xy)
	call ocn_hbuf_put('SWBUOY',swlebuoy,factor_xy)
	call ocn_hbuf_put('SWPRES',swlepres,factor_xy)


        call ocn_hbuf_put('RADLWUP',radlwup,factor_xy)
        call ocn_hbuf_put('RADLWDN',radlwdn,factor_xy)
        call ocn_hbuf_put('RADSWUP',radswup,factor_xy)
        call ocn_hbuf_put('RADSWDN',radswdn,factor_xy)
        call ocn_hbuf_put('RADQRLW',radqrlw,factor_xy*86400.)       
        call ocn_hbuf_put('RADQRSW',radqrsw,factor_xy*86400.)       
        call ocn_hbuf_put('RADQR',radqrlw+radqrsw,86400.)     

        call t_stopf('statistics')

end
	
