subroutine ocn_stepout(flag)

use ocn_vars
use ocn_sgs, only: tk
use ocn_sgs, only: ocn_sgs_print, ocn_sgs_statistics
use ocn_params
use ocn_hbuffer
use ocn_terrain
use params, only: dooceanonly
use grid, only: nprint
use vars, only: sstxy, shf_ocn, lhf_ocn, prec_ocn, roff_ocn, lw_ocn, sw_ocn
use slm_vars, only: seaicemask
implicit none	
	
integer, intent(in) ::  flag
integer i,j,k,ic,jc
real divmax(2), divmin(2), divmax1(2), divmin1(2)
real rdx, rdy, rdz, coef
integer nitermax1
real errormax1
real(8) buffer(5), buffer1(5)
real tmp(1:nx,1:ny)
real, allocatable :: div(:,:,:)

if(flag.eq.1) goto 111
if(dompi) then
    call ocn_task_max_real(error_max,errormax1,1)
    error_max = errormax1
    call task_max_integer(niter_max,nitermax1,1)
    niter_max = nitermax1
end if
if(flag.eq.0.and.masterproc) write(*,'(a,i7,a,i2,a,f5.3,a,f5.3,a,f5.3,a,f5.3,a,i2,a,g9.2)') 'OCEAN: NSTEP = ',nstep,' NCYCLE=',ncycle, &
      ' CFL=',cfl_adv,' CFLH=',cfl_advh,' CFLZ=',cfl_advz,' CFL_sgs=',cfl_sgs, ' niter=',niter_max,' error=',error_max

if(mod(nstep,nstatis).eq.0) then
      call ocn_statistics()
      call ocn_sgs_statistics()
end if


if(mod(nstep,nstat).eq.0) then
  if(masterproc) print *,'OCN: Writing statistics:nstatsteps=',nstatsteps

  call t_startf ('stat_out')

  call ocn_hbuf_average(nstatsteps)
  call ocn_hbuf_write(nstatsteps)
  call ocn_hbuf_flush()  
  nstatsteps = 0

  call t_stopf ('stat_out')

endif

if(mod(nstep,nstat*(1+nrestart_skip)).eq.0) then

  call ocn_write_all() ! save restart file

end if

call t_startf ('2D_out')

if(mod(nstep,nsave2D).eq.0.and.nstep.ge.nsave2Dstart &
                                   .and.nstep.le.nsave2Dend) then
  call ocn_write_fields2D()
  call ocn_stat_2Dinit()
endif

if(.not.save2Davg.or.nstep.eq.nsave2Dstart-nsave2D) call ocn_stat_2Dinit()

call t_stopf ('2D_out')


999 continue

call t_startf ('3D_out')
if(mod(nstep,nsave3D).eq.0.and.nstep.ge.nsave3Dstart.and.nstep.le.nsave3Dend) then
    call ocn_write_fields3D()
endif
call t_stopf ('3D_out')

call t_startf ('2DZ_out')
if(mod(nstep,nsave2DZ).eq.0.and.nstep.ge.nsave2DZstart.and.nstep.le.nsave2DZend) then
  call ocn_write_fields2DZ()
endif
call t_stopf ('2DZ_out')

!------------------------------------------------------------------------------
if(.not.dooceanonly.and.flag.eq.0) return
!------------------------------------------------------------------------------
! Print stuff out:
111 continue
if(nstep.eq.0.or.mod(nstep,nprint).eq.0) then
 allocate (div(nx,ny,nzm))
 do k=1,nzm
  coef = adz(k)*dz
  rdz = 1./coef
  if(ny.ne.1) then
   do j=1,ny
    jc = j+1*YES3D
    rdx = imu(j)/dx
    rdy = imu(j)/(dy*ady(j))
    do i=1,nx
     ic = i+1
     div(i,j,k) = (u(ic,j,k)-u(i,j,k))*rdx + (muv(jc)*v(i,jc,k)-muv(j)*v(i,j,k))*rdy + &
                  (w(i,j,k+1)-w(i,j,k))*rdz
    end do
   end do
  else
    j = 1
    rdx = 1./dx
    do i=1,nx-1
    ic = i+1
     div(i,j,k) = (u(ic,j,k)-u(i,j,k))*rdx +(w(i,j,k+1)-w(i,j,k))*rdz
    end do
  endif
 end do
 divmax(1) = maxval(div)
 divmin(1) = minval(div)

 if(dompi) then
     call ocn_task_max_real(divmax(1),divmax1(1),1)
     call ocn_task_min_real(divmin(1),divmin1(1),1)
     divmax(1) = divmax1(1)
     divmin(1) = divmin1(1)
 end if

 deallocate(div)

!if(masterproc) then
!print*,'>>>>W',rank,minval(w(1:nx,1:ny,1:nz)),maxval(w(1:nx,1:ny,1:nz))
!print*,'>>>>W',rank,minloc(w(1:nx,1:ny,1:nz)),maxloc(w(1:nx,1:ny,1:nz))
!if(rank.eq.11) then
!j=93

!print*,'--->',tk(27,1,1)
!print*,'tk->:'
!write(6,'(16f7.2)')((tk(i,1,k),i=1,16),k=nzm,1,-1)
!print*,'p->:'
!write(6,'(16f7.2)')((p(i,j,k),i=1,16),k=nzm,1,-1)
!print*,'u->:'
!write(6,'(16f7.2)')((u(i,j,k)*100.,i=1,16),k=nzm,1,-1)
!print*,'v->:'
!write(6,'(16f7.2)')((v(i,j,k)*100.,i=1,16),k=nzm,1,-1)
!print*,'w->:'
!write(6,'(16f7.2)')((w(i,j,k)*100.,i=1,16),k=nzm,1,-1)
!print*,'s->:'
!write(6,'(16f7.2)')((s(i,j,k),i=16,31),k=nzm,1,-1)
!print*,'t->:'
!write(6,'(16f7.2)')((t(i,j,k),i=1,16),k=nzm,1,-1)
!print*,'t->:'
!write(6,'(16f7.2)')((rhoo(i,j,k)-rhoo0(k),i=1,16),k=nzm,1,-1)
!print*,'tabs->:'
!write(6,'(16f7.2)')((tabs(i,1,k),i=16,31),k=nzm,1,-1)

!end if

!--------------------------------------------------------
 if(masterproc) then

    write(6,*) '------------- OCEAN ------------------------------'
    print*,'DAY = ',day
!    call print_date_from_day()
    write(6,*) 'OCEAN NSTEP=',nstep
    write(6,*) 'div:',divmax(1),divmin(1)
    write(6,*) 'surface pressure=',pres0

 end if
 call ocn_fminmax_print('u:',u,dimx1_u,dimx2_u,dimy1_u,dimy2_u,nzm)
 call ocn_fminmax_print('v:',v,dimx1_v,dimx2_v,dimy1_v,dimy2_v,nzm)
 call ocn_fminmax_print('w:',w,dimx1_w,dimx2_w,dimy1_w,dimy2_w,nz)
 call ocn_fminmax_print('p:',p,0,nx,1-YES3D,ny,nzm)
 call ocn_fminmax_print('t:',t,dimx1_s,dimx2_s,dimy1_s,dimy2_s,nzm)
 call ocn_fminmax_print('sst:',real(sstxy(1:nx,1:ny)),1,nx,1,ny,1)
 call ocn_fminmax_print('s:',s,dimx1_s,dimx2_s,dimy1_s,dimy2_s,nzm)
 call ocn_fminmax_print('p3D:',p3D,1,nx,1,ny,nzm)
 call ocn_fminmax_print('seaice:',real(seaicemask(1:nx,1:ny)),1,nx,1,ny,1)
 call ocn_fminmax_print('seaice_h:',real(h_seaice(1:nx,1:ny)),1,nx,1,ny,1)
 call ocn_fminmax_print('tabs:',tabs,1,nx,1,ny,nzm)
 if(dosgs) call ocn_sgs_print()
 if(doshortwave.or.dolongwave) call ocn_fminmax_print('qrad(K/day):',qrad*86400.,1,nx,1,ny,nzm)
 if(doshortwave) call ocn_fminmax_print('sw:',sw_ocn,1,nx,1,ny,1)
 if(dolongwave) call ocn_fminmax_print('lw:',lw_ocn,1,nx,1,ny,1)
 call ocn_fminmax_print('uw:',fluxtu,1,nx,1,ny,1)
 call ocn_fminmax_print('vw:',fluxtv,1,nx,1,ny,1)
 call ocn_fminmax_print('wt:',fluxtt*rhow(nz)*cpw,1,nx,1,ny,1)
 call ocn_fminmax_print('ws:',fluxts,1,nx,1,ny,1)
 call ocn_fminmax_print('lhf:',lhf_ocn,1,nx,1,ny,1)
 call ocn_fminmax_print('shf:',shf_ocn,1,nx,1,ny,1)
 call ocn_fminmax_print('prec(mm/d):',prec_ocn*86400.,1,nx,1,ny,1)
 call ocn_fminmax_print('roff(mm/d):',roff_ocn*86400.,1,nx,1,ny,1)
 call ocn_fminmax_print('uw(b):',fluxbu,1,nx,1,ny,1)
 call ocn_fminmax_print('vw(b):',fluxbv,1,nx,1,ny,1)

end if ! mod(nstep,nprint).eq.0) then

end
