! ---------------------------------------------------------
! Fill-in the scalar inside the terrain
! assuming zero laplacian

subroutine ocn_terrain_fill()
use ocn_grid
use ocn_terrain, only: terra, kmax, k_terra
use ocn_vars, only: t, s
use ocn_sgs, only: sgs_field
implicit none
real fld(dimx1_s:dimx2_s,dimy1_s:dimy2_s,nzm)

real a(ny),b(ny),e(ny)
integer i,j,k,niter,iter

call t_startf('ocn_terrain_fill')

if(nstep.eq.0) then
  niter=3*nx_gl
else
  niter = 1
end if

do j=1,ny
 do i=1,nx
   t(i,j,max(1,k_terra(i,j)-1)) = t(i,j,min(nzm,k_terra(i,j)))
   s(i,j,max(1,k_terra(i,j)-1)) = s(i,j,min(nzm,k_terra(i,j)))
   t(i,j,max(1,k_terra(i,j)-2)) = t(i,j,min(nzm,k_terra(i,j)))
   s(i,j,max(1,k_terra(i,j)-2)) = s(i,j,min(nzm,k_terra(i,j)))
 end do
end do

do j=1,ny
   a(j) = mu(j)*muv(j+1)*(dx/dy)**2/(adyv(j+1)*ady(j))
   b(j) = mu(j)*muv(j)*(dx/dy)**2/(adyv(j)*ady(j))
   e(j) = 1./(2.+a(j)+b(j))
end do
do iter=1,niter
 call ocn_boundaries(5)
 do k=1,kmax
  do j=1,ny
   do i=1,nx
     if(terra(i,j,k).lt.1.) then
      t(i,j,k) = (t(i+1,j,k)+t(i-1,j,k)+a(j)*t(i,j+1,k)+b(j)*t(i,j-1,k))*e(j)
      s(i,j,k) = (s(i+1,j,k)+s(i-1,j,k)+a(j)*s(i,j+1,k)+b(j)*s(i,j-1,k))*e(j)
     end if
   end do
  end do
 end do
end do
call t_stopf('ocn_terrain_fill')
end subroutine ocn_terrain_fill

