     
subroutine ocn_write_fields2DZ
	
use ocn_vars
use ocn_params
use ocn_terrain, only: terrau,terrav,terraw,terra
use ocn_sgs, only: tkh
implicit none
character *120 filename
character *80 long_name
character *8 name
character *10 timechar
character *4 rankchar
character *7 filetype
character *10 units
character *12 c_z(nzm),c_p(nzm),c_dy, c_time
integer i,j,k,n,nfields,nfields1,nsteplast
real tmp(nx,ny,nzm),tmpz(ny,nzm)
real tmpz4(1,ny,nzm)
character*7 filestatus

if(RUN2D) return

nfields=7 ! number of 2DZ fields to save

if((dolongwave.or.doshortwave).and..not.doradhomo) nfields=nfields+1
if(doterrain) nfields=nfields+1

nfields1=0

if(masterproc) then
 
  write(rankchar,'(i4)') nsubdomains
  write(timechar,'(i10)') nstep
  do i=1,11-lenstr(timechar)-1
    timechar(i:i)='0'
  end do

! Make sure that the new run doesn't overwrite the file from the old run

    if(notopened2DZ.and.(nrestart.eq.0.or.nrestart.eq.2)) then
      filestatus='new'
    else
      filestatus='unknown'
    end if

    if(save2DZbin) then
      filetype = '.bin2DZ'
    else
      filetype = '.com2DZ'
    end if
   
    if(save2DZsep) then
      filename='./OUT_2DZ/'//trim(case)//'_'//trim(caseid)//'_'// &
             rankchar(5-lenstr(rankchar):4)//'_'//timechar(1:10)//'.OCN.'//filetype
      open(46,file=filename,status='unknown',form='unformatted')
    else
      filename='./OUT_2DZ/'//trim(case)//'_'//trim(caseid)//'_'// &
             rankchar(5-lenstr(rankchar):4)//'.OCN.'//filetype
      open(46,file=filename,status=filestatus,form='unformatted')
      do while(.true.)
         read(46,end=222)  nsteplast
         if(nsteplast.ge.nstep) then
           backspace(46)
           backspace(46)  ! these two lines added because ocn_of
           read(46)       ! a bug in gfrotran compiler
           print*,'com2DZ file at nstep ',nsteplast
           goto 222   ! yeh, I know, it's bad ....
         end if
         read(46)
         read(46)
         do i=1,nfields
           if(masterproc) read(46)
           read(46)
           do j=1,nsubdomains-1
               read(46)
           end do
         end do
      end do
222   continue
      backspace(46)
      notopened2DZ=.false.
    end if

    write(46) nstep
    if(save2DZbin) then

      write(46) nx,ny,nzm,nsubdomains, nsubdomains_x,nsubdomains_y,nfields
      write(46) real(dy,4),real(float(nstep)*dt/(3600.*24.)+day0,4),&
              (real(z(k),4),k=1,nzm),(real(pres(k),4),k=1,nzm)

    else

      write(long_name,'(7i4)') nx,ny,nzm,nsubdomains,  &
                                     nsubdomains_x,nsubdomains_y,nfields
      do k=1,nzm
         write(c_z(k),'(f12.3)') real(z(k),4)
      end do
      do k=1,nzm
         write(c_p(k),'(f12.3)') real(pres(k),4)
      end do
      write(c_dy,'(f12.5)') real(dy,4)
      write(c_time,'(f12.5)') nstep*dt/(3600.*24.)+day0
      write(46) long_name(1:28)
      write(46) c_dy,c_time,(c_z(k),k=1,nzm),(c_p(k),k=1,nzm), &
                real(lat_gl,4),real(latv_gl,4), &
                real(y_gl,4), real(yv_gl,4)

    end if ! save2DZbin

end if ! masterproc

!------------------------------
  nfields1=nfields1+1
  do k=1,nzm
   do j=1,ny
    do i=1,nx
      tmp(i,j,k)=u(i,j,k)*wgtxu(j,k)*terrau(i,j,k)
    end do
   end do
  end do
  name='U'
  call ocn_mean_x_3D(tmp,tmpz)
  tmpz4(1,:,:) = tmpz(:,:)
  long_name='X Wind Component'
  units='m/s'
  call compress3D(tmpz4,1,ny,nzm,name,long_name,units, &
                                 save2DZbin,dompi,rank,nsubdomains)

  nfields1=nfields1+1
  do k=1,nzm
   do j=1,ny
    do i=1,nx
      tmp(i,j,k)=v(i,j,k)*wgtxv(j,k)*terrav(i,j,k)
    end do
   end do
  end do
  call ocn_mean_x_3D(tmp,tmpz)
  tmpz4(1,:,:) = tmpz(:,:)
  name='V'
  long_name='Y Wind Component'
  units='m/s'
  call compress3D(tmpz4,1,ny,nzm,name,long_name,units, &
                                 save2DZbin,dompi,rank,nsubdomains)

  nfields1=nfields1+1
  do k=1,nzm
   do j=1,ny
    do i=1,nx
      tmp(i,j,k)=w(i,j,k)*wgtxw(j,k)*terraw(i,j,k)
    end do
   end do
  end do
  call ocn_mean_x_3D(tmp,tmpz)
  tmpz4(1,:,:) = tmpz(:,:)
  name='W'
  long_name='Z Wind Component'
  units='m/s'
  call compress3D(tmpz4,1,ny,nzm,name,long_name,units, &
                                 save2DZbin,dompi,rank,nsubdomains)

  nfields1=nfields1+1
  do k=1,nzm
   do j=1,ny
    do i=1,nx
      tmp(i,j,k)=tkh(i,j,k)*wgtx(j,k)*terra(i,j,k)
    end do
   end do
  end do
  call ocn_mean_x_3D(tmp,tmpz)
  tmpz4(1,:,:) = tmpz(:,:)
  name='KZH'
  long_name='eddy diffusivity'
  units='m2/s'
  call compress3D(tmpz4,1,ny,nzm,name,long_name,units, &
                                 save2DZbin,dompi,rank,nsubdomains)

  nfields1=nfields1+1
  do k=1,nzm
   do j=1,ny
    do i=1,nx
      tmp(i,j,k)=p(i,j,k,na)*wgtx(j,k)*terra(i,j,k)
    end do
   end do
  end do
  call ocn_mean_x_3D(tmp,tmpz)
  tmpz4(1,:,:) = tmpz(:,:)
  name='PP'
  long_name='Pressure Perturbation'
  units='Pa'
  call compress3D(tmpz4,1,ny,nzm,name,long_name,units, &
                                 save2DZbin,dompi,rank,nsubdomains)


if(doterrain) then
  nfields1=nfields1+1
  do k=1,nzm
   do j=1,ny
    do i=1,nx
      tmp(i,j,k)=terra(i,j,k)
    end do
   end do
  end do
  call ocn_mean_x_3D(tmp,tmpz)
  tmpz4(1,:,:) = tmpz(:,:)
  name='TERRA'
  long_name='Terrain Mask'
  units=' '
  call compress3D(tmpz4,1,ny,nzm,name,long_name,units, &
                                 save2DZbin,dompi,rank,nsubdomains)
end if

  nfields1=nfields1+1
  do k=1,nzm
   do j=1,ny
    do i=1,nx
      tmp(i,j,k)=t(i,j,k)*terra(i,j,k)*wgtx(j,k)
    end do
   end do
  end do
  call ocn_mean_x_3D(tmp,tmpz)
  tmpz4(1,:,:) = tmpz(:,:)
  name='TC'
  long_name='Conservative Temperature'
  units='K'
  call compress3D(tmpz4,1,ny,nzm,name,long_name,units, &
                                 save2DZbin,dompi,rank,nsubdomains)


  nfields1=nfields1+1
  do k=1,nzm
   do j=1,ny
    do i=1,nx
      tmp(i,j,k)=s(i,j,k)*wgtx(j,k)*terra(i,j,k)
    end do
   end do
  end do
  call ocn_mean_x_3D(tmp,tmpz)
  tmpz4(1,:,:) = tmpz(:,:)
  name='SA'
  long_name='Absolute Salinity'
  units='g/kg'
  call compress3D(tmpz4,1,ny,nzm,name,long_name,units, &
                                 save2DZbin,dompi,rank,nsubdomains)
  call task_barrier()

  if(nfields.ne.nfields1) then
    if(masterproc) print*,'write_fields2DZ error: nfields=',nfields,'  nfields1=',nfields1
    call task_abort()
  end if

if(masterproc) then
     close(46)
     if(save2DZsep.and.dogzip2DZ) call systemf('gzip -f '//filename)
     if(masterproc)print*, 'Writting 2DZ data. file:'//filename
endif

 
end
