#include "./../fppmacros"
     
subroutine ocn_write_fields3D
	
use ocn_vars
use ocn_params
use grid, only: date_pr, datechar, lonu_gl, nfiles3D
use ocn_terrain, only: terra
use ocn_sgs, only: tkh, tke, dosmagor
use gsw_mod_toolbox, only:  gsw_t_from_ct, gsw_sp_from_sa
use gsw_mod_kinds, only: r8
use pnetcdf_stuff, only: open_file3D_pnetcdf, close_file_pnetcdf, dopnetcdf

implicit none

character(200)filename
character(80) long_name
character(8)  name
character(10) timechar
character(5)  sepchar
character(3)  filetype
character(4)  rankchar
character(10) units
character(9) fileaction

integer i,j,k,n,nfields,nfields1
real(4) tmp(nx,ny,nzm)
logical flag
integer nsteplast


nfields=7 ! number of 3D fields to save
if(doterrain) nfields=nfields+1
if(doshortwave.or.dolongwave) nfields=nfields+1
if(dosgs) nfields=nfields+1
if(dosgs.and..not.dosmagor) nfields=nfields+1

nfields1=0

if(.not.dopnetcdf) then

 if(rank.eq.rank-mod(rank,nsubdomains/nfiles3D)) then

  if(nfiles3D.eq.1) then
     sepchar=""
  else
     write(rankchar,'(i4)') rank/(nsubdomains/nfiles3D)
     sepchar="_"//rankchar(5-lenstr(rankchar):4)
  end if
  write(timechar,'(i10)') nstep
  do k=1,11-lenstr(timechar)-1
    timechar(k:k)='0'
  end do

  filetype = '.3D'

  if(save2Dsep) then
     fileaction = 'WRITE'
     filename='./OUT_3D/'//trim(case)//'_'//trim(caseid)//'_'// &
        trim(date_pr)//'_'//timechar(1:10)//'.OCN'//filetype//sepchar
  else
     fileaction = 'READWRITE'
     filename='./OUT_3D/'//trim(case)//'_'//trim(caseid)//'.OCN'//filetype//sepchar
  end if

  open(46,file=filename,status='unknown', &
          form='unformatted',BUFFEREDYES ACTION=trim(fileaction))
  if(masterproc) print*, 'Writting to file: '//trim(filename)

  if(.not.save3Dsep) then
       if(nfiles3D.gt.1) then
         if(masterproc) print*,'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
         if(masterproc) print*,'save3Dsep requires nfiles3D=1. exit...'
         if(masterproc) print*,'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
         call task_abort()
       end if
       do while(.true.)
        if(masterproc) then
         read(46,end=222)  nsteplast
         if(nsteplast.ge.nstep) then
           backspace(46)
           goto 222   ! yeh, I know, it's bad ....
         end if
         read(46)
         read(46)
         read(46)
         read(46)
         read(46)
         read(46)
        end if
        do i=1,nfields
           read(46)
           read(46) flag
           if(masterproc.and..not.flag) read(46)
           do n=1,nsubdomains
            read(46)
           end do
        end do
       end do
 222   continue

       if(masterproc) print*,'nsteplast=',nsteplast
  end if

  if(masterproc) then

      write(46) nstep, time
      write(46) nx,ny,nzm,nsubdomains,nsubdomains_x,nsubdomains_y,nfields,nfiles3D
      write(46) real(dx,4),real(dy,4)
      write(46) real(dble(nstep)*dt/(3600._8*24._8)+day0,8),datechar
      write(46) dolatlon
      write(46) 'atm'
      write(46) real(z(1:nzm),4),real(pres(1:nzm),4), &
                lat_gl,lon_gl,latv_gl(1:ny_gl), &
                real(dz*adz(1:nzm),4),real(rho(1:nzm),4),real(rhow(1:nzm),4), &
                real(presi(1:nzm),4)

  end if ! masterproc

 end if ! rank....

else

! open netcdf file:

 write(timechar,'(i10)') nstep
 do k=1,11-lenstr(timechar)-1
   timechar(k:k)='0'
 end do

 filename ='./OUT_3D/'//trim(case)//'_'//trim(caseid)//'_'// &
       trim(date_pr)//'_'//timechar(1:10)//'.3D_atm.nc'

 call open_file3D_pnetcdf(filename)

 if(masterproc) print*, 'Writting to file: '//trim(filename)
end if ! .not.dopnetcdf


  nfields1=nfields1+1
  do k=1,nzm
   do j=1,ny
    do i=1,nx
      tmp(i,j,k)=u(i,j,k) 
    end do
   end do
  end do
  name='U'
  long_name='X Wind Component'
  units='m/s'
  call compress3D(tmp,nx,ny,nzm,name,long_name,units, &
                                 save3Dbin,dompi,rank,nsubdomains,nfiles3D,1)

  nfields1=nfields1+1
  do k=1,nzm
   do j=1,ny
    do i=1,nx
      tmp(i,j,k)=v(i,j,k) 
    end do
   end do
  end do
  name='V'
  long_name='Y Wind Component'
  units='m/s'
  call compress3D(tmp,nx,ny,nzm,name,long_name,units, &
                                 save3Dbin,dompi,rank,nsubdomains,nfiles3D,3)

  nfields1=nfields1+1
  do k=1,nzm
   do j=1,ny
    do i=1,nx
      tmp(i,j,k)=w(i,j,k)
    end do
   end do
  end do
  name='W'
  long_name='Z Wind Component'
  units='m/s'
  call compress3D(tmp,nx,ny,nzm,name,long_name,units, &
                                 save3Dbin,dompi,rank,nsubdomains,nfiles3D,2)

  if(dosgs) then
  nfields1=nfields1+1
  do k=1,nzm
   do j=1,ny
    do i=1,nx
      tmp(i,j,k)=tkh(i,j,k)
    end do
   end do
  end do
  name='KZH'
  long_name='eddy diffusivity'
  units='m2/s'
  call compress3D(tmp,nx,ny,nzm,name,long_name,units, &
                                 save3Dbin,dompi,rank,nsubdomains,nfiles3D,1)
  end if


  if(dosgs.and..not.dosmagor) then
   nfields1=nfields1+1
   do k=1,nzm
    do j=1,ny
     do i=1,nx
       tmp(i,j,k)=tke(i,j,k)
     end do
    end do
   end do
   name='TKE'
   long_name='SGS TKE'
   units='m2/s2'
  call compress3D(tmp,nx,ny,nzm,name,long_name,units, &
                                 save3Dbin,dompi,rank,nsubdomains,nfiles3D,1)
  end if


  nfields1=nfields1+1
  do k=1,nzm
   do j=1,ny
    do i=1,nx
      tmp(i,j,k)=p(i,j,k,na)
    end do
   end do
  end do
  name='PP'
  long_name='Pressure Perturbation'
  units='Pa'
  call compress3D(tmp,nx,ny,nzm,name,long_name,units, &
                                 save3Dbin,dompi,rank,nsubdomains,nfiles3D,1)

if(doterrain) then
  nfields1=nfields1+1
  do k=1,nzm
   do j=1,ny
    do i=1,nx
      tmp(i,j,k)=terra(i,j,k)
    end do
   end do
  end do
  name='TERRA'
  long_name='Terrain Mask'
  units=' '
  call compress3D(tmp,nx,ny,nzm,name,long_name,units, &
                                 save3Dbin,dompi,rank,nsubdomains,nfiles3D,1)
end if

  nfields1=nfields1+1
  do k=1,nzm
   do j=1,ny
    do i=1,nx
      tmp(i,j,k) =  s(i,j,k)
    end do
   end do
  end do
  name='SA'
  long_name='Absolute Salinity'
  units=''
  call compress3D(tmp,nx,ny,nzm,name,long_name,units, &
                                 save3Dbin,dompi,rank,nsubdomains,nfiles3D,1)

  nfields1=nfields1+1
  do k=1,nzm
   do j=1,ny
    do i=1,nx
      tmp(i,j,k)=tabs(i,j,k)
    end do
   end do
  end do
  name='T'
  long_name='Temperature'
  units='K'
  call compress3D(tmp,nx,ny,nzm,name,long_name,units, &
                                 save3Dbin,dompi,rank,nsubdomains,nfiles3D,1)

  nfields1=nfields1+1
  do k=1,nzm
   do j=1,ny
    do i=1,nx
      tmp(i,j,k)=rhoo(i,j,k) - 1000.
    end do
   end do
  end do
  name='RHO'
  long_name='Density deviation from 1000 kg/m3'
  units='kg/m3'
  call compress3D(tmp,nx,ny,nzm,name,long_name,units, &
                                 save3Dbin,dompi,rank,nsubdomains,nfiles3D,1)

  if(doshortwave.or.dolongwave) then
  nfields1=nfields1+1
  do k=1,nzm
   do j=1,ny
    do i=1,nx
      tmp(i,j,k)=qrad(i,j,k)*86400.
    end do
   end do
  end do
  name='QRAD'
  long_name='Radiative heating'
  units='K/day'
  call compress3D(tmp,nx,ny,nzm,name,long_name,units, &
                                 save3Dbin,dompi,rank,nsubdomains,nfiles3D,1)
  end if

  call task_barrier()

  if(nfields.ne.nfields1) then
    if(masterproc) print*,'ocn_write_fields3D error: nfields=',nfields,'  nfields1=',nfields1
    call task_abort()
  end if


  if(dopnetcdf) then
     call close_file_pnetcdf()
     dopnetcdf = .false.
  else
   if(masterproc) then
         close(46)
         if(save2Dsep.and.dogzip3D) call systemf('gzip -f '//filename)
   end if
  end if
  if(masterproc) print*, 'Done. ', nfields1,'fields'

 
end
